   /*******************************************************/
   /*      "C" Language Integrated Production System      */
   /*                                                     */
   /*                  A Product Of The                   */
   /*             Software Technology Branch              */
   /*             NASA - Johnson Space Center             */
   /*                                                     */
   /*               CLIPS Version 5.10  07/17/91          */
   /*                                                     */
   /*                                                     */
   /*******************************************************/

/*************************************************************/
/* Purpose:                                                  */
/*                                                           */
/* Principal Programmer(s):                                  */
/*      Brian L. Donnell                                     */
/*                                                           */
/* Contributing Programmer(s):                               */
/*                                                           */
/* Revision History:                                         */
/*                                                           */
/*************************************************************/

#ifndef _H_classcom
#define _H_classcom

#include "object.h"
#include "defins.h"

#ifdef LOCALE
#undef LOCALE
#endif

#ifdef _CLASSCOM_SOURCE_
#define LOCALE
#else
#define LOCALE extern
#endif

#if ANSI_COMPILER
LOCALE VOID SetupObjectSystem(void);
#if RUN_TIME
LOCALE VOID ObjectsRunTimeInitialize(CLASS_TYPE *,DEFINSTANCES *,CLASS_TYPE *[]);
#endif
LOCALE VOID SetupClasses(void);
LOCALE char *GetDefclassName(VOID *);
LOCALE VOID *FindDefclass(char *);
LOCALE VOID *GetNextDefclass(VOID *);
LOCALE int IsDefclassDeletable(VOID *);

LOCALE VOID CmdUndefclass(void);
LOCALE BOOLEAN IsSuperclass(void);
LOCALE BOOLEAN IsSubclass(void);
LOCALE int ClassHasSlot(void);
LOCALE int ClassHasHandler(void);
LOCALE int DoesClassExist(void);
LOCALE int IsClassAbstractCmd(void);
LOCALE VOID ClassSlotsCmd(DATA_OBJECT *);
LOCALE VOID ClassSuperclassesCmd(DATA_OBJECT *);
LOCALE VOID ClassSubclassesCmd(DATA_OBJECT *);
LOCALE VOID ClassHandlersCmd(DATA_OBJECT *);
LOCALE VOID SlotFacetsCmd(DATA_OBJECT *);
LOCALE VOID SlotSourcesCmd(DATA_OBJECT *);

#if DEBUGGING_FUNCTIONS
LOCALE VOID PPDefclass(void);
LOCALE VOID DescribeClassCmd(void);
LOCALE VOID BrowseClassesCmd(void);
LOCALE VOID CmdListDefclasses(void);
LOCALE char *GetDefclassPPForm(VOID *);
LOCALE VOID DescribeClass(VOID *);
LOCALE VOID BrowseClass(VOID *);
LOCALE VOID ListDefclasses(void);
#endif

LOCALE int IsClassAbstract(VOID *);
LOCALE VOID GetClassSlots(VOID *,DATA_OBJECT *,int);
LOCALE VOID GetClassMessageHandlers(VOID *,DATA_OBJECT *,int);
LOCALE VOID GetClassSuperclasses(VOID *,DATA_OBJECT *,int);
LOCALE VOID GetClassSubclasses(VOID *,DATA_OBJECT *,int);
LOCALE VOID GetSlotFacets(VOID *,char *,DATA_OBJECT *);
LOCALE VOID GetSlotSources(VOID *,char *,DATA_OBJECT *);
LOCALE int DeleteDefclass(VOID *);
LOCALE int HasSuperclass(CLASS_TYPE *,CLASS_TYPE *);

#else
LOCALE VOID SetupObjectSystem();
#if RUN_TIME
LOCALE VOID ObjectsRunTimeInitialize();
#endif
LOCALE VOID SetupClasses();
LOCALE char *GetDefclassName();
LOCALE VOID *FindDefclass();
LOCALE VOID *GetNextDefclass();
LOCALE int IsDefclassDeletable();

LOCALE VOID CmdUndefclass();
LOCALE BOOLEAN IsSuperclass();
LOCALE BOOLEAN IsSubclass();
LOCALE int ClassHasSlot();
LOCALE int ClassHasHandler();
LOCALE int DoesClassExist();
LOCALE int IsClassAbstractCmd();
LOCALE VOID ClassSlotsCmd();
LOCALE VOID ClassSuperclassesCmd();
LOCALE VOID ClassSubclassesCmd();
LOCALE VOID ClassHandlersCmd();
LOCALE VOID SlotFacetsCmd();
LOCALE VOID SlotSourcesCmd();

#if DEBUGGING_FUNCTIONS
LOCALE VOID PPDefclass();
LOCALE VOID DescribeClassCmd();
LOCALE VOID BrowseClassesCmd();
LOCALE VOID CmdListDefclasses();
LOCALE char *GetDefclassPPForm();
LOCALE VOID DescribeClass();
LOCALE VOID BrowseClass();
LOCALE VOID ListDefclasses();
#endif

LOCALE int IsClassAbstract();
LOCALE VOID GetClassSlots();
LOCALE VOID GetClassMessageHandlers();
LOCALE VOID GetClassSuperclasses();
LOCALE VOID GetClassSubclasses();
LOCALE VOID GetSlotFacets();
LOCALE VOID GetSlotSources();
LOCALE int DeleteDefclass();
LOCALE int HasSuperclass();
#endif

#endif





