   /*******************************************************/
   /*      "C" Language Integrated Production System      */
   /*                                                     */
   /*                  A Product Of The                   */
   /*             Software Technology Branch              */
   /*             NASA - Johnson Space Center             */
   /*                                                     */
   /*               CLIPS Version 5.10  07/17/91          */
   /*                                                     */
   /*                                                     */
   /*******************************************************/

/*************************************************************/
/* Purpose:                                                  */
/*                                                           */
/* Principal Programmer(s):                                  */
/*      Brian L. Donnell                                     */
/*                                                           */
/* Contributing Programmer(s):                               */
/*                                                           */
/* Revision History:                                         */
/*                                                           */
/*************************************************************/

#ifndef _H_classfun
#define _H_classfun

#include "object.h"

#define CLASS_TABLE_HASH_SIZE 257

#define OBJECT_CLASS_STRING   "OBJECT"
#define USER_CLASS_STRING     "USER"

#ifdef LOCALE
#undef LOCALE
#endif

#ifdef _CLASSFUN_SOURCE_
#define LOCALE
#else
#define LOCALE extern
#endif

#if ANSI_COMPILER
LOCALE VOID SetClassList(CLASS_TYPE *);
LOCALE VOID InstancesPurge(void);

#if ! RUN_TIME
LOCALE VOID InitializeClasses(void);
#endif
LOCALE CLASS_TYPE *FindDefclassBySymbol(SYMBOL_HN *);
LOCALE SLOT_DESC *FindClassSlot(CLASS_TYPE *,SYMBOL_HN *);
LOCALE VOID ClassExistError(char *,char *);
LOCALE VOID DeleteClassLinks(CLASS_LINK *);

#if ! RUN_TIME
LOCALE VOID PutClassInTable(CLASS_TYPE *);
#endif
#if BLOAD || BLOAD_AND_BSAVE
LOCALE VOID ObjectSystemPurge(void);
#endif
#if (! BLOAD_ONLY) && (! RUN_TIME)
LOCALE VOID ReinitializeClasses(void);
LOCALE CLASS_TYPE *NewClass(void);
LOCALE int IsClassBeingUsed(CLASS_TYPE *);
LOCALE int ClearDefclasses(int);
LOCALE int DeleteClassUAG(CLASS_TYPE *);
LOCALE VOID DeleteSlots(SLOT_DESC *);
LOCALE SLOT_DESC *NewSlot(SYMBOL_HN *);
LOCALE SLOT_DESC *InsertSlot(SLOT_DESC *,SLOT_DESC *);
LOCALE VOID PackSlots(CLASS_TYPE *,SLOT_DESC *);
LOCALE CLASS_LINK *FindPrecedenceList(CLASS_TYPE *,CLASS_LINK *);
LOCALE int AddClass(CLASS_TYPE *);
LOCALE int IsSystemClassName(SYMBOL_HN *);
#endif

#else
LOCALE VOID SetClassList();
LOCALE VOID InstancesPurge();

#if ! RUN_TIME
LOCALE VOID InitializeClasses();
#endif
LOCALE CLASS_TYPE *FindDefclassBySymbol();
LOCALE SLOT_DESC *FindClassSlot();
LOCALE VOID ClassExistError();
LOCALE VOID DeleteClassLinks();

#if ! RUN_TIME
LOCALE VOID PutClassInTable();
#endif
#if BLOAD || BLOAD_AND_BSAVE
LOCALE VOID ObjectSystemPurge();
#endif
#if (! BLOAD_ONLY) && (! RUN_TIME)
LOCALE VOID ReinitializeClasses();
LOCALE CLASS_TYPE *NewClass();
LOCALE int IsClassBeingUsed();
LOCALE int ClearDefclasses();
LOCALE int DeleteClassUAG();
LOCALE VOID DeleteSlots();
LOCALE SLOT_DESC *NewSlot();
LOCALE SLOT_DESC *InsertSlot();
LOCALE VOID PackSlots();
LOCALE CLASS_LINK *FindPrecedenceList();
LOCALE int AddClass();
LOCALE int IsSystemClassName();
#endif

#endif

#ifndef _CLASSFUN_SOURCE_
extern CLASS_TYPE *ClassList,**ClassTable;
extern CLASS_TYPE *PrimitiveClassMap[];
#endif

#endif









