   /*******************************************************/
   /*      "C" Language Integrated Production System      */
   /*                                                     */
   /*                  A Product Of The                   */
   /*             Software Technology Branch              */
   /*             NASA - Johnson Space Center             */
   /*                                                     */
   /*             CLIPS Version 5.10  07/17/91            */
   /*                                                     */
   /*                DEFFACTS HEADER FILE                 */
   /*******************************************************/

/*************************************************************/
/* Purpose:                                                  */
/*                                                           */
/* Principal Programmer(s):                                  */
/*      Gary D. Riley                                        */
/*                                                           */
/* Contributing Programmer(s):                               */
/*                                                           */
/* Revision History:                                         */
/*                                                           */
/*************************************************************/

#ifndef _H_deffacts
#define _H_deffacts

#include "symbol.h"
#include "expressn.h"

struct deffacts
  {
   struct symbolHashNode *name;
   char *pp_form;
   struct expr *alist;                
   struct deffacts *next; 
  };

#ifdef LOCALE
#undef LOCALE
#endif

#ifdef _DEFFACTS_SOURCE_
#define LOCALE
#else
#define LOCALE extern
#endif

#if ANSI_COMPILER
   LOCALE VOID                           InitializeDeffacts(void);
   LOCALE VOID                           RemoveAllDeffacts(void);
   LOCALE BOOLEAN                        DeleteDeffacts(VOID *);
   LOCALE VOID                          *FindDeffacts(char *);
   LOCALE VOID                           SetListOfDeffacts(VOID *);
   LOCALE VOID                          *GetNextDeffacts(VOID *);
   LOCALE char                          *GetDeffactsName(VOID *);
   LOCALE char                          *GetDeffactsPPForm(VOID *);
   LOCALE int                            PPDeffacts(char *,char *);
   LOCALE VOID                           ListDeffacts(void);
   LOCALE VOID                           CreateInitialFactDeffacts(void);
   LOCALE BOOLEAN                        IsDeffactsDeletable(VOID *);
   LOCALE BOOLEAN                        DeleteNamedDeffacts(char *);
#else
   LOCALE VOID                           InitializeDeffacts();
   LOCALE VOID                           RemoveAllDeffacts();
   LOCALE BOOLEAN                        DeleteDeffacts();
   LOCALE VOID                          *FindDeffacts();
   LOCALE VOID                           SetListOfDeffacts();
   LOCALE VOID                          *GetNextDeffacts();
   LOCALE char                          *GetDeffactsName();
   LOCALE char                          *GetDeffactsPPForm();
   LOCALE int                            PPDeffacts();
   LOCALE VOID                           ListDeffacts();
   LOCALE VOID                           CreateInitialFactDeffacts();
   LOCALE BOOLEAN                        IsDeffactsDeletable();
   LOCALE BOOLEAN                        DeleteNamedDeffacts();
#endif

#endif



