   /*******************************************************/
   /*      "C" Language Integrated Production System      */
   /*                                                     */
   /*                  A Product Of The                   */
   /*             Software Technology Branch              */
   /*             NASA - Johnson Space Center             */
   /*                                                     */
   /*             CLIPS Version 5.10  07/17/91            */
   /*                                                     */
   /*               DEFGLOBAL HEADER FILE                 */
   /*******************************************************/

/*************************************************************/
/* Purpose:                                                  */
/*                                                           */
/* Principal Programmer(s):                                  */
/*      Gary D. Riley                                        */
/*                                                           */
/* Contributing Programmer(s):                               */
/*                                                           */
/* Revision History:                                         */
/*                                                           */
/*************************************************************/

#ifndef _H_defglobl

#define _H_defglobl

#ifdef _DEFGLOBL_SOURCE_

struct defglobal;
struct defglobalPtr;
#endif

#include "symbol.h"
#include "expressn.h"
#include "evaluatn.h"

#ifdef LOCALE
#undef LOCALE
#endif
#ifdef _DEFGLOBL_SOURCE_
#define LOCALE
#else
#define LOCALE extern
#endif

#define GLOBALPTR VOID *

struct defglobal
  {
   struct symbolHashNode *name;
   DATA_OBJECT current;
   struct expr *initial;
  };
  
struct defglobalPtr
  {
   int location;
   struct defglobalPtr *next;
  };

#if ANSI_COMPILER
   LOCALE VOID                    InitializeDefglobal(void);
   LOCALE VOID                   *FindDefglobal(char *);
   LOCALE int                     QFindDefglobal(struct symbolHashNode *);
   LOCALE VOID                    ListDefglobals(void);
   LOCALE BOOLEAN                 GetDefglobalValue(char *,struct dataObject *);
   LOCALE BOOLEAN                 SetDefglobalValue(char *,struct dataObject *);
   LOCALE VOID                    QSetDefglobalValue(int,struct dataObject *);
   LOCALE VOID                    QGetDefglobalValue(int,struct dataObject *);
   LOCALE VOID                    GlobalRtnUnknown(struct dataObject *);
   LOCALE BOOLEAN                 ReplaceGlobalVariable(struct expr *);
   LOCALE GLOBALPTR               GetNextDefglobal(GLOBALPTR);
   LOCALE GLOBALPTR               GetActualDefglobal(GLOBALPTR);
   LOCALE GLOBALPTR               GetIndexedDefglobal(int);
   LOCALE int                     GetNumberOfDefglobals(void);
   LOCALE VOID                    SetListOfDefglobals(void *,void *,int);
   LOCALE VOID                    ResetDefglobals(void);
   LOCALE VOID                    ClearDefglobals(void);
   LOCALE int                     SetResetGlobals(int);
   LOCALE int                     GetResetGlobals(void);
   LOCALE int                     GetGlobalsChanged(void);
   LOCALE VOID                    SetGlobalsChanged(int);
   LOCALE VOID                    GetDefglobalValueForm(char *,int,VOID *);
   LOCALE VOID                    GetDefglobalPPForm(char *,int,VOID *);
   LOCALE char                   *GetDefglobalName(GLOBALPTR);
#else
   LOCALE VOID                    InitializeDefglobal();
   LOCALE VOID                   *FindDefglobal();
   LOCALE int                     QFindDefglobal();
   LOCALE VOID                    ListDefglobals();
   LOCALE BOOLEAN                 GetDefglobalValue();
   LOCALE BOOLEAN                 SetDefglobalValue();
   LOCALE VOID                    QSetDefglobalValue();
   LOCALE VOID                    QGetDefglobalValue();
   LOCALE VOID                    GlobalRtnUnknown();
   LOCALE BOOLEAN                 ReplaceGlobalVariable();
   LOCALE GLOBALPTR               GetNextDefglobal();
   LOCALE GLOBALPTR               GetActualDefglobal();
   LOCALE GLOBALPTR               GetIndexedDefglobal();
   LOCALE int                     GetNumberOfDefglobals();
   LOCALE VOID                    SetListOfDefglobals();
   LOCALE VOID                    ResetDefglobals();
   LOCALE VOID                    ClearDefglobals();
   LOCALE int                     SetResetGlobals();
   LOCALE int                     GetResetGlobals();
   LOCALE int                     GetGlobalsChanged();
   LOCALE VOID                    SetGlobalsChanged();
   LOCALE VOID                    GetDefglobalValueForm();
   LOCALE VOID                    GetDefglobalPPForm();
   LOCALE char                   *GetDefglobalName();
#endif

#ifndef _DEFGLOBL_SOURCE_
   extern int                     ChangeToGlobals;
#endif

#endif







