   /*******************************************************/
   /*      "C" Language Integrated Production System      */
   /*                                                     */
   /*                  A Product Of The                   */
   /*             Software Technology Branch              */
   /*             NASA - Johnson Space Center             */
   /*                                                     */
   /*             CLIPS Version 5.10  07/17/91            */
   /*                                                     */
   /*          DEFTEMPLATE FUNCTION HEADER FILE           */
   /*******************************************************/

/*************************************************************/
/* Purpose:                                                  */
/*                                                           */
/* Principal Programmer(s):                                  */
/*      Gary D. Riley                                        */
/*                                                           */
/* Contributing Programmer(s):                               */
/*                                                           */
/* Revision History:                                         */
/*                                                           */
/*************************************************************/

#ifndef _H_deftmfun

#define _H_deftmfun

#include "symbol.h"
#include "scanner.h"
#include "expressn.h"
#include "facts.h"

#ifdef LOCALE
#undef LOCALE
#endif

#ifdef _DEFTMFUN_SOURCE_
#define LOCALE
#else
#define LOCALE extern
#endif

#if ANSI_COMPILER
   LOCALE struct expr                   *ParseAssertTemplate(char *,struct token *,int *,int *,struct symbolHashNode *,int,int);
   LOCALE BOOLEAN                        UpdateModifyDuplicate(struct expr *,char *);
   LOCALE struct expr                   *ModifyParse(struct expr *,char *);
   LOCALE struct expr                   *DuplicateParse(struct expr *,char *);
   LOCALE VOID                           CheckTemplateFact(struct fact *);
   LOCALE int                            GetMultiSlotPosition(struct symbolHashNode *);
   LOCALE VOID                           MultiIntoSingleFieldSlotError(int,struct symbolHashNode *);
#else
   LOCALE struct expr                   *ParseAssertTemplate();
   LOCALE BOOLEAN                        UpdateModifyDuplicate();
   LOCALE struct expr                   *ModifyParse();
   LOCALE struct expr                   *DuplicateParse();
   LOCALE VOID                           CheckTemplateFact();
   LOCALE int                            GetMultiSlotPosition();
   LOCALE VOID                           MultiIntoSingleFieldSlotError();
#endif

#endif









