   /*******************************************************/
   /*      "C" Language Integrated Production System      */
   /*                                                     */
   /*                  A Product Of The                   */
   /*             Software Technology Branch              */
   /*             NASA - Johnson Space Center             */
   /*                                                     */
   /*             CLIPS Version 5.10  07/17/91            */
   /*                                                     */
   /*                  DRIVE HEADER FILE                  */
   /*******************************************************/

/*************************************************************/
/* Purpose:                                                  */
/*                                                           */
/* Principal Programmer(s):                                  */
/*      Gary D. Riley                                        */
/*                                                           */
/* Contributing Programmer(s):                               */
/*                                                           */
/* Revision History:                                         */
/*                                                           */
/*************************************************************/

#ifndef _H_drive

#define _H_drive

#include "expressn.h"
#include "match.h"
#include "network.h"

#ifdef LOCALE
#undef LOCALE
#endif

#ifdef _DRIVE_SOURCE_
#define LOCALE
#else
#define LOCALE extern
#endif

#if ANSI_COMPILER
   VOID                           Drive(struct partialMatch *,struct joinNode *,int,int);
   VOID                           PNLDrive(struct joinNode *,struct partialMatch *);
   BOOLEAN                        EvaluateJoinExpression(struct expr *,struct partialMatch *,struct partialMatch *,struct joinNode *);
   BOOLEAN                        GetIncrementalReset(void);
   BOOLEAN                        SetIncrementalReset(BOOLEAN);
   VOID                           ClearLowerBetaMemory(struct joinNode *);
#else
   VOID                           Drive();
   VOID                           PNLDrive();
   BOOLEAN                        EvaluateJoinExpression();
   BOOLEAN                        GetIncrementalReset();
   BOOLEAN                        SetIncrementalReset();
   VOID                           ClearLowerBetaMemory();
#endif

#ifndef _DRIVE_SOURCE_
   extern int                     IncrementalResetFlag;
#endif

#endif





