   /*******************************************************/
   /*      "C" Language Integrated Production System      */
   /*                                                     */
   /*                  A Product Of The                   */
   /*             Software Technology Branch              */
   /*             NASA - Johnson Space Center             */
   /*                                                     */
   /*               CLIPS Version 5.10  07/17/91          */
   /*                                                     */
   /*                                                     */
   /*******************************************************/

/*************************************************************/
/* Purpose      External Function Definitions for COOL       */
/*                                                           */
/* Principal Programmer(s):                                  */
/*      Brian L. Donnell                                     */
/*                                                           */
/* Contributing Programmer(s):                               */
/*                                                           */
/* Revision History:                                         */
/*                                                           */
/*************************************************************/

#ifndef _H_extobj
#define _H_extobj
   
#if ANSI_COMPILER

extern VOID SetupObjectSystem(void);

extern VOID IncrementInstanceCount(VOID *);
extern VOID DecrementInstanceCount(VOID *);
extern VOID IncrementInstanceDepth(VOID *);
extern VOID DecrementInstanceDepth(VOID *);
extern int GetInstancesChanged(void);
extern VOID SetInstancesChanged(int);

extern char *GetDefclassName(VOID *);
extern VOID *GetNextDefclass(VOID *);
extern VOID *FindDefclass(char *);
extern int IsDefclassDeletable(VOID *);
extern int DeleteDefclass(VOID *);

extern char *GetDefinstancesName(VOID *);
extern VOID *GetNextDefinstances(VOID *);
extern VOID *FindDefinstances(char *);
extern int IsDefinstancesDeletable(VOID *);
extern int DeleteDefinstances(VOID *);

extern int SaveInstances(char *);
extern int LoadInstances(char *);
extern VOID *CLIPSMakeInstance(char *);
extern int CLIPSDeleteInstance(VOID *);
extern int CLIPSUnmakeInstance(VOID *);
extern VOID *CreateRawInstance(VOID *,char *);
extern VOID *FindInstance(char *);
extern int ValidInstanceAddress(VOID *);
extern int CLIPSTestSlot(VOID *,char *,int);
extern VOID CLIPSGetSlot(VOID *,char *,DATA_OBJECT *);
extern int CLIPSPutSlot(VOID *,char *,DATA_OBJECT *);
extern char *GetInstanceName(VOID *);
extern VOID *GetInstanceClass(VOID *);
extern VOID *GetNextInstance(VOID *);
extern VOID *GetNextInstanceInClass(VOID *,VOID *);
extern VOID GetInstancePPForm(char *,int,VOID *);

extern char *GetDefmessageHandlerName(VOID *,unsigned);
extern char *GetDefmessageHandlerType(VOID *,unsigned);
extern unsigned GetNextDefmessageHandler(VOID *,unsigned);
extern unsigned FindDefmessageHandler(VOID *,char *,char *);
extern int IsDefmessageHandlerDeletable(VOID *,unsigned);
extern int DeleteDefmessageHandler(VOID *,unsigned);
extern int WildDeleteHandler(VOID *,char *,char *);
extern VOID CLIPSSendMessage(DATA_OBJECT *,char *,char *,DATA_OBJECT *);

#if DEBUGGING_FUNCTIONS

extern VOID DescribeClass(VOID *);
extern VOID BrowseClass(VOID *);

extern char *GetDefclassPPForm(VOID *);
extern char *GetDefinstancesPPForm(VOID *);
extern char *GetDefmessageHandlerPPForm(VOID *,unsigned);

extern VOID ListDefclasses(void);
extern VOID ListDefinstances(void);
extern VOID ListInstances(VOID *,int);
extern VOID ListDefmessageHandlers(char *,char *,char *);

LOCALE VOID PreviewMessage(VOID *,char *);

#endif

LOCALE int IsClassAbstract(VOID *);
LOCALE VOID GetClassSlots(VOID *,DATA_OBJECT *,int);
LOCALE VOID GetClassMessageHandlers(VOID *,DATA_OBJECT *,int);
LOCALE VOID GetClassSuperclasses(VOID *,DATA_OBJECT *,int);
LOCALE VOID GetClassSubclasses(VOID *,DATA_OBJECT *,int);
LOCALE VOID GetSlotFacets(VOID *,char *,DATA_OBJECT *);
LOCALE VOID GetSlotSources(VOID *,char *,DATA_OBJECT *);

#else

extern VOID SetupObjectSystem();

extern VOID IncrementInstanceCount();
extern VOID DecrementInstanceCount();
extern VOID IncrementInstanceDepth();
extern VOID DecrementInstanceDepth();
extern int GetInstancesChanged();
extern VOID SetInstancesChanged();

extern char *GetDefclassName();
extern VOID *GetNextDefclass();
extern VOID *FindDefclass();
extern int IsDefclassDeletable();
extern int DeleteDefclass();

extern char *GetDefinstancesName();
extern VOID *GetNextDefinstances();
extern VOID *FindDefinstances();
extern int IsDefinstancesDeletable();
extern int DeleteDefinstances();

extern int SaveInstances();
extern int LoadInstances();
extern VOID *CLIPSMakeInstance();
extern int CLIPSDeleteInstance();
extern int CLIPSUnmakeInstance();
extern VOID *CreateRawInstance();
extern VOID *FindInstance();
extern int ValidInstanceAddress();
extern int CLIPSTestSlot();
extern VOID CLIPSGetSlot();
extern int CLIPSPutSlot();
extern char *GetInstanceName();
extern VOID *GetInstanceClass();
extern VOID *GetNextInstance();
extern VOID *GetNextInstanceInClass();
extern VOID GetInstancePPForm();

extern char *GetDefmessageHandlerName();
extern char *GetDefmessageHandlerType();
extern unsigned GetNextDefmessageHandler();
extern unsigned FindDefmessageHandler();
extern int IsDefmessageHandlerDeletable();
extern int DeleteDefmessageHandler();
extern int WildDeleteHandler();
extern VOID CLIPSSendMessage();

#if DEBUGGING_FUNCTIONS

extern VOID DescribeClass();
extern VOID BrowseClass();

extern char *GetDefclassPPForm();
extern char *GetDefinstancesPPForm();
extern char *GetDefmessageHandlerPPForm();

extern VOID ListDefclasses();
extern VOID ListDefinstances();
extern VOID ListInstances();
extern VOID ListDefmessageHandlers();

LOCALE VOID PreviewMessage();

#endif

LOCALE int IsClassAbstract();
LOCALE VOID GetClassSlots();
LOCALE VOID GetClassMessageHandlers();
LOCALE VOID GetClassSuperclasses();
LOCALE VOID GetClassSubclasses();
LOCALE VOID GetSlotFacets();
LOCALE VOID GetSlotSources();

#endif

extern int ChangesToInstances;

#endif



