   /*******************************************************/
   /*      "C" Language Integrated Production System      */
   /*                                                     */
   /*                  A Product Of The                   */
   /*             Software Technology Branch              */
   /*             NASA - Johnson Space Center             */
   /*                                                     */
   /*               CLIPS Version 5.10  07/17/91          */
   /*                                                     */
   /*                                                     */
   /*******************************************************/

/*************************************************************/
/* Purpose:                                                  */
/*                                                           */
/* Principal Programmer(s):                                  */
/*      Brian L. Donnell                                     */
/*                                                           */
/* Contributing Programmer(s):                               */
/*                                                           */
/* Revision History:                                         */
/*                                                           */
/*************************************************************/

#ifndef _H_inscom
#define _H_inscom

#include "object.h"

#ifdef LOCALE
#undef LOCALE
#endif

#ifdef _INSCOM_SOURCE_
#define LOCALE
#else
#define LOCALE extern
#endif

#if ANSI_COMPILER
LOCALE VOID SetupInstances(void);
LOCALE VOID DestroyAllInstances(void);
LOCALE int CLIPSDeleteInstance(VOID *);
LOCALE int CLIPSUnmakeInstance(VOID *);
#if DEBUGGING_FUNCTIONS
LOCALE VOID CmdListInstances(void);
LOCALE VOID PPInstance(void);
LOCALE VOID ListInstances(VOID *,int);
#endif
LOCALE int SaveInstances(char *);
LOCALE int LoadInstances(char *);
LOCALE VOID *CLIPSMakeInstance(char *);
LOCALE VOID *CreateRawInstance(VOID *,char *);
LOCALE VOID *FindInstance(char *);
LOCALE int ValidInstanceAddress(VOID *);
LOCALE int CLIPSTestSlot(VOID *,char *,int);
LOCALE VOID CLIPSGetSlot(VOID *,char *,DATA_OBJECT *);
LOCALE int CLIPSPutSlot(VOID *,char *,DATA_OBJECT *);
LOCALE char *GetInstanceName(VOID *);
LOCALE VOID *GetInstanceClass(VOID *);
LOCALE VOID *GetNextInstance(VOID *);
LOCALE VOID *GetNextInstanceInClass(VOID *,VOID *);
LOCALE VOID GetInstancePPForm(char *,int,VOID *);
LOCALE VOID GetInstanceClassCmd(DATA_OBJECT *);
#if ! RUN_TIME
LOCALE EXPRESSION *ParseInitializeInstance(EXPRESSION *,char *);
#endif
LOCALE VOID DeleteInstance(void);
LOCALE VOID UnmakeInstance(void);
LOCALE VOID SaveInstancesCommand(void);
LOCALE VOID LoadInstancesCommand(void);
LOCALE VOID SymbolToInstanceName(DATA_OBJECT *);
LOCALE VOID InstanceNameToSymbol(DATA_OBJECT *);
LOCALE VOID GetInstanceAddressCmd(DATA_OBJECT *);
LOCALE VOID GetInstanceNameCmd(DATA_OBJECT *);
LOCALE BOOLEAN IsInstanceAddress(void);
LOCALE BOOLEAN IsInstanceName(void);
LOCALE BOOLEAN IsInstance(void);
LOCALE int DoesInstanceExist(void);
LOCALE BOOLEAN DoesSlotExist(void);
LOCALE BOOLEAN IsSlotBound(void);
LOCALE BOOLEAN IsSlotWritable(void);
LOCALE BOOLEAN IsSlotInitable(void);
LOCALE VOID MultifieldSlotReplace(DATA_OBJECT *);
LOCALE VOID MultifieldSlotInsert(DATA_OBJECT *);
LOCALE VOID MultifieldSlotDelete(DATA_OBJECT *);
#else
LOCALE VOID SetupInstances();
LOCALE VOID DestroyAllInstances();
LOCALE int CLIPSDeleteInstance();
LOCALE int CLIPSUnmakeInstance();
#if DEBUGGING_FUNCTIONS
LOCALE VOID CmdListInstances();
LOCALE VOID PPInstance();
LOCALE VOID ListInstances();
#endif
LOCALE int SaveInstances();
LOCALE int LoadInstances();
LOCALE VOID *CLIPSMakeInstance();
LOCALE VOID *CreateRawInstance();
LOCALE VOID *FindInstance();
LOCALE int ValidInstanceAddress();
LOCALE int CLIPSTestSlot();
LOCALE VOID CLIPSGetSlot();
LOCALE int CLIPSPutSlot();
LOCALE char *GetInstanceName();
LOCALE VOID *GetInstanceClass();
LOCALE VOID *GetNextInstance();
LOCALE VOID *GetNextInstanceInClass();
LOCALE VOID GetInstancePPForm();
LOCALE VOID GetInstanceClassCmd();
#if ! RUN_TIME
LOCALE EXPRESSION *ParseInitializeInstance();
#endif
LOCALE VOID DeleteInstance();
LOCALE VOID UnmakeInstance();
LOCALE VOID SaveInstancesCommand();
LOCALE VOID LoadInstancesCommand();
LOCALE VOID SymbolToInstanceName();
LOCALE VOID InstanceNameToSymbol();
LOCALE VOID GetInstanceAddressCmd();
LOCALE VOID GetInstanceNameCmd();
LOCALE BOOLEAN IsInstanceAddress();
LOCALE BOOLEAN IsInstanceName();
LOCALE BOOLEAN IsInstance();
LOCALE int DoesInstanceExist();
LOCALE BOOLEAN DoesSlotExist();
LOCALE BOOLEAN IsSlotBound();
LOCALE BOOLEAN IsSlotWritable();
LOCALE BOOLEAN IsSlotInitable();
LOCALE VOID MultifieldSlotReplace();
LOCALE VOID MultifieldSlotInsert();
LOCALE VOID MultifieldSlotDelete();
#endif

#endif





