   /*******************************************************/
   /*      "C" Language Integrated Production System      */
   /*                                                     */
   /*                  A Product Of The                   */
   /*             Software Technology Branch              */
   /*             NASA - Johnson Space Center             */
   /*                                                     */
   /*               CLIPS Version 5.10  07/17/91          */
   /*                                                     */
   /*                                                     */
   /*******************************************************/

/*************************************************************/
/* Purpose:                                                  */
/*                                                           */
/* Principal Programmer(s):                                  */
/*      Brian L. Donnell                                     */
/*                                                           */
/* Contributing Programmer(s):                               */
/*                                                           */
/* Revision History:                                         */
/*                                                           */
/*************************************************************/

#ifndef _H_insfun
#define _H_insfun

#include "object.h"

#define INSTANCE_TABLE_HASH_SIZE 683

#define MULTI_CLEAR    1
#define MULTI_SET      2

#define INSERT         0
#define REPLACE        1
#define DELETE         2

#define SLOT_ERROR    -1
#define SLOT_EMPTY     0
#define SLOT_FILLED    1

#ifdef LOCALE
#undef LOCALE
#endif

#ifdef _INSFUN_SOURCE_
#define LOCALE
#else
#define LOCALE extern
#endif

#if ANSI_COMPILER
LOCALE VOID IncrementInstanceCount(VOID *);
LOCALE VOID DecrementInstanceCount(VOID *);
LOCALE VOID DecrementInstanceDepth(VOID *);
LOCALE VOID InitializeInstanceTable(void);
LOCALE VOID CleanupInstances(void);
LOCALE VOID InitializeInstance(DATA_OBJECT *);
LOCALE VOID MakeInstance(DATA_OBJECT *);
LOCALE INSTANCE_TYPE *BuildInstance(SYMBOL_HN *,SYMBOL_HN *);
LOCALE int CoreInitializeInstance(INSTANCE_TYPE *,EXPRESSION *);
LOCALE int QuashInstance(INSTANCE_TYPE *);
LOCALE INSTANCE_TYPE *FindInstanceBySymbol(SYMBOL_HN *);
LOCALE INSTANCE_SLOT *FindInstanceSlot(INSTANCE_TYPE *,SYMBOL_HN *);
LOCALE int FindInstanceTemplateSlot(CLASS_TYPE *,SYMBOL_HN *);
LOCALE int EvaluateAndStoreInDataObject(int,EXPRESSION *,DATA_OBJECT *);
LOCALE EXPRESSION *SlotValueExpression(DATA_OBJECT *);
LOCALE int PutSlotValue(INSTANCE_TYPE *,INSTANCE_SLOT *,DATA_OBJECT *,int);
LOCALE VOID EvaluateInstanceSlots(DATA_OBJECT *);
LOCALE int ValidSlotValue(DATA_OBJECT *,char *);
LOCALE INSTANCE_SLOT *CheckMultifieldSlotModify(int,char *,INSTANCE_TYPE *,
                                       EXPRESSION *,int *,int *,DATA_OBJECT *);
LOCALE VOID NoInstanceError(char *,char *);
LOCALE VOID SlotExistError(char *,char *);
LOCALE VOID StaleInstanceAddress(char *);
LOCALE int GetInstancesChanged(void);
LOCALE VOID SetInstancesChanged(int);
#else
LOCALE VOID IncrementInstanceCount();
LOCALE VOID DecrementInstanceCount();
LOCALE VOID DecrementInstanceDepth();
LOCALE VOID InitializeInstanceTable();
LOCALE VOID CleanupInstances();
LOCALE VOID InitializeInstance();
LOCALE VOID MakeInstance();
LOCALE INSTANCE_TYPE *BuildInstance();
LOCALE int CoreInitializeInstance();
LOCALE int QuashInstance();
LOCALE INSTANCE_TYPE *FindInstanceBySymbol();
LOCALE INSTANCE_SLOT *FindInstanceSlot();
LOCALE int FindInstanceTemplateSlot();
LOCALE int EvaluateAndStoreInDataObject();
LOCALE EXPRESSION *SlotValueExpression();
LOCALE int PutSlotValue();
LOCALE VOID EvaluateInstanceSlots();
LOCALE int ValidSlotValue();
LOCALE INSTANCE_SLOT *CheckMultifieldSlotModify();
LOCALE VOID NoInstanceError();
LOCALE VOID SlotExistError();
LOCALE VOID StaleInstanceAddress();
LOCALE int GetInstancesChanged();
LOCALE VOID SetInstancesChanged();
#endif

#ifndef _INSFUN_SOURCE_
extern INSTANCE_TYPE *InstanceList;
#if DEBUGGING_FUNCTIONS
extern int WatchInstances,WatchSlots;
#endif
extern int WithinInit;
extern int MaintainGarbageInstances;
extern int OverrideSlotProtection;
extern int ChangesToInstances;
#endif

#endif







