   /*******************************************************/
   /*      "C" Language Integrated Production System      */
   /*                                                     */
   /*                  A Product Of The                   */
   /*             Software Technology Branch              */
   /*             NASA - Johnson Space Center             */
   /*                                                     */
   /*             CLIPS Version 5.10 07/17/91             */
   /*                                                     */
   /*             INTERFACE FILE HEADER FILE              */
   /*******************************************************/

/*************************************************************/
/* Purpose:                                                  */
/*                                                           */
/* Principal Programmer(s):                                  */
/*      Gary D. Riley                                        */
/*                                                           */
/* Contributing Programmer(s):                               */
/*                                                           */
/* Revision History:                                         */
/*                                                           */
/*************************************************************/

#ifndef _H_intrfile

#define _H_intrfile

#ifdef LOCALE
#undef LOCALE
#endif

#ifdef _INTRFILE_SOURCE_
#define LOCALE
#else
#define LOCALE extern
#endif

#if ANSI_COMPILER
   VOID                           FileFunctionDefinitions(void);
   BOOLEAN                        OpenDribble(char *);
   BOOLEAN                        DribbleActive(void);
   BOOLEAN                        CloseDribble(void);
   VOID                           SetDribbleStatusFunction(int (*)());
   int                            LLGetcBatch(char *,int);
   int                            OpenBatch(char *,int);
   int                            OpenStringBatch(char *,char *,int);
   int                            RemoveBatch(void);
   BOOLEAN                        BatchActive(void);
   VOID                           CloseAllBatchSources(void);
   BOOLEAN                        OpenCRSVTrace(char *);
   BOOLEAN                        CRSVTraceActive(void);
   int                            CloseCRSVTrace(void);
#else
   VOID                           FileFunctionDefinitions();
   BOOLEAN                        OpenDribble();
   BOOLEAN                        DribbleActive();
   BOOLEAN                        CloseDribble();
   VOID                           SetDribbleStatusFunction();
   int                            LLGetcBatch();
   int                            OpenBatch();
   int                            OpenStringBatch();
   int                            RemoveBatch();
   BOOLEAN                        BatchActive();
   VOID                           CloseAllBatchSources();
   BOOLEAN                        OpenCRSVTrace();
   BOOLEAN                        CRSVTraceActive();
   int                            CloseCRSVTrace();
#endif

#endif






