   /*******************************************************/
   /*      "C" Language Integrated Production System      */
   /*                                                     */
   /*                  A Product Of The                   */
   /*             Software Technology Branch              */
   /*             NASA - Johnson Space Center             */
   /*                                                     */
   /*             CLIPS Version 5.10  07/17/91            */
   /*                                                     */
   /*          LOGICAL DEPENDENCIES HEADER FILE           */
   /*******************************************************/

/*************************************************************/
/* Purpose:                                                  */
/*                                                           */
/* Principal Programmer(s):                                  */
/*      Gary D. Riley                                        */
/*                                                           */
/* Contributing Programmer(s):                               */
/*                                                           */
/* Revision History:                                         */
/*                                                           */
/*************************************************************/

#ifndef _H_lgcldpnd

#define _H_lgcldpnd

#include "facts.h"
#include "match.h"

struct dependency
  {
   VOID *dPtr;
   struct dependency *next;
  };
  
#ifdef LOCALE
#undef LOCALE
#endif
#ifdef _LGCLDPND_SOURCE_
#define LOCALE
#else
#define LOCALE extern
#endif

#if ANSI_COMPILER
   LOCALE BOOLEAN                        AddLogicalDependencies(struct fact *,int);
   LOCALE VOID                           RemoveFactDependencies(struct fact *);
   LOCALE VOID                           RemovePMDependencies(struct partialMatch *);
   LOCALE VOID                           AddToDependencyList(struct partialMatch *);
   LOCALE struct fact                   *GetNextLogicalRetraction(void);
   LOCALE VOID                           ForceLogicalRetractions(void);
   LOCALE VOID                           ListDependencies(struct fact *);
   LOCALE VOID                           ListDependents(struct fact *);
#else
   LOCALE BOOLEAN                        AddLogicalDependencies();
   LOCALE VOID                           RemoveFactDependencies();
   LOCALE VOID                           RemovePMDependencies();
   LOCALE VOID                           AddToDependencyList();
   LOCALE struct fact                   *GetNextLogicalRetraction();
   LOCALE VOID                           ForceLogicalRetractions();
   LOCALE VOID                           ListDependencies();
   LOCALE VOID                           ListDependents();
#endif

#endif





