   /*******************************************************/
   /*      "C" Language Integrated Production System      */
   /*                                                     */
   /*                  A Product Of The                   */
   /*             Software Technology Branch              */
   /*             NASA - Johnson Space Center             */
   /*                                                     */
   /*             CLIPS Version 5.10  07/17/91            */
   /*                                                     */
   /*              RETE UTILITY HEADER FILE               */
   /*******************************************************/

/*************************************************************/
/* Purpose:                                                  */
/*                                                           */
/* Principal Programmer(s):                                  */
/*      Gary D. Riley                                        */
/*                                                           */
/* Contributing Programmer(s):                               */
/*                                                           */
/* Revision History:                                         */
/*                                                           */
/*************************************************************/

#ifndef _H_reteutil
#define _H_reteutil

#include "evaluatn.h"
#include "facts.h"
#include "match.h"
#include "network.h"

#ifdef LOCALE
#undef LOCALE
#endif

#ifdef _RETEUTIL_SOURCE_
#define LOCALE
#else
#define LOCALE extern
#endif

#if ANSI_COMPILER  
LOCALE VOID                           PrintPartialMatch(char *,struct partialMatch *);
LOCALE struct partialMatch           *CopyPartialMatch(struct partialMatch *);
LOCALE struct partialMatch           *MergePartialMatches(struct partialMatch *,struct partialMatch *);
LOCALE struct partialMatch           *AddSingleMatch(struct partialMatch *,struct alphaMatch *);
LOCALE int                            FindFactInPartialMatch(long,struct partialMatch *);
LOCALE VOID                           SetPseudoFactIndex(long);
LOCALE BOOLEAN                        GetNumericArgument(struct expr *,char *,struct dataObject *,BOOLEAN,int);
LOCALE int                            AdjustFieldPosition(struct multifieldMarker *,int,int *);
LOCALE VOID                           SetPseudoFactIndex(long int);
LOCALE struct partialMatch           *NewPseudoFactPartialMatch(void);
LOCALE long int                       IncrementPseudoFactIndex(void);
LOCALE VOID                           ResetNotedPatterns(struct patternNode *);
LOCALE VOID                           ResetNotedJoin(struct joinNode *);
LOCALE VOID                           FlushAlphaBetaMemory(struct partialMatch *);
LOCALE VOID                           PrimeJoin(struct joinNode *);
LOCALE VOID                           ClearPatternMatches(struct patternNode *);
LOCALE VOID                           MarkRuleNetwork(int);
LOCALE VOID                           TagRuleNetwork(unsigned long *,unsigned long *);
LOCALE VOID                           ResetDeployedRuleImage(void);
#else   
LOCALE VOID                           PrintPartialMatch();
LOCALE struct partialMatch           *CopyPartialMatch();
LOCALE struct partialMatch           *MergePartialMatches();
LOCALE struct partialMatch           *AddSingleMatch();
LOCALE int                            FindFactInPartialMatch();
LOCALE VOID                           SetPseudoFactIndex();
LOCALE BOOLEAN                        GetNumericArgument();
LOCALE int                            AdjustFieldPosition();
LOCALE VOID                           SetPseudoFactIndex();
LOCALE struct partialMatch           *NewPseudoFactPartialMatch();
LOCALE long int                       IncrementPseudoFactIndex();
LOCALE VOID                           ResetNotedPatterns();
LOCALE VOID                           ResetNotedJoin();
LOCALE VOID                           FlushAlphaBetaMemory();
LOCALE VOID                           PrimeJoin();
LOCALE VOID                           ClearPatternMatches();
LOCALE VOID                           MarkRuleNetwork();
LOCALE VOID                           TagRuleNetwork();
LOCALE VOID                           ResetDeployedRuleImage();
#endif 

#ifndef _RETEUTIL_SOURCE_
   extern struct partialMatch           *GlobalLHSBinds;
   extern struct partialMatch           *GlobalRHSBinds;
#endif

#endif




