   /*******************************************************/
   /*      "C" Language Integrated Production System      */
   /*                                                     */
   /*                  A Product Of The                   */
   /*             Software Technology Branch              */
   /*             NASA - Johnson Space Center             */
   /*                                                     */
   /*             CLIPS Version 5.10  07/17/91            */
   /*                                                     */
   /*               LHS PARSER HEADER FILE                */
   /*******************************************************/

/*************************************************************/
/* Purpose:                                                  */
/*                                                           */
/* Principal Programmer(s):                                  */
/*      Gary D. Riley                                        */
/*                                                           */
/* Contributing Programmer(s):                               */
/*                                                           */
/* Revision History:                                         */
/*                                                           */
/*************************************************************/

#ifndef _H_ruleprsr
#define _H_ruleprsr

#include "expressn.h"
#include "reorder.h"
#include "scanner.h"

#ifdef LOCALE
#undef LOCALE
#endif

#ifdef _RULEPRSR_SOURCE_
#define LOCALE
#else
#define LOCALE extern
#endif

#if STUDENT

#define MAX_SALIENCE  2
#define MIN_SALIENCE -2

#else

#define MAX_SALIENCE  10000
#define MIN_SALIENCE -10000

#endif
 
#if ANSI_COMPILER
LOCALE struct node                   *ParseRuleLHS(char *,struct token *);
LOCALE struct node                   *RestrictionParse(char *,struct token *);
LOCALE struct expr                   *ParseRuleRHS(char *);
#else
LOCALE struct node                   *ParseRuleLHS();
LOCALE struct node                   *RestrictionParse();
LOCALE struct expr                   *ParseRuleRHS();
#endif


#ifndef _RULEPRSR_SOURCE_
   extern int                     GlobalSalience;
   extern struct expr            *SalienceExpression;
#endif

#endif




