   /*******************************************************/
   /*      "C" Language Integrated Production System      */
   /*                                                     */
   /*                  A Product Of The                   */
   /*             Software Technology Branch              */
   /*             NASA - Johnson Space Center             */
   /*                                                     */
   /*             CLIPS Version 5.10  07/17/91            */
   /*                                                     */
   /*                 SCANNER HEADER FILE                 */
   /*******************************************************/

/*************************************************************/
/* Purpose:                                                  */
/*                                                           */
/* Principal Programmer(s):                                  */
/*      Gary D. Riley                                        */
/*                                                           */
/* Contributing Programmer(s):                               */
/*                                                           */
/* Revision History:                                         */
/*                                                           */
/*************************************************************/

#ifndef _H_scanner
#define _H_scanner

struct token;

#ifdef LOCALE
#undef LOCALE
#endif

#ifdef _SCANNER_SOURCE_
#define LOCALE
#else
#define LOCALE extern
#endif

struct token
  {
   int type;
   VOID *value;
   char *print_rep;
  };


#if ANSI_COMPILER
LOCALE VOID                           GetToken(char *,struct token *);
LOCALE VOID                           CopyToken(struct token *,struct token *); 
LOCALE int                            FlushPPBuffer(void);
LOCALE VOID                           DestroyPPBuffer(void);
LOCALE VOID                           SavePPBuffer(char *);
LOCALE VOID                           PPBackup(void);
LOCALE char                          *CopyPPBuffer(void);
LOCALE char                          *GetPPBuffer(void);
LOCALE VOID                           PPCRAndIndent(void);
LOCALE VOID                           IncrementIndentDepth(int);  
LOCALE int                            DecrementIndentDepth(int);  
LOCALE int                            SetIndentDepth(int);  
LOCALE VOID                           SetPPBufferStatus(int);
LOCALE int                            GetPPBufferStatus(void);
LOCALE char                          *StringPrintForm(char *);
#else
LOCALE VOID                           GetToken();
LOCALE VOID                           CopyToken(); 
LOCALE int                            FlushPPBuffer();
LOCALE VOID                           DestroyPPBuffer();
LOCALE VOID                           SavePPBuffer();
LOCALE VOID                           PPBackup();
LOCALE char                          *CopyPPBuffer();
LOCALE char                          *GetPPBuffer();
LOCALE VOID                           PPCRAndIndent();
LOCALE VOID                           IncrementIndentDepth();  
LOCALE int                            DecrementIndentDepth();  
LOCALE int                            SetIndentDepth();  
LOCALE VOID                           SetPPBufferStatus();
LOCALE int                            GetPPBufferStatus();
LOCALE char                          *StringPrintForm();
#endif

#ifndef _SCANNER_SOURCE_
   extern int                         IgnoreCompletionErrors;
#endif
#endif




