   /*******************************************************/
   /*      "C" Language Integrated Production System      */
   /*                                                     */
   /*                  A Product Of The                   */
   /*             Software Technology Branch              */
   /*             NASA - Johnson Space Center             */
   /*                                                     */
   /*             CLIPS Version 5.10  07/17/91            */
   /*                                                     */
   /*             SHORT LINK NAME HEADER FILE             */
   /*******************************************************/

/*************************************************************/
/* Purpose:                                                  */
/*                                                           */
/* Principal Programmer(s):                                  */
/*      Gary D. Riley                                        */
/*                                                           */
/* Contributing Programmer(s):                               */
/*                                                           */
/* Revision History:                                         */
/*                                                           */
/*************************************************************/

/******************************************************************/
/* This file redefines a number of global function and variable   */
/* definitions which are not distinguishable within 6 characters. */
/* This is done for linkers which only use less than the number   */
/* of significant characters used by the C compiler. Note that    */
/* the compiler should still be ANSI compliant in that in should  */
/* recognize at least 31 significant characters.                  */
/******************************************************************/

#ifndef _SHRTLNKN_HEADER_
#define _SHRTLNKN_HEADER_

#define ActivationBasis                     RN1
#define AddClearBloadReadyFunction          RN2
#define AddClearFunction                    RN3
#define AddHashFunction                     RN4
#define AddressesToStrings                  RN5
#define AgendaCommand                       RN6
#define AppendNToString                     RN7
#define AppendToString                      RN8
#define AssertString                        RN9
#define BinaryVersionID                     RN10
#define BrowseClassesCmd                    RN11
#define buffer_getc                         RN12
#define buffer_ungetc                       RN13
#define BuildFunction                       RN14
#define CallNextMethod                      RN15
#define ChangeToFactList                    RN16
#define ChangeToGlobals                     RN17
#define CheckSlotRange                      RN18
#define CheckSlotType                       RN19
#define ClassHasHandler                     RN20
#define ClassHasSlot                        RN21
#define ClassSubclassesCmd                  RN22
#define ClassSuperclassesCmd                RN23
#define ClearCommand                        RN24
#define ClearDefgenerics                    RN25
#define ClearDefglobals                     RN26
#define ClearDefinstances                   RN27
#define ClearDefmethods                     RN28
#define ClearDefrules                       RN29
#define ClearDeftemplates                   RN30
#define ClearPatternMatches                 RN31
#define CLIPSFunctionCall                   RN32
#define CLIPSSystemError                    RN33
#define CLIPSTrueSymbol                     RN34
#define CloseAllFiles                       RN35
#define CloseFunction                       RN36
#define CloseStringSource                   RN37
#define CmdListDeffunctions                 RN38
#define CmdListDefgenerics                  RN39
#define CmdListDefinstances                 RN40
#define CmdListDefmessageHandlers           RN41
#define CmdListDefmethods                   RN42
#define CmdListInstances                    RN43
#define CmdUndeffunction                    RN44
#define CmdUndefgeneric                     RN45
#define CmdUndefinstances                   RN46
#define CmdUndefmessageHandler              RN47
#define CmdUndefmethod                      RN48
#define compile_region                      RN49
#define CompileBufferp                      RN50
#define ConstructsToCCommand                RN51
#define ConstructsToCCommandDefinition      RN52
#define ContinueEnvFunction                 RN53
#define CreateInitialFactDeffacts           RN54
#define CreateMultifield                    RN55
#define CreateRawInstance                   RN56
#define CRSVTraceOffCommand                 RN57
#define CRSVTraceOnCommand                  RN58
#define CurrentEphemeralSizeMax             RN59
#define CurrentEvaluationDepth              RN60
#define CurrentExpression                   RN61
#define CurrentGeneric                      RN62
#define CurrentMessageFrame                 RN63
#define CurrentMessageName                  RN64
#define CurrentMessageSize                  RN65
#define CurrentMethod                       RN66
#define DecrementFloatCount                 RN67
#define DecrementIndentDepth                RN68
#define DecrementInstanceCount              RN69
#define DecrementInstanceDepth              RN70
#define DecrementIntegerCount               RN71
#define DecrementSymbolCount                RN72
#define DeffunctionGetBind                  RN73
#define DefruleCommands                     RN74
#define DefruleHasBreakpoint                RN75
#define DeleteActivation                    RN76
#define DeleteClassLinks                    RN77
#define DeleteClassUAG                      RN78
#define DeleteDefclass                      RN79
#define DeleteDeffacts                      RN80
#define DeleteDeffunction                   RN81
#define DeleteDefgeneric                    RN82
#define DeleteDefinstances                  RN83
#define DeleteDefmessageHandler             RN84
#define DeleteDefmethod                     RN85
#define DeleteDefrule                       RN86
#define DeleteDeftemplate                   RN87
#define DeletedFiringRule                   RN88
#define DeleteHandler                       RN89
#define DeleteInstance                      RN90
#define DeleteMethodInfo                    RN91
#define DeleteMultiValueField               RN92
#define DeleteNamedDeffacts                 RN93
#define DeleteNamedDefrule                  RN94
#define DeleteNamedDeftemplate              RN95
#define DeletePartialMatches                RN96
#define DeleteRouter                        RN97
#define DeleteSlots                         RN98
#define DependentsCommand                   RN99
#define DescribeClassCmd                    RN100
#define DestroyHandlerLinks                 RN101
#define DestroyPPBuffer                     RN102
#define DribbleOffCommand                   RN103
#define DribbleOnCommand                    RN104
#define DuplicateParse                      RN105
#define DuplicateSegment                    RN106
#define EditCommand                         RN107
#define EphemeralItemSize                   RN108
#define EvalFunction                        RN109
#define EvaluateExpression                  RN110
#define EvaluateInstanceSlots               RN111
#define EvaluateJoinExpression              RN112
#define EvaluateSalience                    RN113
#define EvaluatingTopLevelCommand           RN114
#define EvaluationError                     RN115
#define ExecutingConstruct                  RN116
#define ExecutingRule                       RN117
#define ExpandStringWithChar                RN118
#define ExpectedTypeError                   RN119
#define ExpressionComplexity                RN120
#define ExpressionContainsVariables         RN121
#define ExpressionCount                     RN122
#define ExpressionDeinstall                 RN123
#define ExpressionInstall                   RN124
#define ExpressionSize                      RN125
#define ExpressionToCode                    RN126
#define FactInstall                         RN127
#define filevisit_guts                      RN128
#define FindDefclassBySymbol                RN129
#define FindDeffacts                        RN130
#define FindDeffunction                     RN131
#define FindDeffunctionBySymbol             RN132
#define FindDefgeneric                      RN133
#define FindDefgenericBySymbol              RN134
#define FindDefglobal                       RN135
#define FindDefinstances                    RN136
#define FindDefmessageHandler               RN137
#define FindDefrule                         RN138
#define FindDeftemplate                     RN139
#define FindHandlerNameGroup                RN140
#define FindInstance                        RN141
#define FindInstanceBySymbol                RN142
#define FindInstanceSlot                    RN143
#define FindInstanceTemplateSlot            RN144
#define FindMethodByRestrictions            RN145
#define FindPreviewApplicableHandlers       RN146
#define FindSlotItem                        RN147
#define FindSlotPosition                    RN148
#define FindSymbolMatches                   RN149
#define FlushAnalysisExpressions            RN150
#define Function1Parse                      RN151
#define Function2Parse                      RN152
#define FunctionArray                       RN153
#define GarbagePartialMatches               RN154
#define GenericList                         RN155
#define GenericListBottom                   RN156
#define GenericStackFrame                   RN157
#define GenericStackSize                    RN158
#define GenGetvar                           RN159
#define GenGetvarValue                      RN160
#define GenJNConstant                       RN161
#define genlongfree                         RN162
#define GenPNConstant                       RN163
#define genrealloc                          RN164
#define GensymStarFunction                  RN165
#define GetActivationPPForm                 RN166
#define GetActivationSalience               RN167
#define GetActualDefglobal                  RN168
#define GetAutoFloatDividendCommand         RN169
#define GetClassSlots                       RN170
#define GetClassSubclasses                  RN171
#define GetClassSuperclasses                RN172
#define GetCompilationsWatch                RN173
#define GetConstructName                    RN174
#define GetConstructNameAndComment          RN175
#define GetDefclassPPForm                   RN176
#define GetDeffactsName                     RN177
#define GetDeffactsPPForm                   RN178
#define GetDeffunctionName                  RN179
#define GetDeffunctionPPForm                RN180
#define GetDefgenericName                   RN181
#define GetDefgenericPPForm                 RN182
#define GetDefglobalName                    RN183
#define GetDefglobalPPForm                  RN184
#define GetDefglobalValue                   RN185
#define GetDefglobalValueForm               RN186
#define GetDefinstancesName                 RN187
#define GetDefinstancesPPForm               RN188
#define GetDefmessageHandlerPPForm          RN189
#define GetDefmessageHandlerType            RN190
#define GetDefmethodDescription             RN191
#define GetDefmethodPPForm                  RN192
#define GetDefruleName                      RN193
#define GetDefrulePPForm                    RN194
#define GetDeftemplateName                  RN195
#define GetDeftemplatePPForm                RN196
#define GetFactDuplication                  RN197
#define GetFactDuplicationCommand           RN198
#define GetFactIndex                        RN199
#define GetFactListChanged                  RN200
#define GetFactPPForm                       RN201
#define GetFastSave                         RN202
#define GetFieldSysFunction                 RN203
#define GetGenericWildargs                  RN204
#define GetIncrementalResetCommand          RN205
#define GetIndexedDefrule                   RN206
#define GetInstanceClass                    RN207
#define GetInstanceClassCmd                 RN208
#define GetInstanceName                     RN209
#define GetInstanceNameCmd                  RN210
#define GetInstancePPForm                   RN211
#define GetInstancesChanged                 RN212
#define GetNextDefclass                     RN213
#define GetNextDeffacts                     RN214
#define GetNextDeffunction                  RN215
#define GetNextDefgeneric                   RN216
#define GetNextDefglobal                    RN217
#define GetNextDefinstances                 RN218
#define GetNextDefmessageHandler            RN219
#define GetNextDefmethod                    RN220
#define GetNextDefrule                      RN221
#define GetNextDeftemplate                  RN222
#define GetNextFact                         RN223
#define GetNextInstance                     RN224
#define GetNextInstanceInClass              RN225
#define GetNextLogicalRetraction            RN226
#define GetNextSymbolMatch                  RN227
#define GetNodeType                         RN228
#define GetNthWatchValue                    RN229
#define GetNumberOfDefglobals               RN230
#define GetNumberOfFacts                    RN231
#define GetNumericArgument                  RN232
#define GetPPBufferStatus                   RN233
#define GetPrintWhileLoading                RN234
#define GetQueryInstanceSlot                RN235
#define GetResetGlobalsCommand              RN236
#define GetRuleFiring                       RN237
#define GetRulesWatch                       RN238
#define GetSalienceEvaluationCommand        RN239
#define GetSlotSources                      RN240
#define GetStrategyCommand                  RN241
#define GetvarReplace                       RN242
#define GetVarSysFunction                   RN243
#define GlobalRHSBinds                      RN244
#define GlobalRtnUnknown                    RN245
#define GlobalSalience                      RN246
#define gotobol                             RN247
#define gotoeol                             RN248
#define GreaterThanOrEqualFunction          RN249
#define HandlerDeleteSlot                   RN250
#define HandlerGetBind                      RN251
#define HandlerGetSlot                      RN252
#define HandlerInsertSlot                   RN253
#define HandlerPutSlot                      RN254
#define HandlerReplaceSlot                  RN255
#define HandlerRtnUnknown                   RN256
#define HandlersExecuting                   RN257
#define HandlerType                         RN258
#define HandlerWildargs                     RN259
#define HelpFunctionDefinitions             RN260
#define IncrementalResetFlag                RN261
#define IncrementFactCount                  RN262
#define IncrementFloatCount                 RN263
#define IncrementIndentDepth                RN264
#define IncrementInstanceCount              RN265
#define IncrementIntegerCount               RN266
#define IncrementPseudoFactIndex            RN267
#define IncrementSymbolCount                RN268
#define InitializeClasses                   RN269
#define InitializeCLIPS                     RN270
#define InitializeConstructs                RN271
#define InitializeDefaultRouters            RN272
#define InitializeDeffacts                  RN273
#define InitializeDeffunctions              RN274
#define InitializeDefglobal                 RN275
#define InitializeDefrules                  RN276
#define InitializeDeftemplates              RN277
#define InitializeEngine                    RN278
#define InitializeFacts                     RN279
#define InitializeIgnoredConstructs         RN280
#define InitializeInstance                  RN281
#define InitializeInstanceTable             RN282
#define InitializeSpecialForms              RN283
#define InsertSlot                          RN284
#define InstanceNameToSymbol                RN285
#define InstancesPurge                      RN286
#define IntegerFunction                     RN287
#define IntegerpFunction                    RN288
#define IsClassAbstractCmd                  RN289
#define IsClassBeingUsed                    RN290
#define IsDeffunctionDeletable              RN291
#define IsDefmethodDeletable                RN292
#define IsInstanceAddress                   RN293
#define IsInstanceName                      RN294
#define IsSlotInitable                      RN295
#define IsSlotWritable                      RN296
#define kill_all_windows                    RN297
#define LessThanOrEqualFunction             RN298
#define ListDeffacts                        RN299
#define ListDeffactsCommand                 RN300
#define ListDeffunctions                    RN301
#define ListDefgenerics                     RN302
#define ListDefglobals                      RN303
#define ListDefglobalsCommand               RN304
#define ListDefinstances                    RN305
#define ListDefmessageHandlers              RN306
#define ListDefmethods                      RN307
#define ListDefrules                        RN308
#define ListDeftemplates                    RN309
#define ListDeftemplatesCommand             RN310
#define ListDependencies                    RN311
#define ListDependents                      RN312
#define LoadConstructs                      RN313
#define LoadConstructsFromLogicalName       RN314
#define LoadFactsCommand                    RN315
#define LoadInstancesCommand                RN316
#define MemoryTable                         RN317
#define MemoryUsed                          RN318
#define MethodsExecuting                    RN319
#define mlwrite                             RN320
#define ModifyParse                         RN321
#define MultifieldpFunction                 RN322
#define MultifieldSlotDelete                RN323
#define MultifieldSlotInsert                RN324
#define MultifieldSlotReplace               RN325
#define NetworkRetract                      RN326
#define NumericNotEqualFunction             RN327
#define ObjectsRunTimeInitialize            RN328
#define ObjectSystemPurge                   RN329
#define OpenStringDestination               RN330
#define OpenStringSource                    RN331
#define ParseAtomOrExpression               RN332
#define ParseConstruct                      RN333
#define ParseDeftemplate                    RN334
#define ParseInitializeInstance             RN335
#define ParseRuleRHS                        RN336
#define PatternMatch                        RN337
#define PatternNetErrorMessage              RN338
#define PauseEnvFunction                    RN339
#define PpdeffactsCommand                   RN340
#define PpdefglobalCommand                  RN341
#define PPDefmethod                         RN342
#define PPDeftemplateCommand                RN343
#define PreviewMessage                      RN344
#define PreviewMessageCmd                   RN345
#define PrintActivation                     RN346
#define PrintAtom                           RN347
#define PrintCLIPS                          RN348
#define PrintCRSVActivation                 RN349
#define PrintCurrentMessage                 RN350
#define PrintDeffunctionReference           RN351
#define PrintFactWithIdentifier             RN352
#define PrintFloat                          RN353
#define PrintFloatReference                 RN354
#define PrintFunctionReference              RN355
#define PrintIntegerReference               RN356
#define PrintPrompt                         RN357
#define PrintTemplateFact                   RN358
#define PTR_EQ_FIELD                        RN359
#define PTR_OR                              RN360
#define PTR_NEQ_FIELD                       RN361
#define PTR_NOT                             RN362
#define PTR_NOTCONSTANT                     RN363
#define QFindDeftemplate                    RN364
#define QUERY_DELIMETER_SYMBOL              RN365
#define QueryDoForInstance                  RN366
#define QueryFindInstance                   RN367
#define RedrawScreenFunction                RN368
#define RefreshAgenda                       RN369
#define RefreshAgendaCommand                RN370
#define RefreshBooleanSymbols               RN371
#define RefreshCommand                      RN372
#define RefreshDefrule                      RN373
#define region_getc                         RN374
#define region_ungetc                       RN375
#define ReleaseMemory                       RN376
#define ReleaseTraversalID                  RN377
#define RemoveAllActivations                RN378
#define RemoveAllBreakpoints                RN379
#define RemoveAllDeffacts                   RN380
#define RemoveAllFacts                      RN381
#define RemoveBatch                         RN382
#define RemoveBreakCommand                  RN383
#define RemoveBreakpoint                    RN384
#define RemoveCleanupFunction               RN385
#define RemoveClearFunction                 RN386
#define RemoveConstruct                     RN387
#define RemoveEphemeralAtoms                RN388
#define RemoveFactDependencies              RN389
#define RemoveFunctionParser                RN390
#define RemoveHashedFact                    RN391
#define RemoveOldFacts                      RN392
#define RemovePeriodicFunction              RN393
#define RemovePMDependencies                RN394
#define RemoveResetFunction                 RN395
#define RemoveRunFunction                   RN396
#define RemoveSaveFunction                  RN397
#define ReorderPatterns                     RN398
#define ReplaceMultiValueField              RN399
#define ResetCommand                        RN400
#define ResetDeployedRuleImage              RN401
#define ResetNotedPatterns                  RN402
#define RetractFact                         RN403
#define ReturnContext                       RN404
#define ReturnDefrule                       RN405
#define ReturnElements                      RN406
#define ReturnExpression                    RN407
#define ReturnFlag                          RN408
#define ReturnFunction                      RN409
#define ReturnNodes                         RN410
#define ReturnPackedExpression              RN411
#define ReturnPartialMatch                  RN412
#define ReturnSlots                         RN413
#define ReturnSymbolMatches                 RN414
#define ReturnValues                        RN415
#define SalienceInformationError            RN416
#define SaveConstructs                      RN417
#define SaveFactsCommand                    RN418
#define SaveInstancesCommand                RN419
#define searchop                            RN420
#define SearchParsedBindNames               RN421
#define SegmentInstall                      RN422
#define SetAutoFloatDividendCommand         RN423
#define SetBeforeResetFunction              RN424
#define SetCompilationsWatch                RN425
#define SetContinueEnvFunction              RN426
#define SetDefinstancesList                 RN427
#define SetFactDuplicationCommand           RN428
#define SetFactID                           RN429
#define SetFactListChanged                  RN430
#define SetFastSave                         RN431
#define SetgenFunction                      RN432
#define SetIncrementalResetCommand          RN433
#define SetListOfDeffunctions               RN434
#define SetListOfDefglobals                 RN435
#define SetListOfDefrules                   RN436
#define SetListOfDeftemplates               RN437
#define SetResetGlobalsCommand              RN438
#define SetRuleInformation                  RN439
#define SetSalienceEvaluationCommand        RN440
#define SetStrategyCommand                  RN441
#define SetupGenericsBload                  RN442
#define SetupGenericsCompiler               RN443
#define SetupObjectsCompiler                RN444
#define SetupObjectSystem                   RN445
#define StringpFunction                     RN446
#define StringPrintForm                     RN447
#define StringToFact                        RN448
#define StringToMultifield                  RN449
#define SymbolToInstanceName                RN450
#define TextLookupToss                      RN451
#define updateline                          RN452
#define UpdateMemoryRequests                RN453
#define UpdateMemoryUsed                    RN454
#define UpdateModifyDuplicate               RN455
#define WatchMethods                        RN456
#define BinaryFileHandle                    RN457
#define BinaryFP                            RN458
#define BinaryRefNum                        RN459
#define PTR_AND                             RN460

#endif

