#include <stdio.h>
#include <string.h> 
#include "crsv.h"

/* ===========  Functions defined Externally but used here  =========== */

/* -----------------------------
 *  From the file: CRSVTKN.C
 * -----------------------------
 */

extern int      GetToken();

/* -----------------------------
 *  From the file: CRSVPRNT.C
 * -----------------------------
 */

extern void     FactBlockPrintout();
extern void     RulesPrintout();
extern void     RelationsPrintout();
extern void     ExternalFuncsPrintout();
extern void     DefrelationsPrintout();

extern void     SendMessage();


/* -----------------------------
 *  From the file: CRSVMISC.C
 * -----------------------------
 */

extern int      CheckInputs();
extern int      CheckTopConstruct();
extern int      FindTopConstruct();
extern int      FindRhtParen();

/* -----------------------------
 *  From the file: CRSVUSR.C
 * -----------------------------
 */

extern void UsrStartup();
extern void UsrNewFile();
extern void UserSummary();

/* -----------------------------
 *  From the file: CRSVANAL.C
 * -----------------------------
 */

extern void analysis();

/* -----------------------------
 *  From the file: CRSVDEFREL.C
 * -----------------------------
 */

extern int ProcessDefrelation();

/* -----------------------------
 *  From the file: CRSVEXF.C
 * -----------------------------
 */

extern int ProcessDefexternal();

/* -----------------------------
 *  From the file: CRSVTMP.C
 * -----------------------------
 */

extern int ProcessDeftemplate();

/* -----------------------------
 *  From the file CRSVDEFGL.C
 * -----------------------------
 */
 extern int ProcessDefglobal();

/* -----------------------------
 *  From the file: CRSVWRT.C
 * -----------------------------
 */

extern void CreateDefrelFile();
extern void CreateDefextFile();

/* -----------------------------
 *  From the file: CRSVPROC.C
 * -----------------------------
 */

extern int ProcessRule();
extern int ProcessFactBlock();

/* -----------------------------
 *  From the file: CRSVPRNT.C
 * -----------------------------
 */

extern void ErrorMessage();

/* -----------------------------
 *  From the file: CRSVMEM.C
 * -----------------------------
 */

extern void FreeFactBlock();
extern void FreeRule();
extern void FreeRelation();
extern void FreeExternalFunction();      
extern void FreeVariable();
extern void FreeDefrelation();
extern void FreeDefexternal();
extern void FreeActivatedRule();
extern void FreeActivatedRelation();
extern void FreeDeftemplate();
extern void FreeDefglobal();
extern long int     MemoryUsed();
extern long int     MaximumMemoryUsed();
extern int          ReleaseMemory();

/* -----------------------------
 *  From the file: CRSVHASH.C
 * -----------------------------
 */

extern void     InitSymbolTable();

/* -----------------------------
 * From the file :  CRSVPRST.C
 * -----------------------------
 */

extern int ProcessTraceFile();


/* ===========  Functions defined here for Global use  ================ */

void       EndCRSV();


/* ===========  Functions defined here for internal use  ============== */

void         CloseFile();
FILE        *OpenFile();
void         InitGlobals();
int          ProcessMain();


/* ===========  Variables defined here for Global use  ================ */

char        *CurrentObjectName;    /* Name of current object           */
int          CurrentLineNumber;    /* Current line number              */
FILE        *CurrentFile;          /* current file pointer             */
char        *CurrentFileName;      /* Name of the current file         */
short        LastOperation;        /* RETRACTION or ASSERTION          */
short        FirstRelation;
short        FirstRule;
short        IssuedErrorMessage;   /* Set upon call to ErrorMessage   */

int          CHECK_RULES;           /* Check rules flag                 */
int          CHECK_RELATIONS;       /* Check relations flag             */
int          CHECK_EX_FLAG;         /* Check external functions flag    */
int          CHECK_COMMENTS;        /* Report on missing comments       */
int          VERBOSE;               /* Verbose printout flag            */
int          CHECK_STYLE;           /* Check code Style                 */
int          CREATE_DEFRELS;        /* Create Defrelations File flag    */
int          CHECK_DEFRELS;         /* Check defrelations flag          */
int          CHECK_DEBUG;           /* Display Debug info               */
int          ANALYZE_TRACE;         /* Analize trace file               */
int          LITERAL;               /* Field value checker              */
int          INFERENCE_TRACE;       /* Tracing the inference            */
int          MAX_SINGLE_LIST = 5;   /* The length of a token list when  */
                                    /* the wildcard ?VARIABLE is        */
                                    /* substituted for the explicit     */
                                    /* list                             */
int          NUM_ERRORS;            /* Number of errors in a File       */
int          NUM_WARNINGS;          /* Number of warnings in a File     */
int          IBM_COM_LINE;

char         MsgBuf[WORDLENGTH];   /* Global Message buffer            */

FACT_BLOCK  *FactBlockHead        = NULL;  /* First Element in Fact block list */
RULE        *RuleHead             = NULL;  /* First Element in Rule list       */
RELATION    *RelationHead         = NULL;  /* First Element in Relation list   */
EX_FUNC     *externalFunctionHead = NULL;  /* First Element in Ex Funcs list   */
VAR_PTR      RetractHead          = NULL;  /* First Element in Retract list    */
VAR_PTR      VariableHead         = NULL;  /* First Element in Variable list   */
DEF_REL     *DefrelationHead      = NULL;  /* First Element in Defrelation     */
                                           /* list                             */
DEF_EXT     *DefexternalHead = NULL;          /* First Element in Defexternal     */
                                           /* list                             */
DEF_TMP     *DeftemplateHead = NULL;       /* First Element in Deftemplate     */
                                           /* list                             */
ACT_REL_PTR  ActvatedRelationHead = NULL;  /* first node in trace relation     */
                                           /* list                             */
ACT_R_PTR    ActivatedRuleHead = NULL;     /* first node in trace rule list    */
COMP_R_PTR   CompiledRuleHead = NULL;      /* first node in trace list of      */
                                           /* rules in the system              */
DG_PTR       DefglobalHead = NULL;         /* first def_global node            */
VAR_PTR      NegativeVariableHead = NULL;
ACT_REL_PTR  CurrentActivatedRelation = NULL;     /* current relation returned by   */
                                                  /* FindCreateActRelation          */
SPE_FACT_PTR CurrentFact = NULL;        /* specific information about the current   */
                                        /* relation                                 */
AGEN_RULE   *AgendaRules = NULL;        /* Rules in the agenda                      */
int          FactNumber;                /* the number corresponds to the            */
                                        /* current fact in the trace  file          */
int          cycle;
int          FactNumberInDeffact;
FB_PTR       LastFactBlock;
short        start;
ACT_R_PTR    LastFiredRule;
  

/* ===========  Variables defined Externally but used here  =========== */

/* -----------------------------
 *  From the file: CRSVTKN.C
 * -----------------------------
 */

extern char  *TKNWORD;                      /* gettoken string storage  */

#if IBM_TBC

/* -----------------------------
 *  For the Turbo C Linker
 * -----------------------------
 */

extern unsigned _stklen = 24576;             /* Set stack size to 24K    */

#endif

/* ===========  Variables defined here for internal use  ============== */


/* ======================================================================= */

/*
 * -------------------------------------------------------------
 *  NAME   :  main
 *
 *  PURPOSE:  This is the main routine for the program.
 *            All processing is done through here.
 *
 *  INPUTS :  Two, C standard argc and argv. 
 *
 *  RETURNS:  Nothing
 *
 *  NOTES  :  On the Macintosh, picking up argc and argv 
 *            doesn't mean much.
 * -------------------------------------------------------------
 */

main(argc, argv)
int argc;
char *argv[];
{
   char   *def_rel_file;	                 /* Name for defrelations file */
   char   *trace_file_name;       	         /* Name for the trace_file    */
   char   c_file_list[MAX_FILES][MAX_NAME];  /* only used when IBM_COM_LINE is true */
   int    rtn;
   int    exit_flag,i;

#if MAC_LSC
   MacCRSVInterface();    /* On the Mac, call the interface (never returns!) */
#endif

#if IBM_TBC || IBM_MSC
   IF(argc == 1)THEN
      IBM_COM_LINE = FALSE;
      PC_CRSV_interface();   /* On the PC, call the interface (never returns!) */
   ELSE
      IBM_COM_LINE = TRUE;
   END_IF
#endif

   /*======================================*/
   /* For Generic Versions of this program */
   /*======================================*/

   exit_flag = NO;
   WHILE(exit_flag IS_NO) DO

      /*==================================*/
      /* Check user inputs and file names */
      /*==================================*/

      rtn = CheckInputs(&argc, argv, &def_rel_file, &trace_file_name);

      IF(rtn IS_ERROR) THEN

         /*===========================================*/
         /* If inputs invalid, or no files, then exit */
         /*===========================================*/

         exit_flag = YES;
      END_IF

      IF(exit_flag IS_NO) THEN

         /*===========================*/
         /* Call Main processing loop */
         /*===========================*/

/* The following code is for those who do not want to use the interface and recompile the codes */
/* This is not clean, but this is the only way I could think of, at this time, to over come the problem */
/* Recompiling and relinking the code could take quite a long time, so I guess we have to sacrify the speed a little bit*/

         IF(IBM_COM_LINE)THEN
             argc--;
             IF(argc > MAX_FILES)THEN
		        sprintf(MsgBuf,"Too many files, limit is %d\n",MAX_FILES);
                ErrorMessage(ERROR,MsgBuf);
                SendMessage("NOTE!!! If you wish to have more files\n",NO);
	            SendMessage("Please change the flag to GENERIC(crsv.h) and \n",NO);
	            SendMessage("recompile and relink the files - Use the makefile provided\n",NO);
		        EndCRSV();
		     END_IF
	         FOR(i = 0; i < argc ; i++) DO
               IF(strlen(argv[i + 1]) > (MAX_NAME - 1))THEN
		         sprintf(MsgBuf,"File %s is too long, limit is %d\n",argv[i],MAX_NAME);
                 ErrorMessage(ERROR,MsgBuf);
                 SendMessage("NOTE!!! If you wish to have the longer file name\n",NO);
	             SendMessage("Please change the flag to GENERIC(crsv.h) \n",NO);
	             SendMessage("and recompile and relink the files - Use the makefile provided\n",NO);
		         EndCRSV();
		        END_IF
                strcpy(c_file_list[i],argv[i + 1]);
             END_FOR
             exit_flag = ProcessMain(argc, c_file_list,def_rel_file, trace_file_name);
          ELSE
             exit_flag = ProcessMain(argc - 1, argv + 1, 
                                  def_rel_file, trace_file_name);
          END_IF
      END_IF

   END_WHILE

   EndCRSV();
}


/* ===================================================================
 *                       Main Processing Loop
 * ===================================================================
 */

int ProcessMain(num_files, file_list, def_rel_file, trace_file_name)
int    num_files;
#if MAC_LSC || IBM_TBC || IBM_MSC
char file_list[MAX_FILES][MAX_NAME];
char def_rel_file[MAX_NAME];
char trace_file_name[MAX_NAME];
#else
char   **file_list;
char   *def_rel_file;
char   *trace_file_name;
#endif
{
   int    flag = 0;
   int    i;
   int    token, rtn;
   char   logfile[WORDLENGTH];
   /*===========================*/
   /*  Do initialization stuff  */
   /*===========================*/

   SendMessage("\n           CRSV Version 1.31 (09/19/91)",NO);
   SendMessage("\nCLIPS Cross Reference, Style and Verification Tool\n",NO);

   InitGlobals();
   UsrStartup();

   /*=====================================*/
   /*  For each file in the file list...  */
   /*=====================================*/

   FOR (i = 0; i < num_files ;   i++) DO

      /*===============================*/
      /*  Set up file processing info  */
      /*===============================*/

      CurrentFileName = file_list[i];           /* Set global file name */
      CurrentLineNumber  = 1;                      /* and line count */

      /*=================*/
      /*  Open the file  */
      /*=================*/

      CurrentFile = OpenFile(CurrentFileName);
      IF(CurrentFile EQ NULL) THEN               /* If error opening file... */
         sprintf(MsgBuf,"Error opening file \"%s\"", CurrentFileName);
         ErrorMessage(ERROR,MsgBuf);
	     return(ERROR);
      ELSE
         UsrNewFile(CurrentFileName);            /* and tell usr function */

         IssuedErrorMessage = OFF;
            SendMessage
         ("\n\n========================  PROCESSING FILE  =======================",NO);
            sprintf(MsgBuf, "\n\nFILENAME: %s", CurrentFileName);
            SendMessage(MsgBuf,NO);
         /*==========================*/
         /*  Start reading the file  */
         /*==========================*/

         token = GetToken(CurrentFile);

         while(token NEQ STOP) DO
            CurrentObjectName = "none";

            /*===========================*/
            /*  Find a def... something  */
            /*===========================*/

            IF(flag NEQ RESTART) THEN
               rtn = CheckTopConstruct(CurrentFile, token);
            ELSE
               rtn = FindTopConstruct(CurrentFile, token);
            END_IF

            /*================================*/
            /*  Process the def... something  */
            /*================================*/

            IF(rtn EQ DEFFACTS) THEN
               flag = ProcessFactBlock();
            ELSE_IF(rtn EQ DEFRULE)
               flag = ProcessRule();
            ELSE_IF(rtn EQ DEFRELATION)
               flag = ProcessDefrelation();
            ELSE_IF(rtn EQ DEFEXTERNAL)
               flag = ProcessDefexternal();
            ELSE_IF(rtn EQ DEFTEMPLATE)
               flag = ProcessDeftemplate();
            ELSE_IF(rtn EQ DEFCLASS)
               flag = FindRhtParen();
            ELSE_IF(rtn EQ DEFINSTANCES)
               flag = FindRhtParen();
            ELSE_IF(rtn EQ DEFMETHOD)
               flag = ProcessDefmethod();
            ELSE_IF(rtn EQ DEFMESSAGE_HANDLER)
               flag = FindRhtParen();
            ELSE_IF(rtn EQ DEFGLOBAL)
               flag = ProcessDefglobal();
            ELSE_IF(rtn EQ DEFGENERIC)
               flag = ProcessDefgeneric();
            ELSE_IF(rtn EQ DEFFUNCTION)
               flag = ProcessDeffunction();
            ELSE_IF(rtn EQ ERROR)
               flag = RESTART;
            END_IF

            token = GetToken(CurrentFile);
         END_WHILE

         SendMessage
 ("\n\n===================  FINISHED PROCESSING FILE  ===================\n",NO);
         CloseFile(CurrentFile);
      END_IF
   END_FOR
   
  /*========================*/
  /*  Process Trace File    */
  /*========================*/
   CurrentObjectName = "none";  
   IF((INFERENCE_TRACE IS_ON) || (ANALYZE_TRACE IS_ON))THEN
      CurrentLineNumber = 0;
      IssuedErrorMessage = OFF;
      IF((INFERENCE_TRACE IS_ON) && ((IBM_COM_LINE IS_ON) ||
      	 (!MAC_LSC && !IBM_TBC && !IBM_MSC))) THEN
        SendMessage("Enter the file name for inference trace option \n",NO);
        WHILE(1)DO
           if(gets(logfile) != NULL)
             break;
        END_WHILE
        IF(OpenLogFile(logfile) == ERROR)THEN
           sprintf(MsgBuf,"Error in opening file \"%s\" \n",logfile);
           SendMessage(MsgBuf,NO);
           EndCRSV();
        END_IF
      END_IF

      SendMessage
    ("\n\n========================  PROCESSING FILE  =======================",NO);
      sprintf(MsgBuf, "\n\nFILENAME: %s\n", trace_file_name);
      SendMessage(MsgBuf,NO);

      CurrentFileName = trace_file_name;
      CurrentFile = OpenFile(CurrentFileName);
      IF(CurrentFile EQ NULL) THEN               /* If error opening file... */
         sprintf(MsgBuf,"Error in opening file \"%s\"", CurrentFileName);
         ErrorMessage(ERROR,MsgBuf);
	     return(ERROR);
      ELSE
        ProcessTraceFile(CurrentFileName);
        CloseFile(CurrentFile);
      END_IF
      SendMessage
  ("\n\n===================  FINISHED PROCESSING FILE  ===================\n",NO);
   END_IF
   
  /*==================*/
  /*  Final analysis  */
  /*==================*/
     
   analysis(FactBlockHead, RuleHead, RelationHead, externalFunctionHead, ActivatedRuleHead,
      ActvatedRelationHead, DefrelationHead, DefexternalHead);

  /*=========================================*/
  /*  Print out cross references, as needed  */
  /*=========================================*/
     
   IF(CHECK_RULES IS_ON) THEN
      FactBlockPrintout(FactBlockHead);
      RulesPrintout(RuleHead, ActivatedRuleHead);
   END_IF

   IF(CHECK_RELATIONS IS_ON) THEN
      RelationsPrintout(RelationHead);
   END_IF

   IF(CHECK_EX_FLAG IS_ON) THEN
      ExternalFuncsPrintout(externalFunctionHead);
   END_IF

  /*===================================================*/
  /*  Create defrelations and defexternals, if needed  */
  /*===================================================*/
     
   IF(CREATE_DEFRELS IS_ON) THEN
      sprintf(MsgBuf, "\n\nStoring definitions in file: %s\n", 
              def_rel_file);
      SendMessage(MsgBuf,NO);
      CreateDefrelFile(RelationHead, def_rel_file);
      CreateDefextFile(externalFunctionHead, def_rel_file);
   END_IF
   
   IF(CHECK_DEBUG IS_ON) THEN
      DefrelationsPrintout(DefrelationHead);
   END_IF

   UserSummary(FactBlockHead, RuleHead, RelationHead, externalFunctionHead);

   SendMessage
  ("\n\n====================  CRSV ANALYSIS COMPLETED  ===================\n",NO);

   IF(CHECK_DEBUG IS_ON) THEN
      sprintf(MsgBuf, "\n\nCurrent mem used: %ld", MemoryUsed());
      SendMessage(MsgBuf,NO);
      sprintf(MsgBuf, "\nMax     mem used: %ld", MaximumMemoryUsed());
      SendMessage(MsgBuf,NO);
   END_IF      

   SendMessage("\n",NO);

   return(YES);
}

/* ===================================================================
 *                       Misc. Functions
 * ===================================================================
 */

/*
 * -------------------------------------------------------------
 *  NAME   :  OpenFile
 *
 *  PURPOSE:  This function opens a file. Prints an
 *            error message if the file can't be opened.
 *
 *  INPUTS:   A single argument, a string pointer to the 
 *            name of the file to be opened.
 *
 *  RETURNS:  An integer, ERROR (-1) if file can't be opened,
 *            otherwise, OK (0).
 * -------------------------------------------------------------
 */

FILE *OpenFile(file_name)
char *file_name;
{
   FILE *fp;
   
#if MAC_LSC
   GotoFileDirectory(file_name);
#endif

   fp = fopen(file_name, "r");
   
   return(fp);
}

/*
 * -------------------------------------------------------------
 *  NAME   :  CloseFile
 *
 *  PURPOSE:  This function closes a file.
 *
 *  INPUTS :  A single argument, a FILE pointer to the 
 *            file to be closed.
 *
 *  RETURNS:  Nothing useful.
 * -------------------------------------------------------------
 */
 
void CloseFile(file)
FILE *file;
{
   (void)fclose(file);
}

/* ======================================================================= */

/*
 * -------------------------------------------------------------
 *  NAME   :  InitGlobals
 *
 *  PURPOSE:  This function sets all global data to something
 *            appropriate for starting up or looping through
 *            multiple runs of the program.
 *
 *  INPUTS :  None. 
 *
 *  RETURNS:  Nothing
 * -------------------------------------------------------------
 */

void InitGlobals()
{
  /*===========================*/
  /* Init the global variables */
  /*===========================*/

   CurrentFileName       = "none";
   CurrentObjectName     = "none";
   CurrentLineNumber     = 1;
   LastOperation         = ERROR;
   
   NUM_ERRORS = 0;
   NUM_WARNINGS = 0;

  /*======================*/
  /* Clear all data lists */
  /*======================*/

   FreeFactBlock(FactBlockHead);
   FreeRule(RuleHead);
   FreeRelation(RelationHead);
   FreeVariable(RetractHead);
   FreeExternalFunction(externalFunctionHead);
   FreeDefrelation(DefrelationHead);
   FreeDefexternal(DefexternalHead);
   FreeVariable(VariableHead);
   FreeVariable(NegativeVariableHead);
   FreeActivatedRelation(ActvatedRelationHead);
   FreeActivatedRule(ActivatedRuleHead);
   FreeDeftemplate(DeftemplateHead);
   FreeDefglobal(DefglobalHead);
   
   FactBlockHead                 = NULL;
   RuleHead                      = NULL;
   RelationHead                  = NULL;
   RetractHead                   = NULL;
   externalFunctionHead          = NULL;
   DefrelationHead               = NULL;
   DefexternalHead               = NULL;
   VariableHead                  = NULL;
   NegativeVariableHead          = NULL;
   ActvatedRelationHead          = NULL;
   ActivatedRuleHead             = NULL;
   CompiledRuleHead              = NULL;
   DeftemplateHead               = NULL;
   CurrentActivatedRelation      = NULL;  
   CurrentFact 		             = NULL;   
   AgendaRules                   = NULL;
   DefglobalHead                 = NULL;
   cycle 			             = 1;
   FactNumberInDeffact           = 0;
   LastFactBlock 			     = NULL;
   start 			             = YES;
   LastFiredRule                 = NULL;
   FirstRelation                 = YES;
   FirstRule                     = YES;


  /*=============================*/
  /* Clear the symbol hash table */
  /*=============================*/

   InitSymbolTable();
   
   IF(CHECK_DEBUG IS_ON) THEN
      ReleaseMemory(-1);
      sprintf(MsgBuf, "\n\nCurrent mem used: %ld", MemoryUsed());
      SendMessage(MsgBuf,NO);
      sprintf(MsgBuf, "\nMax     mem used: %ld", MaximumMemoryUsed());
      SendMessage(MsgBuf,NO);
   END_IF
}
   
void EndCRSV()
{
   exit(1);
}
