#include <stdio.h>
#include <string.h> 
#include "crsv.h"


/* -----------------------------
 *  From the file: CRSVTKN.C
 * -----------------------------
 */

extern DG_PTR   AllocDefglobal();
extern int      GetToken();

/* -----------------------------
 *  From the file: CRSVEXF.C
 * -----------------------------
 */
extern DE_PTR   FindDefexternal ();

/* -----------------------------
 *  From the file: CRSVHASH.C
 * -----------------------------
 */
extern HASH *AddSymbol();

/* Global variable declared in the other files */

extern FILE     *CurrentFile;
extern char     *TKNWORD;
extern DG_PTR   DefglobalHead;
extern DE_PTR   DefexternalHead;



DG_PTR   FinfDefglobal();

/* ------------------------------------------------
 * ProcessDefglobal:
 *  This function processes the defglobal construct.
 * ------------------------------------------------
 */
int ProcessDefglobal()
{
    DG_PTR dglobal;
    int token,rtn;
    char *string;
    HASH *temp_hash;
    
    IF(VERBOSE IS_ON)THEN
        sprintf(MsgBuf,"\nProcess defglobal %s \n",TKNWORD);
        SendMessage(MsgBuf,NO);
    END_IF
    WHILE(((token = GetToken(CurrentFile)) != RPAREN) && (token != STOP)) DO
        IF(token != GLOBAL)THEN   /* if token != ?*variable*     */
            ErrorMessage(ERROR,"Check appropriate syntax for defglobal\n");
            return(RESTART);
        END_IF
        dglobal = AllocDefglobal();
        temp_hash = AddSymbol(TKNWORD);
        dglobal->variable = temp_hash->contents;
        token = GetToken(CurrentFile);  /* read in the equal sign */
        IF((token != WORD) ||(strcmp(TKNWORD,"=") != 0))THEN
            ErrorMessage(ERROR,"Check appropriate syntax for defglobal\n");
            return(RESTART);
        END_IF
        token = GetToken(CurrentFile);
        IF(token == LPAREN) THEN
            IF((rtn = ProcessExpression(dglobal)) == ERROR)THEN
                return(RESTART);
            END_IF
            dglobal->type = rtn;
            dglobal->value = dglobal->variable;
         ELSE
            temp_hash = AddSymbol(TKNWORD);
            dglobal->value = temp_hash->contents;
            dglobal->type  = token;
         END_IF
         IF(DefglobalHead == NULL) THEN
          DefglobalHead = dglobal;
         ELSE
            dglobal->next = DefglobalHead;
            DefglobalHead = dglobal;
         END_IF
     END_WHILE
}

/* ------------------------------------------------
 *  ProcessExpression:
 *   This function processes the expression in the
 *   defglobal.
 * ------------------------------------------------
 */
ProcessExpression(defglobal)
DG_PTR defglobal;
{
   int token,rtn_type,count = 0;
   DE_PTR DefExtFunc = NULL;
  
   token = GetToken(CurrentFile);
   IF(token NEQ WORD)THEN
       ErrorMessage(ERROR,"A Function name must be a SYMBOL \n",TKNWORD);
       return(ERROR);
   ELSE_IF(CheckExternalFuncs(TKNWORD,&rtn_type) IS_NO)
      IF((DefExtFunc = FindDefexternal(DefexternalHead,TKNWORD)) != NULL)THEN
         if(ProcessExternalFunction((RULE_PTR)defglobal,TKNWORD,DEFGLOBAL,NO,NO) != OK)
           return(ERROR);
         IF(DefExtFunc->return_word) THEN
           rtn_type = WORD;
           count++;
         END_IF
         IF(DefExtFunc->return_string) THEN
           rtn_type = STRING;
           count++;
         END_IF
         IF(DefExtFunc->return_integer) THEN
           rtn_type = INTEGER;
           count++;
         END_IF
         IF(DefExtFunc->return_float) THEN
           rtn_type = FLOAT;
           count++;
         END_IF
         if (count > 1)
          rtn_type = UNKNOWN;
         else if (count == 0)
          rtn_type = VOID;
         return(rtn_type);
      ELSE
          sprintf(MsgBuf,"Function %s is used before defined\n",TKNWORD);
          ErrorMessage(WARNING,MsgBuf);
          if(FindRhtParen() != OK)
            return(ERROR);
      END_IF
   END_IF
  WHILE(((token = GetToken(CurrentFile) ) != RPAREN) && (token != STOP))DO
       IF(token == LPAREN)THEN
         IF(ProcessExpression() == ERROR) THEN
            return(ERROR);
         END_IF
       ELSE_IF(ProcessSymbol(token) == ERROR)
          return(ERROR);
       END_IF
   END_WHILE
   return(rtn_type);
}

/* ------------------------------------------------
 * ProcessSymbol
 *  This function processes the symbol in the defglobal
 *  construct
 * ------------------------------------------------
 */
int ProcessSymbol(token)
int token;
{
    IF((token != WORD) AND (token != STRING) AND (token != INTEGER) AND 
            (token != FLOAT) AND (token != GLOBAL))THEN
        sprintf(MsgBuf,"Variable ?%s is unbound \n",TKNWORD); 
        ErrorMessage(ERROR,MsgBuf,NO);
        return(ERROR);
    END_IF
    IF(token == GLOBAL) THEN
       IF(FinfDefglobal(DefglobalHead,TKNWORD) == NULL)THEN
           sprintf(MsgBuf," Variable %s is unbound \n",TKNWORD);
           ErrorMessage(ERROR,MsgBuf,NO);
           return(ERROR);
       END_IF
    END_IF
    return(OK);
}

/* ------------------------------------------------
 * FinfDefglobal
 *   This function searches for the global variable
 *   in the list.
 * ------------------------------------------------
 */

DG_PTR FinfDefglobal(list,name)
DG_PTR list;
char *name;
{
    DG_PTR node;
    
    node  = list;
    
    WHILE(node != NULL)DO
        if(strcmp(node->variable,name) == 0)
          return(node);
        node = node->next;
    END_WHILE
    return(NULL);
}
