#include <stdio.h>
#include "crsv.h" 
#include <string.h>


/********************************************************************
 *  This file contains all the functions used to process rules and
 *  deffacts.
 ********************************************************************
 */


/* ===========  Functions defined Externally but used here  =========== */

/* -----------------------------
 *  From the file: CRSVREL.C
 * ----------------------------
 */
extern void     CheckMinNumOfFields ();
extern DEF_REL  *FindDefrelation ();
extern DEF_FLD  *FindDeffield ();
extern DEF_REL  *FindCreateDefrelation ();

/* -----------------------------
 *  From the file: CRSVEXF.C
 * -----------------------------
 */

 extern void     CheckArgumentInfo ();
 extern void     CheckVariableArgumentInfo ();
 extern DE_PTR   FindDefexternal ();

/* -----------------------------
 *  From the file: CRSVDEFGL.C
 * -----------------------------
 */

 extern DG_PTR   FinfDefglobal();
/* -----------------------------
 *  From the file: CRSVHASH.C
 * ----------------------------
 */

 extern HASH    *AddSymbol ();

/* -----------------------------
 *  From the file: CRSVMEM.C
 * -----------------------------
 */

extern FB_PTR     AllocFactBlock ();
extern FBR_PTR    AllocFactBlockRelation ();
extern REL_PTR    AllocRelation ();
extern EXF_PTR    AllocExternalFunction ();
extern FLD_PTR    AllocField ();
extern RULE_PTR   AllocRule ();
extern RR_PTR     AllocRuleRelation ();
extern TK_PTR	  AllocToken ();
extern VAR_PTR    AllocVariable ();
extern DGPTR      AllocDefglobalPtr();
extern void       FreeFactBlockRelation();
extern void       FreeVariableInOrPattern();
extern void       GenFree ();
extern char      *GenAlloc ();
extern void       FreeVariable ();
extern MULT_REL  *AllocMultipleRelation ();
extern void       FreeDefglobalPtr();

/* -----------------------------
 *  From the file: CRSVMISC.C
 * ----------------------------
 */

extern int      FindRhtParen ();
extern void     FindNewConstruct();
extern WL_PTR   AddToWordList ();

/* -----------------------------
 *  From the file: CRSVPRNT.C
 * ----------------------------
 */

extern void     ErrorMessage ();
extern void     SendMessage ();
extern void     SendText ();

/* -----------------------------
 *  From the file: CRSVREL.C
 * -----------------------------
 */

extern void     CheckFieldInfo ();
extern void     CheckMinNumOfFields ();
extern DEF_REL  *FindDefrelation ();
extern DEF_FLD  *FindDeffield ();

/* -----------------------------
 *  From the file: CRSVRSVD.C
 * ----------------------------
 */

extern int      CheckExternalFuncs ();

/* -----------------------------
 *  From the file: CRSVSTK.C
 * -----------------------------
 */

extern void ResetStack ();
extern void Push ();
extern void Pop ();
extern int  InsideIf ();
extern int  InsideWhile ();
extern int  NumberOfNestLevels ();
extern int  DescribePrevious ();
extern void MarkRetraction ();

/* -----------------------------
 *  From the file: CRSVTKN.C
 * -----------------------------
 */

extern int      GetToken ();
extern TK_PTR   GetTokenPtr ();
extern void     UnGetTokenPtr ();
extern void     SaveToken ();
extern void     StoreTokenInRelation();
extern void		FreeTokenInRelation();

/* -----------------------------
 *  From the file: CRSVTMP.C
 * -----------------------------
 */

 extern DEF_TMP *FindDeftemplate ();
 extern int      TemplateFormatToRelationFormat ();

/* -----------------------------
 *  From the file: CRSVUSR.C
 * -----------------------------
 */

extern void UserDeffact ();
extern void UserRule ();

/* -----------------------------
 * From CRSVVAR.C
 * -----------------------------
 */
extern void       		CheckVariables();
extern VAR_PTR    		FindVariable();
extern int 		      	ProcessLHSVariable();
extern int 		 		ProcessRHSVariable();
extern void 			InitVarListInOrPattern();

/* -----------------------------
 *  From the system:
 * -----------------------------
 */

extern double atof ();


/* ===========  Functions defined here for Global use  ================ */

int         ProcessRule ();
int         ProcessFactBlock();
RELATION   *FindRelation();
EX_FUNC    *FindExternalFunction ();
PAT_TKN_PTR InsertTokenIntoPattern();
RULE       *FindRule();
RULE	   *SearchRule();

/* ===========  Functions defined here for internal use  ============== */

RELATION       *FindCreateRelation ();
EXF_PTR        FindCreateExternalFunction ();
FLD_PTR        GetFieldPtr();
FLD_PTR        GetArgumentPtr ();
int 	       ProcessExternalFunction ();
int            FindArguments ();
int            ProcessLHSRetract ();
int            ProcessRHSRetract ();
int            ProcessRHSModify ();
int            FindBoundWords ();
int            CheckMultipleRelation ();
int            ProcessFBRelation ();
static int     ProcessRuleLHS();
PAT_LIST_PTR   CreateAndLinkPatToList();
static int     checkExtFncRtnTypeWDefrel();
static int     checkIntFncRtnTypeWDefrel();
RULE_PTR       InsertRule();
RR_PTR         FreeRuleInList();


/* =========== Variables defined here for global used  ================*/
PAT_LIST_PTR   CurrentPattern_list   = NULL; /* Pattern list in the current rule */
PAT_LIST_PTR   CurrentPattern        = NULL; /* Pattern in process */
short          LHSPattern           = FALSE;/* Currently process relation on the LHS */
RULE_PTR       CurrentRule           = NULL; /* Current rule pointer */
PAT_TKN_PTR    CurrentTokenInPattern = NULL;
IN_OR_VAR_PTR  InOrVariableList           = NULL; /* Variables in the OR pattern */

/* ===========  Variables defined Externally but used here  =========== */

/* -----------------------------
 *  From the file: CRSV.C
 * -----------------------------
 */

extern char        *CurrentObjectName;      /* Name of current object   */
extern FILE        *CurrentFile;            /* current file pointer  */
extern char        *CurrentFileName;        /* Name of the current file */
extern FACT_BLOCK  *FactBlockHead;          /* First Element in Fact block list */
extern RULE        *RuleHead;               /* First Element in Rule list       */
extern RELATION    *RelationHead;           /* First Element in Relation list   */
extern EX_FUNC     *externalFunctionHead;   /* First Element in Ex Funcs list   */
extern DR_PTR       DefrelationHead;        /* First Element in Defrelation list*/
extern DE_PTR       DefexternalHead;        /* First Element in Defexternal list*/
extern DT_PTR       DeftemplateHead;        /* First Element in Deftemplate list*/
extern VAR_PTR      RetractHead;            /* First Element in Retract list    */
extern VAR_PTR      VariableHead;           /* First Element in Variable list   */
extern VAR_PTR      NegativeVariableHead;   /* First Element in the negation of */
                                            /* variable list                    */
extern DG_PTR       DefglobalHead;          /* First Element in the global variable list */

                                            


/* -----------------------------
 *  From the file: CRSVTKN.C
 * -----------------------------
 */

extern double  FLOATNUMBER;                  /* GetToken float return   */
extern long    INTNUMBER;                    /* GetToken integer return */
extern char    *TKNWORD;                      /* GetToken string storage */


/* ===========  Variables defined here for internal use  ============== */

REL_PTR      CurrentRelation;                      /* Current relation pointer */
EXF_PTR      CurrentExtFunc;                  /* Current external function ptr */



/* ====================================================================
 * ==========       Fact Block Processing Functions       =============
 * ====================================================================
 */

/* ------------------------------------------------------------------
 *  NAME   :  ProcessFactBlock () 
 *
 *  PURPOSE:  This function reads all information about a
 *            deffacts structure and stores it in the
 *            appropriate structure.
 *
 *  INPUTS :  None.
 *
 *  RETURNS:  An integer, OK if deffacts was processed properly, 
 *            ERROR if there was a recoverable syntax error, and
 *            RESTART if there was a gross syntax error which
 *            prevents me from finding the closing paren.
 *
 *  NOTES  :
 * -------------------------------------------------------------
 *               Psuedo Code (may not be complete) 
 *
 *    Get fact block name
 *    Check if it is a new fact block, warn if duplicate name
 *    Allocate memory for a new FB structure
 *    Check for fact block comment
 *    Process each relation
 * ------------------------------------------------------------------
 */

int ProcessFactBlock () 
{
   int           rtn;
   int           token;
   char         *cur_fb_name;
   FACT_BLOCK   *cur_fb;
   HASH         *temp_hash;

   /*=========================*/
   /* Process fact block name */
   /*=========================*/

   token = GetToken (CurrentFile);

   IF (token NEQ WORD) THEN
      ErrorMessage (ERROR, "Missing name for deffacts construct\n");
      return(RESTART);
   END_IF

   cur_fb_name  = TKNWORD;
   CurrentObjectName = cur_fb_name;

   IF (VERBOSE IS_ON) THEN
      sprintf (MsgBuf, "\n\nProcessing fact block: %.40s.", cur_fb_name);
      SendMessage (MsgBuf,NO);
   END_IF

   /*====================================*/
   /*Check for duplicate fact block name */
   /*====================================*/

   IF (NewFBName (cur_fb_name, FactBlockHead) NEQ YES) THEN
      ErrorMessage (WARNING, "Duplicate deffacts name.");
   END_IF

   /*==============================*/
   /* Create new fact block struct */
   /*==============================*/

   cur_fb       = AllocFactBlock ();                   /* Create new fact block structure */
   temp_hash    = AddSymbol(cur_fb_name);
   cur_fb->name = temp_hash->contents;           /* Store Fact block name in it  */
   temp_hash    = AddSymbol(CurrentFileName);
   cur_fb->file = temp_hash->contents;           /* along with current file name */

   cur_fb->next_block = FactBlockHead;        /* Put this FB at start of list */
   FactBlockHead = cur_fb;                    /* and reset start of list pointer */

   /*==============================*/
   /* Check for fact block comment */
   /*==============================*/

   token = GetToken (CurrentFile);
   IF (token EQ STRING) THEN             /* Fact block has a comment */
      token = GetToken (CurrentFile);       /* so read next token */
   ELSE_IF (CHECK_COMMENTS IS_ON) 
      ErrorMessage (WARNING, "Comment not used.");
   END_IF

   /*==============================*/
   /* Process fact block relations */
   /*==============================*/

   while (token NEQ RPAREN) DO
      IF (token EQ LPAREN) THEN                  /* Should have a ' (' */
         cur_fb->num_facts++;
         rtn = find_simple_relation (DEFFACTS);  /* Find relation name */
         IF ((rtn NEQ ERROR) AND (rtn NEQ RESTART)) THEN
            if(ProcessFBRelation (cur_fb) != OK)        /* Process relation */
              return(RESTART);
         ELSE_IF(rtn EQ RESTART)
           return(rtn);
         END_IF

      ELSE                                      /* Error if not a ' (' */
         ErrorMessage (ERROR, "Check appropriate syntax for deffacts\n");
         return (RESTART);
      END_IF
      token = GetToken (CurrentFile);                /* Get next token */
   END_WHILE

   UserDeffact (cur_fb);                          /* Call user function */
   return (OK);
}

/* ==================================================================== */

/*
 * -------------------------------------------------------------
 *  NAME   :  NewFBName () 
 *
 *  PURPOSE:  This function checks to see if the name of the
 *            current deffacts has been previously used.
 *
 *  INPUTS :  The name of the current deffacts block (char *), 
 *            and a pointer to the list of deffacts (FB_PTR).
 *
 *  RETURNS:  An integer, either YES if this is a new deffacts
 *            name or NO if it is a duplicate.
 *
 *  NOTES  :
 * -------------------------------------------------------------
 */

static int NewFBName (name, list_head) 
char   *name;
FB_PTR  list_head;
{
   FB_PTR temp;

   temp = list_head;
   while (temp NEQ NULL) DO
      IF (strcmp (name, temp->name) EQ 0) THEN
         return (NO);
      ELSE
         temp = temp->next_block;
      END_IF
   END_WHILE

   return (YES);
}

/* ===================================================================
 * =============       Rule Processing Functions       ===============
 * ===================================================================
 */

/* ------------------------------------------------------------------
 *  NAME   :  ProcessRule () 
 *
 *  PURPOSE:  This function reads all information about a
 *            rule and stores it in the appropriate structure.
 *
 *  INPUTS :  None.
 *
 *  RETURNS:  An integer, OK if rule was processed properly, 
 *            ERROR if there was a recoverable syntax error, and
 *            RESTART if there was a gross syntax error which
 *            prevents me from finding the closing paren.
 *
 *  NOTES  :
 * ------------------------------------------------------------------
 */

int ProcessRule () 
{
   int      token, rtn;
   VAR_PTR  temp_var, temp_not_var;
   HASH *temp_hash;

   /*=====================*/
   /* Check for rule name */
   /*=====================*/

   token = GetToken (CurrentFile);

   IF (token NEQ WORD) THEN
      ErrorMessage (ERROR, "Check appropriate syntax for defrule\n");
      return (RESTART);
   END_IF
    
   CurrentObjectName  = TKNWORD;
   if(SearchRule(RuleHead,TKNWORD) != NULL){
     ErrorMessage(WARNING,"Duplication of rule, ignoring the new rule\n");
     return(RESTART);}
   IF (VERBOSE IS_ON) THEN
      sprintf (MsgBuf, "\n\nProcessing rule: %.40s", CurrentObjectName);
      SendMessage (MsgBuf,NO);
   END_IF
   
   /*=================================*/
   /* Check pointer to rule structure */
   /*=================================*/

   CurrentRule = AllocRule();
   CurrentRule->file = CurrentFileName;
   CurrentRule->name = TKNWORD;
   /*===================*/
   /* Check for comment */
   /*===================*/

   token = GetToken (CurrentFile);
   IF (token EQ STRING) THEN /* Rule has a comment */
      temp_hash = AddSymbol(TKNWORD);
      CurrentRule->comment = temp_hash->contents;      /* so read next token */
      token = GetToken (CurrentFile);
   ELSE_IF (CHECK_COMMENTS IS_ON)
      CurrentRule->comment = NULL;
      ErrorMessage (WARNING, "Comment not used.");
   END_IF

   /*=====================*/
   /* Process LHS of rule */
   /*=====================*/

   NegativeVariableHead = NULL;
   rtn = ProcessRuleLHS (CurrentRule, token);
   IF (rtn NEQ OK) THEN
      ReinitializeVar();
      ResetStack();
      FreeVariableInOrPattern(InOrVariableList);
      InOrVariableList = NULL;
      return (rtn);
   END_IF

   /* ============================================================ */
   /*   Check for inconsistency of the negation of the variables   */
   /*   on the LHS of the rule.                                    */
   /* ============================================================ */

    temp_var = VariableHead;
    if (NegativeVariableHead != NULL) 
     {
	    while (temp_var != NULL) 
	     {
	       temp_not_var = NegativeVariableHead;
	       while (temp_not_var != NULL) 
	        {
	          if (strcmp (temp_not_var->var, temp_var->var) == 0) 
	           {
	             rtn = compare_field_info (temp_not_var->field_info, 
	             		temp_var->field_info);
	             if (rtn == TRUE) 
	               {
	                 sprintf (MsgBuf, 
                            "rule <%.40s> may not fire due to the negation of \
variable <%.40s>.", 
	                           CurrentRule->name, temp_not_var->var);
	                 ErrorMessage (WARNING, MsgBuf);
	               }
	           }
	           temp_not_var = temp_not_var->next_variable;
	        }
	       temp_var = temp_var->next_variable;
	     }
	   }
    NegativeVariableHead = NULL;
   /*=============================*/
   /* Initialize nest-level stack */
   /*=============================*/

   ResetStack ();

   /*=====================*/
   /* Process RHS of rule */
   /*=====================*/

   rtn = ProcessRuleRHS (CurrentRule);
   IF (rtn NEQ OK) THEN
      ReinitializeVar();
      ResetStack();
      FreeVariableInOrPattern(InOrVariableList);
      InOrVariableList = NULL;
      return (rtn);
   END_IF
   RuleHead = InsertRule(CurrentRule,RuleHead);
   UserRule (CurrentRule, VariableHead, RetractHead);
   
   /*=====================================*/
   /* Report on variable binding problems */
   /*=====================================*/
   CheckVariables ();
   FreeVariableInOrPattern(InOrVariableList);
   InOrVariableList = NULL;
   return (rtn);
}

/* -------------------------------------------
 *  ReinitializeVar
 * -------------------------------------------
 */
 ReinitializeVar()
 {
      CleanRelations(CurrentRule->name,RelationHead);
      CleanExFunctions(CurrentRule->name,externalFunctionHead);
      FreeRule(CurrentRule);
      CurrentRule = NULL;
      FreeVariable(NegativeVariableHead);
      FreeVariable(VariableHead);
      FreeVariable(RetractHead);
      RetractHead = NULL;
      VariableHead = NULL;
      NegativeVariableHead = NULL;
 }

/* ==================================================================== *
 * compare_field_info
 * This funtion will compare the defintions of two field
 * where the same variable is used
 * Arguments:
 *    fld1,fld2: definitions of two fields
 * Return:
 *  FALSE if found contradiction
 *  TRUE if everything is OK
 * ==================================================================== */
static int compare_field_info (fld1, fld2)  
DEF_FLD *fld1, *fld2;
{
   int type;

   /* ----------------------------------------------------
    *
    *             *****   NOTE  *****
    *
    *   This function has a bug which cannot be fixed as
    *   it is a byproduct of the control mechanism of
    *   CRSV.  fld2 in this function is the field values
    *   of a variable found in a relation.  If this 
    *   relation was created by a template, and the 
    *   field is a multi-field, and the variable is in
    *   a position other than the first, then unless
    *   this multi-field exists in a prior rule in which
    *   the position of the variable had been supplied a
    *   value the variable will have no field values.
    *   If this is the case, fld2 will be <nil> upon
    *   entering this function.  The fix for this will
    *   be to have a condition which will return FALSE
    *   if fld2 is <nil> and return.
    * ----------------------------------------------------
    */

    IF (fld2 IS_NIL) THEN
       return (FALSE);
    END_IF

   if (fld1->allow_word == YES) 
     type = WORD;
   else if (fld1->allow_string == YES) 
     type = STRING;
   else if (fld1->allow_integer == YES) 
     type = INTEGER;
   else if (fld1->allow_float == YES)
     type = FLOAT;
   else if (fld1->allow_instance == YES)
     type = INSTANCE;
   else if (fld1->allow_address == YES)
     type = EXTERNAL_ADDRESS;
   else 
     ErrorMessage (WARNING, " INTERNAL ERROR.");

   switch (type) 
     {
       case WORD:
          if ((fld2->allow_string == YES) || (fld2->allow_integer == YES) ||
              (fld2->allow_float ==   YES) || (fld2->allow_instance == YES) ||
              (fld2->allow_word == NO)) 
             return (FALSE);
          if (fld2->possible_words == NULL) 
             return (FALSE);
          if (fld2->possible_words->next_word != NULL) 
             return (FALSE);
          if (strcmp (fld2->possible_words->word, fld1->possible_words->word) == 0) 
             return (TRUE);
          break;
       case STRING:
          if ((fld2->allow_string == NO) || (fld2->allow_integer == YES) ||
              (fld2->allow_float ==   YES) || (fld2->allow_instance == YES) ||
              (fld2->allow_word == YES)) 
             return (FALSE);
          if (fld2->possible_words == NULL) 
             return (FALSE);
          if (fld2->possible_words->next_word != NULL) 
             return (FALSE);
          if (strcmp (fld2->possible_words->word, fld1->possible_words->word) == 0) 
             return (TRUE);
          break;
       case INTEGER:
          if ((fld2->allow_string == YES) || (fld2->allow_integer == NO) ||
              (fld2->allow_float == YES) ||(fld2->allow_instance == YES) ||
              (fld2->allow_word == YES)) 
             return (FALSE);
          if (fld2->possible_integers == NULL) 
             return (FALSE);
          if (fld2->possible_integers->next_number != NULL) 
             return (FALSE);
          if (fld2->possible_integers->number == fld1->possible_integers->number) 
             return (TRUE);
          break;
       case FLOAT:
       if ((fld2->allow_string == YES) || (fld2->allow_integer == YES) ||
              (fld2->allow_float == NO) ||(fld2->allow_word == YES)||
              (fld2->allow_instance == YES)) 
             return (FALSE);
          if (fld2->possible_floats == NULL) 
             return (FALSE);
          if (fld2->possible_floats->next_number != NULL) 
             return (FALSE);
          if (fld2->possible_floats->number == fld1->possible_floats->number) 
             return (TRUE);
          break;
       case INSTANCE:
        if ((fld2->allow_string == YES) || (fld2->allow_integer == YES) ||
              (fld2->allow_float == YES) ||(fld2->allow_word == YES)||
              (fld2->allow_instance == NO)) 
             return (FALSE);
        if (fld2->possible_instances == NULL) 
             return (FALSE);
        if (fld2->possible_instances->next_word != NULL) 
             return (FALSE);
        if (fld2->possible_instances->word == fld1->possible_instances->word) 
             return (TRUE);
        break;
     }
   return (FALSE);
}

/* ==================================================================== */

/*
 * -------------------------------------------------------------
 *  NAME   :  FindRule() 
 *
 *  PURPOSE:  This function checks to see if the name of the
 *            current rule has been previously used. If it is
 *            a new name, then create a structure for the info, 
 *            and stores it in the proper place in the binary
 *            tree. If it an old name, give warning and use old
 *            structure.
 *
 *  INPUTS :  A pointer to the list of rules (RULE_PTR), 
 *            and the name of the current rule (char *).
 *
 *  RETURNS:  A pointer to the top of the rule binary tree.
 *
 *  NOTES  :  This function is called recursively to process
 *            through the tree. It may add a node to the tree
 *            a therefore always returns the tree root. It
 *            also sets the global variable CurrentRule so I can
 *            modify the current rule structure.
 * -------------------------------------------------------------
 */

RULE *FindRule(node, name) 
RULE_PTR  node;
char     *name;
{
   int rtn;

   IF (node EQ NULL) THEN                       /* A new rule! */
      node       = AllocRule ();
      node->name = name;
      node->file = CurrentFileName;
      CurrentRule   = node;
   ELSE
      rtn = strcmp (name, node->name);
      IF (rtn < 0) THEN
         node->lft_rule = FindRule(node->lft_rule, name);
      ELSE_IF (rtn > 0) 
         node->rht_rule = FindRule(node->rht_rule, name);
      ELSE
         CurrentRule = node;
      END_IF
   END_IF

   return (node);
}

/* ------------------------------------------------------ *
 * InsertRule                                             *
 * This function insert  a rule into the list             *
 * ------------------------------------------------------ */

RULE_PTR InsertRule(node,list)
RULE_PTR node,list;
{
   RULE_PTR RulePtr = NULL,RuleParent = NULL, NewRule;
   int rtn;
   
   if (list == NULL)
     return(node);
   RulePtr = list;
   while(RulePtr != NULL)
    {
       rtn = strcmp(node->name,RulePtr->name);
       if(rtn < 0)
        {
          RuleParent = RulePtr;
          RulePtr = RulePtr->lft_rule;   
        }
       else if(rtn > 0)
        {
          RuleParent = RulePtr;
          RulePtr = RulePtr->rht_rule;   
        }
       else{
         ErrorMessage(ERROR,"CRSV error, in InsertRule, please report this error\n");
         return(list);}
    }
   if(rtn < 0)
      RuleParent->lft_rule = node;
   else if(rtn > 0)
      RuleParent->rht_rule = node;
   else
      ErrorMessage(ERROR,"CRSV error in InsertRule, please report this error\n");
   return(list);
}

/* ================================================
 *  CleanRelations
 * ================================================
 */
 CleanRelations(name,list)
 char *name;
 REL_PTR list;
 {
    if(list == NULL)
      return(OK);
    CleanRelations(name,list->lft_rel);
    list->rule_list    = FreeRuleInList(name,list->rule_list);
    list->retract_list = FreeRuleInList(name,list->retract_list);
    list->assert_list  = FreeRuleInList(name,list->assert_list);
    CleanRelations(name,list->rht_rel);
    
 }
 
 /* ================================================
 *  CleanExFunction
 * ================================================
 */
 CleanExFunctions(name,list)
 char *name;
 EXF_PTR list;
 {
    if(list == NULL)
      return(OK);
    CleanExFunctions(name,list->lft_ex_func);
    list->LHS_rule_list = FreeRuleInList(name,list->LHS_rule_list);
    list->RHS_rule_list = FreeRuleInList(name,list->RHS_rule_list);
    CleanExFunctions(name,list->rht_ex_func);
 
 }
 
 /* ===================================================
  * FreeRuleInList
  * ===================================================
  */
 
 RR_PTR FreeRuleInList(name,list)
 char *name;
 RR_PTR list;
 {
    RR_PTR rules,parent_rule = NULL,head;
    
    head = rules = list;
    parent_rule = NULL;
    while(rules != NULL)
      {
        if(strcmp(name,rules->rule->name) == 0){
          if(parent_rule == NULL)
           {
             head = head->next_rr;
             rules->next_rr = NULL;
             FreeRuleRelation(rules);
             rules = head;
           }
          else
           {
             parent_rule->next_rr = rules->next_rr;
             rules->next_rr = NULL;
             FreeRuleRelation(rules);
             rules = parent_rule->next_rr;
           }
        }
        else
         {
           parent_rule = rules;
           rules = rules->next_rr;
         }
      }
   return(head);
 }
/*
 * -------------------------------------------------------------
 *  NAME   :  SearchRule () 
 *
 *  PURPOSE:  This function checks to see if the rule is in the list
 *  INPUTS :  A pointer to the list of rules (RULE_PTR), 
 *            and the name of the current rule (char *).
 *
 *  RETURNS:  A pointer to the top of the rule binary tree.
 *
 *  NOTES  :  This function is called recursively to process
 *            through the tree.It return the node that contains information
 *	      about the rule. 
 * -------------------------------------------------------------
 */

RULE *SearchRule (node, name) 
RULE_PTR  node;
char     *name;
{
   int rtn;

   IF(node != NULL) THEN
      rtn = strcmp (name, node->name);
      IF (rtn < 0) THEN
         return(SearchRule(node->lft_rule, name));
      ELSE_IF (rtn > 0) 
         return(SearchRule (node->rht_rule, name));
      END_IF
   END_IF

   return (node);
} 


/* ===================================================================
 * ===========      LHS of Rule Processing Functions     =============
 * ===================================================================
 */

/*
 * -------------------------------------------------------------
 *  NAME   :  ProcessRuleLHS () 
 *
 *  PURPOSE:  This function reads and stores all the info which
 *            can be gathered by processing the LHS of a rule.
 *
 *  INPUTS :  A pointer to the current rule structure (RULE_PTR), 
 *            and a pointer to the last token read.
 *
 *  RETURNS:  An integer, OK if rule was processed properly, 
 *            ERROR if there was a recoverable syntax error, and
 *            RESTART if there was a gross syntax error which
 *            prevents me from finding the closing paren.
 *
 *  NOTES  :
 * -------------------------------------------------------------
 */

static int ProcessRuleLHS (current_rule, old_token) 
int      old_token;
RULE_PTR current_rule;
{
   int token ;
   int rtn,pat_num = 1;
   PAT_LIST_PTR temp_pat;
   DG_PTR  global_var = NULL;
   short logical_flag = FALSE,relation_flag = FALSE;

   token = old_token;

   /*==========================*/
   /* Check declare features   */
   /*==========================*/

   IF (token EQ LPAREN) THEN
      token = GetToken (CurrentFile);

      IF ((token EQ WORD) AND (strcmp (TKNWORD, "declare") EQ 0)) THEN
         token = GetToken (CurrentFile);

         IF (token NEQ LPAREN) THEN
            ErrorMessage (ERROR, "Expected a \' (\' following declare.");
            return(RESTART); 
         ELSE

            /*============================*/
            /* Check for salience & value */
            /*============================*/

            token = GetToken (CurrentFile);
            IF ((token EQ WORD) AND (strcmp (TKNWORD, "salience") EQ 0)) THEN
               if((rtn = process_salience(current_rule)) != OK)
                 return(RESTART);
               if(FindRhtParen() != OK)
                return(RESTART);               /* Finish declare  */
            ELSE
              ErrorMessage(ERROR,"Only salience declarations are allowed\n");
              return(RESTART);
            END_IF
           
         token = GetToken (CurrentFile);           /* And get next token */
         END_IF
      ELSE
         SaveToken (token, TKNWORD, FLOATNUMBER,INTNUMBER);
         token     = LPAREN;
         TKNWORD   = "(";
         FLOATNUMBER = 0.00;
         INTNUMBER = 0;
      END_IF
   ELSE_IF ((token NEQ BWORD) AND (token NEQ SEPARATOR)) 
      ErrorMessage (ERROR, "Expected a \' (\' or variable on LHS.");
      return (RESTART);
   END_IF

   /*=====================*/ 
   /* Process rest of LHS */
   /*=====================*/
   CurrentPattern_list = NULL;
   while (token NEQ SEPARATOR) DO
      IF(INFERENCE_TRACE IS_ON) THEN
        CurrentPattern_list = CreateAndLinkPatToList(CurrentPattern_list);
        CurrentPattern->pattern = InsertTokenIntoPattern(CurrentPattern->pattern,TKNWORD,token);
        LHSPattern = TRUE;
      END_IF 
      IF (token EQ LPAREN) THEN
         token = GetToken(CurrentFile);
         if((token == WORD) AND (strcmp(TKNWORD,"logical") == 0))
          {
            if((logical_flag) && (relation_flag)){
              ErrorMessage(ERROR,"Gaps may not exists between logical CEs\n");
              return(RESTART);}
            else if ((relation_flag) && (!logical_flag)){
              ErrorMessage(ERROR,"Logical CEs must be placed first in rule \n");
              return(RESTART);
              }
            if(process_logical(current_rule,&pat_num) != OK)
               return(RESTART);
            logical_flag = TRUE;
          }
         else{
           SaveToken (token, TKNWORD, FLOATNUMBER,INTNUMBER);
           rtn = RuleFindRelation (current_rule, NO, NO,NO);
           IF (rtn EQ RESTART) THEN
             return (RESTART);
           END_IF
           relation_flag = TRUE;
           }
      ELSE_IF (token EQ BWORD) 
         rtn = ProcessLHSRetract (current_rule, NO);
         IF (rtn EQ RESTART) THEN
            return (RESTART);
         END_IF
         rtn = RuleFindRelation (current_rule, YES, NO, NO);
         IF (rtn EQ RESTART) THEN
            return (RESTART);
         END_IF
         relation_flag = TRUE;
      ELSE
         ErrorMessage (ERROR, "Expected a \' (\' or variable on LHS.");
         return (RESTART);
      END_IF
      IF(INFERENCE_TRACE IS_ON) THEN
         CurrentPattern->num = pat_num++;
         LHSPattern = FALSE;
      END_IF
      token = GetToken (CurrentFile);
   END_WHILE
   CurrentRule->lhs_patterns = CurrentPattern_list;
   return (OK);
}


/*==================================================
 *  Process the salience value of a rule
 *==================================================
 */
int process_salience(current_rule)
RULE_PTR current_rule;
{
   int token,rtn;
   DG_PTR global_var = NULL;
   
       current_rule->salience_set = YES;
       token = GetToken (CurrentFile);
       IF (token EQ RPAREN) THEN
         ErrorMessage (ERROR, "Forgot to include salience value!");
         return(RESTART);
       ELSE_IF (token EQ LPAREN)
         IF(((rtn = ProcessExpression()) != INTEGER) && (rtn != UNKNOWN))THEN
            ErrorMessage (ERROR, "Salience value must be an integer value\n");
            SendMessage("        but expression returns a non-integer value \n",NO);
            return(RESTART);
         END_IF
         IF(rtn == UNKNOWN)THEN
            ErrorMessage (WARNING, "type of the salience value is UNKNOWN,\n");
            SendMessage("        assumed INTEGER \n",NO);
         END_IF
         
       ELSE_IF (token EQ GLOBAL)
        IF((global_var = FinfDefglobal(DefglobalHead,TKNWORD)) == NULL)THEN
            sprintf(MsgBuf,"?%s is not defined \n",TKNWORD);
            ErrorMessage(ERROR,MsgBuf);
            return(RESTART);
        ELSE_IF(global_var->type != INTEGER)
            current_rule->salience_val = 0;
            ErrorMessage (ERROR, "Salience value must be an integer value\n");
            SendMessage("         but global value is non-integer \n",NO);
            return(RESTART);
        END_IF
       ELSE_IF (token EQ INTEGER)
         if((INTNUMBER > 10000) OR (INTNUMBER < -10000))
          {
             ErrorMessage(ERROR,"Salience value is out of range -10000 too 10000\n");
             return(RESTART);
          }
         current_rule->salience_val = (int)INTNUMBER;
       ELSE
         current_rule->salience_val = 0;
         ErrorMessage (ERROR, "Salience value must be an integer value\n");
         return(RESTART);
       END_IF
       if(FindRhtParen() != OK)
           return(ERROR);
       return(OK);
}

/*==================================================
 * Process the logical pattern
 *==================================================
 */

int process_logical(current_rule,pat_num)
RULE_PTR current_rule;
int *pat_num;
{
   int token;
   
   token = GetToken(CurrentFile);
   if((token == RPAREN) OR ( token == STOP))
    {
      ErrorMessage(ERROR,"No Patterns within logical conditional element\n");
      return(RESTART);
    }
   WHILE((token != RPAREN) AND (token != STOP)) DO
      IF(INFERENCE_TRACE IS_ON) THEN
        CurrentPattern_list = CreateAndLinkPatToList(CurrentPattern_list);
        CurrentPattern->pattern = InsertTokenIntoPattern(CurrentPattern->pattern,TKNWORD,token);
        LHSPattern = TRUE;
      END_IF
      IF (token EQ LPAREN) THEN
         if(RuleFindRelation (current_rule, NO, NO,NO) != OK)
            return (RESTART);
      ELSE_IF (token EQ BWORD) 
         if(ProcessLHSRetract (current_rule, NO) != OK)
            return (RESTART);
         if(RuleFindRelation (current_rule, YES, NO, NO) != OK)
            return (RESTART);
      ELSE
         ErrorMessage (ERROR, "Expected a \' (\' or variable on LHS.");
         return (RESTART);
      END_IF
      IF(INFERENCE_TRACE IS_ON) THEN
         CurrentPattern->num = (*pat_num)++;
         LHSPattern = FALSE;
      END_IF
      token = GetToken(CurrentFile);
    END_WHILE
      return(OK);
}

/* ===================================================================
 * ===========      RHS of Rule Processing Functions     =============
 * ===================================================================
 */

/*
 * -------------------------------------------------------------
 *  NAME   :  ProcessRuleRHS () 
 *
 *  PURPOSE:  This function reads and stores all the info which
 *            can be gathered by processing the RHS of a rule.
 *
 *  INPUTS :  A pointer to the current rule structure (RULE_PTR), 
 *            and an integer which specifies whether or not
 *            you are currently in an if statement.
 *
 *  RETURNS:  An integer, OK if rule was processed properly, 
 *            ERROR if there was a recoverable syntax error, and
 *            RESTART if there was a gross syntax error which
 *            prevents me from finding the closing paren.
 *
 *  NOTES  :  This function can be called recursively for each
 *            level of if or while nesting on the RHS of the
 *            rule.
 *            This function really needs to be cleaned up so
 *            that it does a better job of handling errors. The
 *            process_XX functions need to be fixed to return
 *            values which can be checked for RESTART, and
 *            this function also needs to return RESTART.
 * -------------------------------------------------------------
 */

static int ProcessRuleRHS (current_rule) 
RULE_PTR  current_rule;
{
   int token;
   int func_rtn;  /* This is useless in this function */

   token = GetToken (CurrentFile);

   while (token NEQ RPAREN) DO

      /*===========================*/
      /* Check for opening paren   */
      /*===========================*/

      IF (token NEQ LPAREN) THEN
         IF (InsideIf ()) THEN
            IF (strcmp (TKNWORD, "else") EQ 0) THEN

               /*===============================*/
               /*  Update the nest-level stack  */
               /*===============================*/

               Push (_else_);
            ELSE
               ErrorMessage (ERROR, "Invalid entry inside an if.");
               return(ERROR);
            END_IF
         ELSE_IF (token EQ STOP) 
            ErrorMessage (ERROR, "Missing closing right paren.");
            return (RESTART);
         ELSE
            ErrorMessage (ERROR, "Expecting an \' (\' on RHS of rule.");
            return(RESTART);
         END_IF

      ELSE
         token = GetToken (CurrentFile);
         current_rule->num_actions++;

         /*===================*/
         /* Check for assert  */
         /*===================*/

         IF (strcmp (TKNWORD, "assert") EQ 0) THEN
            current_rule->num_asserts++;
            if(process_assert (current_rule, ASSERT) != OK)
              return(RESTART);

         /*======================*/
         /* Check for load-facts */
         /*======================*/

         ELSE_IF (strcmp (TKNWORD, "load-facts") EQ 0) 
            current_rule->num_asserts++;
            ErrorMessage (WARNING, 
                "load-facts used, assertion lists may be incomplete.");
            if(FindBoundWords (RHS, NO, NO,NO,NO) != OK)
              return(RESTART);

         /*===================*/
         /* Check for retract */
         /*===================*/

         ELSE_IF (strcmp (TKNWORD, "retract") EQ 0) 
            current_rule->num_retracts++;
            if(ProcessRHSRetract (current_rule, NO) != OK)
             return(RESTART);

         /*======================*/
         /* Check for modify     */
         /*======================*/

         ELSE_IF (strcmp (TKNWORD, "modify") EQ 0) 
            current_rule->num_asserts++;
            current_rule->num_retracts++;
            if(ProcessRHSModify (current_rule) != OK)
              return(RESTART);
         ELSE_IF (strcmp (TKNWORD,"duplicate") EQ 0)
            current_rule->num_asserts++;
            if(process_RHS_duplicate(CurrentRule) != OK)
              return(RESTART);

         /*======================*/
         /* Check for if         */
         /*======================*/

         ELSE_IF (strcmp (TKNWORD, "if") EQ 0) 
            current_rule->num_ifs++;
            current_rule->num_actions--;
            if(process_if (current_rule) != OK)
             return(RESTART);

         /*======================*/
         /* Check for while      */
         /*======================*/

         ELSE_IF (strcmp (TKNWORD, "while") EQ 0) 
            current_rule->num_whiles++;
            current_rule->num_actions--;
            if(process_while (current_rule) != OK)
             return(RESTART);

         /*=========================*/
         /* Check for string assert */
         /*=========================*/

         ELSE_IF ((strcmp (TKNWORD, "string_assert") EQ 0) OR
                 (strcmp (TKNWORD, "str_assert") EQ 0)) 
            current_rule->num_asserts++;
            ErrorMessage (WARNING, 
                 "str_assert used, assertion lists may be incomplete.");
            if(FindBoundWords (RHS, NO, NO, NO,NO) == RESTART)
              return(RESTART);

         
         /*================*/
         /* Check for bind */
         /*================*/

         ELSE_IF (strcmp (TKNWORD, "bind") EQ 0) 
            current_rule->num_actions++;
            if(process_bind (current_rule) != OK)
              return(RESTART);
                        
         /*==============================*/
         /* Check for external functions */
         /*==============================*/
         

         ELSE_IF ((token EQ WORD) AND (CheckExternalFuncs (TKNWORD,&func_rtn) IS_NO))
              current_rule->num_ex_funcs++;
              if(ProcessExternalFunction (current_rule, TKNWORD, RHS,0, NO) == RESTART)
                return(RESTART);
         ELSE_IF ((token EQ WORD) AND (CheckExternalFuncs (TKNWORD,&func_rtn) IS_YES))
            if(AInstanceQueryFunction(TKNWORD) == YES)
              {
               if(!FindRhtParen())
                 return(RESTART);
              }
            if(FindBoundWords (RHS, NO, NO, NO,NO) == RESTART)
              return(RESTART);
         ELSE
            ErrorMessage(ERROR,"Expected a constant, variable, or an expression\n");
            return(RESTART);
         END_IF
      END_IF
      token = GetToken (CurrentFile);
   END_WHILE

   return (OK);
}


/*
 * -------------------------------------------------------------
 *  NAME   :  FindBoundWords () 
 *
 *  PURPOSE:  This function searches pattern fields and action
 *            arguments looking for variables. If it finds them
 *            it calls the appropriate function to store the
 *            information.
 *
 *  INPUTS :  Two arguments, 
 *             A flag telling what side of rule this was called
 *               from (RHS or LHS) (int), and
 *             A flag telling if function was called from inside
 *               a not pattern (YES or NO) (int).
 *             A flag telling if function was called from inside
 *		       an or pattern.
 *             A flag telling if first field of the relation was variable
 *             A flag telling if it is call while processing relation or function
 *  RETURNS:   RETART if it found syntax error.
 *
 *  NOTES  :
 * -------------------------------------------------------------
 */

int FindBoundWords (side_of_rule, in_not,in_or,first_field_var,is_rel) 
int side_of_rule, in_not,in_or, first_field_var,is_rel;
{
   int  token, all_var,field_num = 2,
			after_and = NO;
   int  count,func_rtn;        /* func_rtn is dummy in this function */

   count = 1;

   IF (first_field_var EQ YES) THEN
      all_var = YES;
   ELSE
      all_var = NO;
   END_IF
   WHILE(count) DO
      token = GetToken (CurrentFile);
      switch(token) DO
       case  LPAREN:
         token = GetToken (CurrentFile);
         IF(token NEQ WORD) THEN
             ErrorMessage(ERROR,
                 "A function name must be a SYMBOL\n");
             return(RESTART);
         ELSE_IF(CheckExternalFuncs (TKNWORD,&func_rtn) IS_NO)
            CurrentRule->num_ex_funcs++;
            if((side_of_rule EQ GLOBAL) OR (side_of_rule EQ FB)){
              if(ProcessExternalFunction (CurrentRule, TKNWORD, side_of_rule,in_not,in_or) == RESTART)
                return(RESTART);}
            else{
              if(ProcessExternalFunction (CurrentRule, TKNWORD, LHS,in_not,in_or) == RESTART)
                return(RESTART);}
         ELSE
            if(AInstanceQueryFunction(TKNWORD) == YES)
              if(!FindRhtParen())
                return(RESTART);
            if(FindBoundWords(RHS,in_not,in_or,NO,NO) != OK)
              return(RESTART);
         END_IF
         break;
      case RPAREN:
         count--;
	 		break;
      case BWORD:
      case BWORDS:
         IF((first_field_var)&&(LHSPattern)&&(!after_and)) THEN
           CurrentTokenInPattern->num = field_num++;
         ELSE
           after_and = NO;
         END_IF
         IF ((side_of_rule EQ GLOBAL) OR (side_of_rule EQ FB)) THEN
           ErrorMessage(ERROR,"Variables cannot be accessed by a deffacts/defglobal construct \n");
           return(RESTART);
         ELSE_IF (side_of_rule EQ RHS)
           if(ProcessRHSVariable (NULL,NULL,token, 0, in_not,in_or,0, NULL) != OK)
             return(RESTART);
         ELSE_IF (side_of_rule EQ LHS) 
           if(ProcessLHSVariable (CurrentRule,NULL, NULL, token, 0, NO, 
                      in_not,in_or,0, NO) != OK)
             return(RESTART);
         END_IF
         break;
      case SINGLE:
      case  MULTIPLE:
         IF((first_field_var)&&(LHSPattern)&&(!after_and))THEN
           CurrentTokenInPattern->num = field_num++;
         ELSE
           after_and = NO;
         END_IF
         IF ((side_of_rule EQ GLOBAL) OR (side_of_rule EQ FB)) THEN
           ErrorMessage(ERROR,"Variables cannot be accessed by a deffacts/defglobal construct \n");
           return(RESTART);
         ELSE_IF (side_of_rule EQ RHS)
            ErrorMessage (ERROR, "Wildcard used in an inappropriate place.");
         END_IF
         break;
      case LAND:
         after_and = YES;
         break;
      case WORD:
         IF((strcmp(TKNWORD,"=") != 0) AND (strcmp(TKNWORD,":") != 0)) THEN
           IF((first_field_var)&&(LHSPattern)&&(!after_and))THEN
             field_num++;
           ELSE
             after_and = NO;
           END_IF
         ELSE
           token = GetToken (CurrentFile);
           IF(token NEQ LPAREN) THEN
             ErrorMessage(ERROR,"Expected an expression \n");
             return(RESTART);
           ELSE
             token = GetToken(CurrentFile);
             IF(token != WORD)THEN
               ErrorMessage(ERROR,"A Function name must be a SYMBOL\n");
               return(RESTART);
             ELSE_IF(CheckExternalFuncs (TKNWORD,&func_rtn) IS_NO)
               CurrentRule->num_ex_funcs++;
              if((side_of_rule EQ GLOBAL) OR (side_of_rule EQ FB)){
                 if(ProcessExternalFunction (CurrentRule, TKNWORD, side_of_rule,in_not,in_or) == RESTART)
                   return(RESTART);}
              else{
                if(ProcessExternalFunction (CurrentRule, TKNWORD, LHS,in_not,in_or) == RESTART)
                   return(RESTART);}
             ELSE
                 if(AInstanceQueryFunction(TKNWORD) == YES)
                   if(!FindRhtParen())
                      return(RESTART);
                 if(FindBoundWords(RHS,in_not,in_or,NO,NO) != OK)
                     return(RESTART);
             END_IF
           END_IF
         END_IF
         all_var = NO;
         break;
      case GLOBAL:
         IF (FinfDefglobal(DefglobalHead,TKNWORD) == NULL)THEN
             sprintf(MsgBuf,"?%s is not defined \n",TKNWORD);
             ErrorMessage(ERROR,MsgBuf);
             return(RESTART);
         END_IF
         IF((first_field_var)&&(LHSPattern)&&(!after_and))THEN
             field_num++;
         ELSE
             after_and = NO;
         END_IF
             all_var = NO;
         break;
      case STRING:
      case INTEGER:
      case FLOAT :
      case INSTANCE:
         IF((first_field_var)&&(LHSPattern)&&(!after_and))THEN
           field_num++;
         ELSE
           after_and = NO;
         END_IF
         all_var = NO;
         break;
      case STOP:
         count = 0;
         break;
      default:
         if(!is_rel){
         ErrorMessage(ERROR,"Expected a constant, a variable or an expression\n");
         return(RESTART);}
         else
          break;
      DONE

   END_WHILE

   IF (all_var EQ YES) THEN
      ErrorMessage (WARNING, "Pattern contains all variables!");
   END_IF
   return(OK);
}

/* ==================================================================== */

/*
 * -------------------------------------------------------------
 *  NAME   :  process_assert () 
 *
 *  PURPOSE:  This function is called everytime an assert
 *            is found on the RHS of a rule. It stores the
 *            appropriate info about the relation (s) being
 *            asserted and handles any variables found.
 *
 *  INPUTS :  A pointer to the current rule (RULE_PTR). A flag
 *            indicating if the retract is an explicit statement
 *            or implied by a modify statement.
 *
 *  RETURNS:  An integer, OK if the assert was processed without
 *            problems, ERROR if a syntax error is found.
 * ------------------------------------------------------------
 */

static int process_assert (current_rule, implied) 
RULE_PTR current_rule;
int implied;
{
   char     *CurrentRelation_name;
   RR_PTR    temp_rr;
   int       rtn;
   int       token;
   short    is_template = NO;
   char     *statement;
   char     *action;

   switch(implied) {
     case ASSERT :
          statement = "an assert";
          action = "asserted";
          break;
     case MODIFY :
         statement = "a modify";
         action = "modified";
         break;
     case DUPLICATE :
         statement = "an duplicate";
         action = "duplicated";
         break;
     }
   token = GetToken (CurrentFile);

   IF (token NEQ LPAREN) THEN
      sprintf (MsgBuf, "At least one fact must be %s.", action);
      ErrorMessage (ERROR, MsgBuf);
      return(RESTART);
   END_IF

   LOOP
      rtn = find_simple_relation (ASSERT);

      IF ((rtn NEQ ERROR) && (rtn NEQ RESTART)) THEN
         CurrentRelation_name  = TKNWORD;
         IF (FindDeftemplate (DeftemplateHead, CurrentRelation_name)) THEN
            if(TemplateFormatToRelationFormat (CurrentRelation_name, YES,NULL) != OK)
              return(RESTART);
            is_template = YES;
         ELSE_IF((token = GetToken(CurrentFile)) == LPAREN)
           sprintf(MsgBuf,"Deftemplate <%s> is not defined,\n        or illegal left parenthesis after relation %s \n",
           					CurrentRelation_name,CurrentRelation_name);
           ErrorMessage(ERROR,MsgBuf);
           SaveToken (token, TKNWORD, FLOATNUMBER,INTNUMBER);
           return(RESTART);
         ELSE
           SaveToken(token,TKNWORD,FLOATNUMBER,INTNUMBER);
         END_IF
         RelationHead = FindCreateRelation (RelationHead, CurrentRelation_name);
         temp_rr              = AllocRuleRelation ();
         if(find_fields (&(temp_rr->num_fields),CurrentRelation,RHS, NO,NO, NULL, NO) != OK)
          {
           FreeRuleRelation(temp_rr);
           return(RESTART);
          }
         temp_rr->rule        = current_rule;
         temp_rr->next_rr     = CurrentRelation->assert_list;
         CurrentRelation->assert_list = temp_rr;
         CurrentRelation->is_template = is_template;

         IF (CHECK_DEFRELS IS_ON) THEN
            CheckMinNumOfFields (CurrentRelation->name, temp_rr->num_fields, YES);
         END_IF
      ELSE_IF(rtn EQ RESTART)
       return(rtn);
      END_IF
   UNTIL ((implied == MODIFY) OR (implied == DUPLICATE) 
          OR ((token = GetToken (CurrentFile)) NEQ LPAREN));

   IF ((implied == ASSERT) AND (token NEQ RPAREN)) THEN
      sprintf ("Expected a \') \' to close %s.", statement);
      ErrorMessage (ERROR, MsgBuf);
      return (RESTART);
   END_IF

   return (OK);
}

/* ==================================================================== */

/*
 * -------------------------------------------------------------
 *  NAME   :  process_if () 
 *
 *  PURPOSE:  This function is called everytime an if
 *            is found on the RHS of a rule. It stores the
 *            appropriate info and handles any variables found.
 *
 *  INPUTS :  A pointer to the current rule (RULE *).
 *
 *  RETURNS:  An integer, OK if the if was processed without
 *            problems, ERROR if a syntax error is found.
 *
 *  NOTES  :  Recursively calls ProcessRuleRHS () 
 * -------------------------------------------------------------
 */

static int process_if (current_rule) 
RULE_PTR current_rule;
{
   int  token;
   int  rtn;
   int  nest_level;

   /*===============================*/
   /*  Update the nest-level stack  */
   /*===============================*/

   Push (_if_);
   IF ((nest_level = NumberOfNestLevels (_if_)) > 2) THEN
      sprintf (MsgBuf, "%d levels of nested if's.", nest_level);
      ErrorMessage (WARNING, MsgBuf);
   END_IF

   /*===================*/
   /*  Get a new token  */
   /*===================*/

   token = GetToken (CurrentFile);

   

   /*=================================*/
   /*  Otherwise, process if actions  */
   /*=================================*/

   IF (token EQ LPAREN) THEN
      /*============================*/
      /*  Process the function call */
      /*============================*/

      token = GetToken (CurrentFile);
      IF(token != WORD)THEN
           ErrorMessage(ERROR," A function name must be a SYMBOL\n");
           return(RESTART);
      ELSE_IF(CheckExternalFuncs (TKNWORD,&rtn) IS_NO)
            CurrentRule->num_ex_funcs++;
            if(ProcessExternalFunction (CurrentRule, TKNWORD, RHS,NO,NO) == RESTART)
                return(RESTART);
      ELSE
         if(AInstanceQueryFunction(TKNWORD) == YES)
              if(!FindRhtParen())
                return(RESTART);
         if(FindBoundWords (RHS, NO, NO, NO,NO) == RESTART)
           return(RESTART); 
      END_IF
    END_IF 
      /*=================*/
      /*  Find the then  */
      /*=================*/

    token = GetToken (CurrentFile);
    IF ((token EQ WORD) AND (strcmp (TKNWORD, "then") EQ 0)) THEN
         rtn = ProcessRuleRHS (current_rule);

         /*===============================*/
         /*  Update the nest-level stack  */
         /*===============================*/

         Pop ();
         return (rtn);
    ELSE
         ErrorMessage (ERROR, "Check appropriate syntax for if function\n");
         return(RESTART);
    END_IF

}

/* ==================================================================== */

/*
 * -------------------------------------------------------------
 *  NAME   :  process_while () 
 *
 *  PURPOSE:  This function is called everytime a while
 *            is found on the RHS of a rule. It stores the
 *            appropriate info and handles any variables found.
 *
 *  INPUTS :  A pointer to the current rule (RULEPTR).
 *
 *  RETURNS:  An integer, OK if the while was processed without
 *            problems, ERROR if a syntax error is found.
 *
 *  NOTES  :  Recursively call ProcessRuleRHS
 * -------------------------------------------------------------
 */

static int process_while (current_rule) 
RULE_PTR current_rule;
{
   int  token;
   int  rtn;
   int  nest_level;

   /*===============================*/
   /*  Update the nest-level stack  */
   /*===============================*/

   Push (_while_);
   IF ((nest_level = NumberOfNestLevels (_while_)) > 1) THEN
      sprintf (MsgBuf, "%d levels of nested while's.", nest_level);
      ErrorMessage (WARNING, MsgBuf);
   END_IF

   /*===================*/
   /*  Get a new token  */
   /*===================*/

   token = GetToken (CurrentFile);

   /*====================*/
   /*  Error if not a (  */
   /*====================*/

   IF (token EQ LPAREN) THEN
      
     /*=============================*/
      /* Process comparison function */
      /*=============================*/

      token = GetToken (CurrentFile);
      if(FindBoundWords (RHS, NO, NO, NO,NO) == RESTART)
        return(RESTART);
   
   END_IF
      /*====================================*/
      /*  Otherwise, process while actions  */
      /*====================================*/
      /*=================*/
      /*  Optional 'do'  */
      /*=================*/

   token = GetToken (CurrentFile);
   IF ( NOT ((token EQ WORD) AND (strcmp (TKNWORD, "do") EQ 0)) ) THEN
      SaveToken (token, TKNWORD, FLOATNUMBER,INTNUMBER);
   END_IF

   rtn = ProcessRuleRHS (current_rule);

   /*===============================*/
   /*  Update the nest-level stack  */
   /*===============================*/

   Pop ();
   return (rtn);
}

/* ==================================================================== */

/*
 * -------------------------------------------------------------
 *  NAME   :  process_bind () 
 *
 *  PURPOSE:  This function is called every time a bind
 *            is found on the RHS of a rule. It stores the
 *            appropriate info and handles any variables found.
 *
 *  INPUTS :  A pointer to the current rule (RULE *).
 *
 *  RETURNS:  An integer, OK if the bind was processed without
 *            problems, ERROR if a syntax error is found.
 *
 *  NOTES  :
 * -------------------------------------------------------------
 */

/*ARGSUSED*/ /* Make lint happy */
static int process_bind (current_rule) 
RULE_PTR current_rule;
{
   int token;
   int rtn_type; /* Dummy variable */
	
   /*===========================================*/
   /*  First get binding variable and store it  */
   /*===========================================*/

   token = GetToken (CurrentFile);

   IF ((token NEQ BWORD) AND ( token != GLOBAL) AND (token != BWORDS))THEN
      ErrorMessage (ERROR, "Must use a variable inside a bind operation.");
      return(RESTART);
   END_IF
   IF(token EQ GLOBAL)THEN
      IF(FinfDefglobal(DefglobalHead,TKNWORD) == NULL)THEN
            sprintf(MsgBuf,"global variable %s is used, but not defined\n");
            ErrorMessage(ERROR,MsgBuf);
            return(RESTART);
      END_IF
   ELSE_IF(token == BWORD)
     if(ProcessLHSVariable (current_rule,NULL, NULL, BWORD, 0, YES, NO,NO,0, NO) != OK)
       return(RESTART);
   ELSE
     if(ProcessLHSVariable (current_rule,NULL, NULL, BWORDS, 0, YES, NO,NO,0, NO) != OK)
      return(RESTART);
   END_IF

   /*==========================================*/
   /*  Then process any remaining bound words  */
   /*==========================================*/

   token = GetToken (CurrentFile);

   IF (token EQ LPAREN) THEN
      token = GetToken (CurrentFile);
      IF(token != WORD)THEN
           ErrorMessage(ERROR," A function name must be a SYMBOL\n");
           return(RESTART);
      ELSE_IF(CheckExternalFuncs (TKNWORD,&rtn_type) IS_NO)
            CurrentRule->num_ex_funcs++;
            if(ProcessExternalFunction (CurrentRule, TKNWORD, LHS,NO,NO) == RESTART)
              return(RESTART);
      ELSE
         if(AInstanceQueryFunction(TKNWORD) == YES)
              if(!FindRhtParen())
                return(RESTART);
         if(FindBoundWords (RHS, NO, NO, NO,NO) == RESTART)
           return(RESTART); 
      END_IF
      if(FindRhtParen () == RESTART)
        return(RESTART);
   ELSE
      if(FindBoundWords (RHS, NO, NO, NO,NO) == RESTART)
        return(RESTART);;
   END_IF
   return (OK);
}

/* ==================================================================== */

/*
 * -------------------------------------------------------------
 *  NAME   :  ProcessExternalFunction () 
 *
 *  PURPOSE:  This function is called everytime an external
 *            function is found in a rule, both RHS and LHS.
 *
 *  INPUTS : 
 *            A pointer to the current rule (RULE *), 
 *            the name of the function (char *), and
 *            the side of the rule where it is called (int).
 *
 *  RETURNS:  An integer, currently always returns OK.
 * -------------------------------------------------------------
 */

int ProcessExternalFunction ( current_rule, func_name, side_of_rule,in_not,
									in_or)
RULE *current_rule;
char *func_name;
int   side_of_rule;
int   in_not,in_or;
{
   RR_PTR temp_rr = NULL;
   DGPTR  temp_dg = NULL;
   int num_args;

   externalFunctionHead = FindCreateExternalFunction (externalFunctionHead, func_name);
   IF((side_of_rule != GLOBAL) && (side_of_rule != FB))THEN
       temp_rr        = AllocRuleRelation ();
       temp_rr->rule  = current_rule;
   ELSE_IF (side_of_rule == GLOBAL)
       temp_dg = AllocDefglobalPtr();
       temp_dg->defglobal_list = (DG_PTR)current_rule;
   END_IF
     
   IF (side_of_rule EQ GLOBAL) THEN
      temp_dg->next = CurrentExtFunc->global_list;
      CurrentExtFunc->global_list = temp_dg;
   ELSE_IF (side_of_rule EQ LHS)
      temp_rr->next_rr           = CurrentExtFunc->LHS_rule_list;
      CurrentExtFunc->LHS_rule_list = temp_rr;
   ELSE_IF(side_of_rule EQ RHS)
      temp_rr->next_rr           = CurrentExtFunc->RHS_rule_list;
      CurrentExtFunc->RHS_rule_list = temp_rr;
   END_IF
   if(FindArguments (&num_args, CurrentExtFunc, side_of_rule,in_not,in_or) == RESTART)
    {
      IF (side_of_rule EQ GLOBAL) THEN
        temp_dg = CurrentExtFunc->global_list;
        CurrentExtFunc->global_list = CurrentExtFunc->global_list->next;
        temp_dg->next = NULL;
        FreeDefglobalPtr(temp_dg);
      ELSE_IF (side_of_rule EQ LHS)
        temp_rr = CurrentExtFunc->LHS_rule_list;
        CurrentExtFunc->LHS_rule_list = CurrentExtFunc->LHS_rule_list->next_rr;
        temp_rr->next_rr = NULL;
        FreeRuleRelation(temp_rr);
      ELSE_IF(side_of_rule EQ RHS)
        temp_rr  = CurrentExtFunc->RHS_rule_list;
        CurrentExtFunc->RHS_rule_list = CurrentExtFunc->RHS_rule_list->next_rr;
        temp_rr->next_rr = NULL;
        FreeRuleRelation(temp_rr);
      END_IF
      return(RESTART);
    }
   if(temp_rr != NULL)
     temp_rr->num_fields = num_args;
   return(OK);
}

/* ==================================================================== */

/*
 * -------------------------------------------------------------
 *  NAME   :  FindCreateExternalFunctions () 
 *
 *  PURPOSE:  Works similarly to FindCreateRelation (), this function
 *            updates the binary tree to hold a new external
 *            function or finds its position in the tree if it
 *            is NOT a new function.
 *
 *  INPUTS :  A pointer to the head node (initially) (EXF_PTR), and
 *            the name of the function (char *).
 *
 *  RETURNS:  A pointer to the head node.
 *
 *  NOTES  :  Recursive, sets a global pointer (current_ex_func) to
 *            point to the node containing the current function
 *            when it is either found or created.
 * -------------------------------------------------------------
 */

static EXF_PTR FindCreateExternalFunction (node, func_name) 
   EXF_PTR  node;
   char    *func_name;
{
   int rtn;

   IF (node EQ NULL) THEN        /* A new external function! */
      node        = AllocExternalFunction ();
      node->name  = func_name;
      CurrentExtFunc = node;
   ELSE
      rtn = strcmp (func_name, node->name);
      IF (rtn < 0) THEN
         node->lft_ex_func = FindCreateExternalFunction (node->lft_ex_func, func_name);
      ELSE_IF (rtn > 0) 
         node->rht_ex_func = FindCreateExternalFunction (node->rht_ex_func, func_name);
      ELSE
         CurrentExtFunc   = node;
      END_IF
   END_IF
   return (node);
}

/* ==================================================================== */

/*
 * -------------------------------------------------------------
 *  NAME   :  FindArguments () 
 *
 *  PURPOSE:  Corresponds to find_arguments () for relations, this
 *            function processes the arguments of an external
 *            function call.
 *
 *  INPUTS :  A pointer to the current external function (EXF_PTR), 
 *            and the side of the rule where the function was found (int).
 *
 *  RETURNS:  The number of arguments.
 *
 *  NOTES  :  The number of arguments is counted differently than
 *            the number of fields in a relation, because the
 *            relation name is counted as a field, but the function
 *            name is NOT counted as an argument.
 * -------------------------------------------------------------
 */

static int FindArguments (num_args, current_ex_func, side_of_rule,in_not,
							in_or) 
EXF_PTR current_ex_func;
int     side_of_rule;
int    *num_args;
int     in_not,in_or;
{
   int token,func_rtn,error_found = FALSE;
   DE_PTR def_ex_func;
   DG_PTR global_ptr;
   /*======================*/
   /* Initialize variables */
   /*======================*/

    token       = GetToken (CurrentFile);
   *num_args     = 0;

   while ((token NEQ RPAREN) && (token NEQ STOP)) DO
      switch (token) DO
         case SINGLE:
         case MULTIPLE:
               (*num_args) ++;
               IF((side_of_rule != GLOBAL) AND (side_of_rule != FB))THEN
                  ErrorMessage (ERROR, "Wildcard used in an inappropriate place.");
               ELSE
                  ErrorMessage(ERROR,"Variables cannot be accessed by a deffacts/defglobal construct \n");
                  return(RESTART);
               END_IF
               error_found = TRUE;
            break;

         case BWORD:
            (*num_args) ++;
            IF ((side_of_rule EQ GLOBAL) OR (side_of_rule EQ FB))THEN
                ErrorMessage(ERROR,"Variables cannot be accessed by a deffacts/defglobal construct \n");
                return(RESTART);
            ELSE_IF (side_of_rule EQ LHS)
               if(ProcessLHSVariable (CurrentRule,NULL, current_ex_func, BWORD, *num_args, 
                  NO, in_not,in_or, FUNCTION, NO) != OK)
                  return(RESTART);
            ELSE_IF (side_of_rule EQ RHS) 
               if(ProcessRHSVariable (CurrentRelation,current_ex_func,BWORD, *num_args, 
               		in_not,in_or, FUNCTION,NULL) != OK)
                 return(RESTART);
            END_IF
            break;

         case BWORDS:
            (*num_args) ++;
            IF ((side_of_rule EQ GLOBAL) OR (side_of_rule EQ FB))THEN
                ErrorMessage(ERROR,"Variables cannot be accessed by a deffacts/defglobal construct \n");
                return(RESTART);
            ELSE_IF (side_of_rule EQ LHS)
               if(ProcessLHSVariable (CurrentRule,NULL, current_ex_func, BWORDS, 0, NO, in_not,in_or, 
                        FUNCTION, NO) != OK)
                return(RESTART);
            ELSE_IF (side_of_rule EQ RHS) 
               if(ProcessRHSVariable (CurrentRelation,current_ex_func,BWORDS, 0, in_not,in_or, 
               		FUNCTION,NULL) != OK)
                return(RESTART);
            END_IF
            break;

         case LPAREN:
               token = GetToken (CurrentFile);
               IF(token != WORD)THEN
                   ErrorMessage(ERROR," A function name must be a SYMBOL\n");
                   return(RESTART);
               ELSE_IF (CheckExternalFuncs (TKNWORD,&func_rtn) IS_NO)
                  CurrentRule->num_ex_funcs++;
                  if((side_of_rule == GLOBAL) OR (side_of_rule == FB))
                   {
                     if(ProcessExternalFunction (CurrentRule, TKNWORD, side_of_rule, in_not,in_or) != OK)
                       return(RESTART);
                    }
                  else
                     if(ProcessExternalFunction (CurrentRule, TKNWORD, RHS, in_not,in_or) != OK)
                       return(RESTART);
               ELSE
                  
                  if(AInstanceQueryFunction(TKNWORD) == YES)
                      if(!FindRhtParen())
                        return(RESTART);
                  if((side_of_rule != GLOBAL) && (side_of_rule != FB)){
                    if(FindBoundWords (RHS, in_not,in_or, NO,NO) != OK)
                      return(RESTART);}
                  else
                    if(FindBoundWords (side_of_rule, in_not,in_or, NO,NO) != OK)
                      return(RESTART);
               END_IF
               (*num_args) ++;
               break;
         case GLOBAL:
            (*num_args) ++;
            IF(FinfDefglobal(DefglobalHead,TKNWORD) == NULL)THEN
                sprintf(MsgBuf,"?%s is not defined \n",TKNWORD);
                ErrorMessage(ERROR,MsgBuf,NO);
                return(RESTART);
            ELSE
              (void)process_args (global_ptr->type,global_ptr->value, *num_args, current_ex_func);
            END_IF 
            break;
         case WORD:
            (*num_args) ++;
            (void)process_args (token, TKNWORD, *num_args, current_ex_func);
            break;
         case STRING:
         case INTEGER:
         case FLOAT:
         case INSTANCE:
            (*num_args) ++;
            (void)process_args (token, TKNWORD, *num_args, current_ex_func);
            break;
		    
         default:
            ErrorMessage (ERROR, "Unknown symbol found!");
            return(RESTART);
            break;
      DONE
      token       = GetToken (CurrentFile);
      IF(token == STOP) THEN
		 ErrorMessage(ERROR,"Expected a right parentheses but found EOF\n");
		 return(RESTART);
      END_IF
   END_WHILE

   IF ((CHECK_DEFRELS IS_ON) && (!error_found)) THEN
      def_ex_func = FindDefexternal (DefexternalHead, current_ex_func->name);
      IF (def_ex_func NEQ NULL) THEN
         IF ((*num_args < def_ex_func->min_arguments) OR
            (*num_args > def_ex_func->max_arguments)) THEN
            ErrorMessage (ERROR, "Number of arguments mismatch\n");
            sprintf (MsgBuf, "        -- expected between %d and %d --\n", 
                   def_ex_func->min_arguments, def_ex_func->max_arguments);
            SendMessage(MsgBuf,NO);
         END_IF
      ELSE
         sprintf (MsgBuf, 
           "External function <%.20s> used prior to its definition.", 
               current_ex_func->name);
         ErrorMessage (WARNING, MsgBuf);
      END_IF
   END_IF
   
}

/* ===================================================================
 *                       Process variables
 * ===================================================================
 */

/*
 * -------------------------------------------------------------
 *  NAME   :  ProcessLHSRetract () 
 *
 *  PURPOSE:  This function builds a list of variables that
 *            are bound on the LHS to a fact.
 *
 *  INPUTS :  A pointer to the current rule (RULE *).
 *
 *  RETURNS:  An integer, OK if everything is kosher, else
 *            it returns ERROR.
 *
 *  NOTES  :
 * -------------------------------------------------------------
 */

/*ARGSUSED*/ /* Make lint happy */
static int ProcessLHSRetract (current_rule, inside_or) 
RULE_PTR current_rule;
int      inside_or;
{
   int      token;
   VAR_PTR  temp_var;
   char     *store_wrd;

   store_wrd = TKNWORD;

   /*=========================================*/
   /*  Make sure this really is a retraction! */
   /*=========================================*/

   token = GetToken (CurrentFile);
   IF (token NEQ BINDER) THEN
      ErrorMessage(ERROR,"Expected '<-' right after variable \n");
      return (RESTART);
   END_IF

   token = GetToken (CurrentFile);
   IF (token NEQ LPAREN) THEN
      ErrorMessage(ERROR,"Expected a '(' following '<-'\n");
      return (RESTART);
   END_IF

   /*===============================================*/
   /*  Syntactically correct retraction, now make   */
   /*  sure variable isn't bound to a regular value */
   /*===============================================*/

   IF ((temp_var = FindVariable (store_wrd, VariableHead)) NEQ NULL) THEN
      sprintf (MsgBuf, "Variable <%.50s> bound to both a fact and a value.", 
         store_wrd);
      ErrorMessage (ERROR, MsgBuf);

   ELSE_IF ((temp_var = FindVariable (store_wrd, RetractHead)) NEQ NULL) 
      IF (NOT inside_or) THEN
         sprintf (MsgBuf, "Duplicate fact address ?%s used", 
            store_wrd);
         ErrorMessage (ERROR, MsgBuf);
      END_IF
   ELSE

      /*==============================*/
      /*  Put Variable name on stack  */
      /*==============================*/

      temp_var                  = AllocVariable ();
      temp_var->var             = store_wrd;
      temp_var->level_retracted = NOT_RETRACTED;

      /*===================================*/
      /*  Set values in new retract object */
      /*===================================*/

      temp_var->next_variable      = RetractHead;
      temp_var->prev_variable      = NULL;

      IF (RetractHead NEQ NULL) THEN
         RetractHead->prev_variable = temp_var;
      END_IF

      RetractHead                = temp_var;

   END_IF

   return (OK);
}

/* ==================================================================== */

/*
 * -------------------------------------------------------------
 *  NAME   :  ProcessRHSRetract () 
 *
 *  PURPOSE:  This function is called when a retract/modify
 *            statement is found on the RHS of a rule. It checks
 *            all the variables and gives any necessary warnings.
 *
 *  INPUTS :  A pointer to the current rule (RULE *). A flag
 *            indicating if the retract is an explicit statement
 *            or implied by a modify statement.
 *
 *  RETURNS:  An integer, OK if the statement was processed without
 *            problems, ERROR if a syntax error is found.
 *
 *  NOTES  :
 * -------------------------------------------------------------
 */

static int ProcessRHSRetract (current_rule, implied) 
RULE_PTR current_rule;
int implied;
{
   int      rtn = OK;
   int      token;
   VAR_PTR  temp_rl;
   RR_PTR   temp_rr;
   int      prev_retract;
   char*    Statement = implied IS_YES ? "Modify" : "Retract";
   char*    statement = implied IS_YES ? "modify" : "retract";
   char*    valid_retract_spec = implied IS_YES ? "inside modify" :
      "or number inside retract";

   IF (InsideWhile () IS_YES) THEN
      IF (InsideIf () IS_YES) THEN
         sprintf (MsgBuf, "%s inside both a while and an if.", Statement);
         ErrorMessage (WARNING, MsgBuf);
      ELSE
         sprintf (MsgBuf, "%s inside a while", Statement);
         ErrorMessage (ERROR, MsgBuf);
      END_IF;
   END_IF

   token = GetToken (CurrentFile);
   if(token == RPAREN)
    {
       ErrorMessage(ERROR,"At least one fact must be retracted/modified\n");
       return(RESTART);
    }
   while (token NEQ RPAREN) DO

      IF (token EQ INTEGER) THEN
         IF (implied) THEN
            ErrorMessage ( WARNING, 
               "Modifying a fact specified by its index number.");
            return(RESTART);
         ELSE
            ErrorMessage (WARNING, 
                  "Retracting a fact by using the index number.");
         END_IF
      ELSE_IF (token NEQ BWORD) 
         sprintf (MsgBuf, "Expecting a variable %s.", valid_retract_spec);
         ErrorMessage (ERROR, MsgBuf);
         return(RESTART);
      ELSE
         temp_rl = FindVariable (TKNWORD, RetractHead);


         /*===================================================*/
         /*  If retraction variable is found, check relation  */
         /*===================================================*/

         IF (temp_rl NEQ NULL) THEN

            /*========================================================*/
            /*  Make sure that no invalid multiple retractions occur  */
            /*========================================================*/

            IF (temp_rl->level_retracted EQ NOT_RETRACTED) THEN
               prev_retract = NOT_RETRACTED;
            ELSE

               /*==================================================*/
               /*  If multiple retraction, classify it by testing  */
               /*  nested-if levels.                               */
               /*==================================================*/

               prev_retract = DescribePrevious (temp_rl);
            END_IF

            SWITCH (prev_retract) DO

               /*====================*/
               /*  ERROR Conditions  */
               /*====================*/

               case OUTSIDE_IF:
               case SUPERLEVEL:
               case SAME:

                  sprintf (MsgBuf, 
                     "Multiple retraction/modification of variable %.40s.", 
                     TKNWORD);
                  ErrorMessage (ERROR, MsgBuf);
                  return(RESTART);
               break;

               /*======================*/
               /*  WARNING Conditions  */
               /*======================*/

               case SUBLEVEL:
               case SEPARATE:
               case COMPANION_IF:

                  IF (prev_retract EQ COMPANION_IF) THEN
                     sprintf (MsgBuf, 
                        "Variable <%.40s> %s", 
                        TKNWORD, "retracted/modified in both if and else.");
                  ELSE
                     sprintf (MsgBuf, 
                        "%s of variable %.40s", 
                        "Possible multiple retraction/modication.", TKNWORD);
                  END_IF
                  ErrorMessage (WARNING, MsgBuf);

                  /* the break was intentionally left off here */

               /*=================*/
               /*  OK Conditions  */
               /*=================*/

               case NOT_RETRACTED:
               case OK_RETRACT:

                  /*==================================================*/
                  /*  If relation was found, store rule name in list  */
                  /*==================================================*/

                  IF (temp_rl->relation NEQ NULL) THEN
                     temp_rr              = AllocRuleRelation ();
                     temp_rr->rule        = current_rule;
                     temp_rr->next_rr     = temp_rl->relation->retract_list;
                     temp_rl->relation->retract_list = temp_rr;
                  END_IF

                  /*========================================*/
                  /*  And mark retract object as retracted  */
                  /*========================================*/

                  MarkRetraction (temp_rl);
               break;

               default:
               break;
            END_SWITCH

         /*===================================================*/
         /*  Error if variable wasn't found in retract list  */
         /*===================================================*/

         ELSE
            sprintf (MsgBuf, 
            "Function %s expected argument  #1 to be of type non-negative or variable\n", statement);
            ErrorMessage (ERROR, MsgBuf);
            return(RESTART);
         END_IF

      END_IF

      token = GetToken (CurrentFile);
   END_WHILE

   return (rtn);
}

/* ==================================================================== */

/*
 * -------------------------------------------------------------
 *  NAME   :  ProcessRHSModify () 
 *
 *  PURPOSE:  This function is called when a modify statement
 *            is found on the RHS of a rule. It checks all the
 *            variables and gives any necessary warnings.
 *
 *  INPUTS :  A pointer to the current rule (RULE *).
 *
 *  RETURNS:  An integer, OK if the statement was processed without
 *            problems, ERROR if a syntax error is found.
 *
 *  NOTES  :
 * -------------------------------------------------------------
 */

static int ProcessRHSModify (current_rule) 
   RULE_PTR current_rule;
{
   TK_PTR tknstruct = GetTokenPtr (CurrentFile);
   char *variable_name = tknstruct->tknword;
   TK_PTR right_paren = AllocToken ();
   int rtn;


   IF(tknstruct->token != BWORD)THEN
        ErrorMessage(ERROR,"Expect a variable in modify form\n");
        return(RESTART);
    END_IF
   /*=====================================*/
   /* Construct a right parenthesis token */
   /*=====================================*/

   right_paren->token = RPAREN;
   right_paren->tknword = ") ";

   /*===================================================================*/
   /* Place the retraction spec. followed by the right parenthesis back */
   /* onto the input queue.                                             */
   /*===================================================================*/

   UnGetTokenPtr (tknstruct);
   UnGetTokenPtr (right_paren);

   /*==============================*/
   /* Process the retraction spec. */
   /*==============================*/

   IF ((rtn = ProcessRHSRetract (current_rule, YES)) IS_OK) THEN
      /*===================================================*/
      /* Convert the retraction spec. into a template name */
      /*===================================================*/

      VAR_PTR retraction_spec = FindVariable (variable_name, RetractHead);
      char *template_name = retraction_spec->relation->name;

      IF (FindDeftemplate (DeftemplateHead, template_name)) THEN
         /*===============================================================*/
         /* Construct tokens for the template name and a left parenthesis */
         /*===============================================================*/

         TK_PTR left_paren = AllocToken ();
         TK_PTR template = AllocToken ();

         left_paren->token = LPAREN;
         left_paren->tknword = "(";

         template->tknword = template_name;
         template->token = WORD;
         template->hashword = AddSymbol (template_name);
         template->print_rep = template_name;

         /*=============================================================*/
         /* Place left parenthesis and template name on the input queue */
         /*=============================================================*/

         UnGetTokenPtr (left_paren);
         UnGetTokenPtr (template);

         /*==========================================*/
         /* Process the rest of the modify statement */
         /*==========================================*/

         rtn = process_assert (current_rule, MODIFY);
     ELSE
         /*=================================================*/
         /* Process the modification of a standard relation */
         /*=================================================*/
         ErrorMessage (ERROR, 
            "The modify statement can not modify relations.");
         return(RESTART);
      END_IF
   ELSE
      /*===========================*/
      /* Skip the modify statement */
      /*===========================*/

      if(FindRhtParen () != OK)
        return(RESTART);
   END_IF

   return (rtn);
}

/*
 * -------------------------------------------------------------
 *  NAME   :  process_RHS_duplicate ()  
 *
 *  PURPOSE:  This function is called when a duplicate statement
 *            is found on the RHS of a rule. It checks all the
 *            variables and gives any necessary warnings.
 *
 *  INPUTS :  A pointer to the current rule (RULE *).
 *
 *  RETURNS:  An integer, OK if the statement was processed without
 *            problems, ERROR if a syntax error is found.
 *
 *  NOTES  :
 * -------------------------------------------------------------
 */

static int process_RHS_duplicate (current_rule) 
   RULE_PTR current_rule;
{
   TK_PTR tknstruct = GetTokenPtr (CurrentFile);
   char *variable_name = tknstruct->tknword;
   VAR_PTR duplicate_spec = FindVariable (variable_name, RetractHead);
   char *template_name;
   int rtn;

   IF(tknstruct->token != BWORD)THEN
       ErrorMessage(ERROR,"Expect a variable in a duplicate form\n");
       return(RESTART);
    END_IF
    IF(duplicate_spec == NULL)THEN
       ErrorMessage(ERROR,"Attempt to duplicate an unbound variable\n");
       return(RESTART);
    ELSE
      template_name = duplicate_spec->relation->name;
    END_IF

      IF (FindDeftemplate (DeftemplateHead, template_name)) THEN
         /*===============================================================*/
         /* Construct tokens for the template name and a left parenthesis */
         /*===============================================================*/

         TK_PTR left_paren = AllocToken ();
         TK_PTR template = AllocToken ();

         left_paren->token = LPAREN;
         left_paren->tknword = "(";

         template->tknword = template_name;
         template->token = WORD;
         template->hashword = AddSymbol (template_name);
         template->print_rep = template_name;

         /*=============================================================*/
         /* Place left parenthesis and template name on the input queue */
         /*=============================================================*/

         UnGetTokenPtr (left_paren);
         UnGetTokenPtr (template);

         /*=============================================*/
         /* Process the rest of the duplicate statement */
         /*=============================================*/
         MarkRetraction(duplicate_spec);
         if(process_assert (current_rule, DUPLICATE) == RESTART)
           return(RESTART);
      ELSE
         ErrorMessage(ERROR,"The duplicate statement can not duplicate relations.\n");
         return(RESTART);
      END_IF

   return (OK);
}


/* ===================================================================
 * ===========       Relation Processing Functions       =============
 * ===================================================================
 */

/*
 * -------------------------------------------------------------
 *  NAME   :  find_simple_relation () 
 *
 *  PURPOSE:  This function is called when looking for the
 *            relation name in a deffacts or an assert, i.e.
 *            places where I expect to find only 'simple'
 *            pattern constructs. Once the relation is found, 
 *            it calls functions which do the right thing with
 *            the rest of the pattern.
 *
 *  INPUTS :  A flag telling if function was called from inside
 *            an ASSERT or a DEFFACTS (int).
 *
 *  RETURNS:  An integer, OK if relation was found and processed
 *            without problems, ERROR if an incorrect or invalid
 *            item is found.
 *
 *  NOTES  :  Should consider if RESTART is necessary anywhere.
 * -------------------------------------------------------------
 */

static int find_simple_relation (type) 
int type;
{
   int  token;
   int  rtn = OK;
   VAR_PTR temp_var;

   token = GetToken (CurrentFile);

   /*==============================*/
   /* Check for illegal constructs */
   /*==============================*/

   IF ((type EQ DEFFACTS) AND (token EQ WORD) AND ((strcmp (TKNWORD, "not") EQ 0) OR
                           (strcmp (TKNWORD, "or") EQ 0) OR
                           (strcmp (TKNWORD, "and") EQ 0) OR
                           (strcmp (TKNWORD, "test") EQ 0)) ) THEN
      sprintf (MsgBuf, "\'%.40s\' not allowed in a deffacts or assert.", 
         TKNWORD);
      ErrorMessage(ERROR,MsgBuf);
      return(RESTART);

   /*=============================*/
   /* Check for illegal variables */
   /*=============================*/

   ELSE_IF ((token EQ BWORD) OR (token EQ BWORDS) OR (token EQ SINGLE) OR
           (token EQ MULTIPLE)) 
      IF (type EQ DEFFACTS) THEN
         ErrorMessage (ERROR, 
                       "Variables cannot be accessed by deffacts construct");
         return(RESTART);
      ELSE_IF (type EQ ASSERT)
         if((temp_var = FindVariable(TKNWORD,VariableHead)) == NULL)
           {
             sprintf(MsgBuf,"Undefined variable %s referenced on the RHS of the rule\n",TKNWORD);
             ErrorMessage(ERROR,MsgBuf);
             return(RESTART);
           }
         ErrorMessage (WARNING, 
                    "Variable used as the first field in an assert.");
      END_IF
      
   /*========================*/
   /* Check for legal tokens */
   /*========================*/

   ELSE_IF ((token EQ WORD) OR (token EQ STRING) OR (token EQ INTEGER)
            OR (token EQ FLOAT) OR (token EQ INSTANCE)) 
      return(OK);
   /*====================================*/
   /* Otherwise this is an unknown token */
   /*====================================*/

   ELSE_IF (token EQ RPAREN)
      ErrorMessage(ERROR,"RHS pattern must contain at least one field\n");
      return(RESTART);
   ELSE
      ErrorMessage (ERROR, 
                "Unexpected item found, expecting one of the primitive types");
      return(RESTART);
   END_IF
   return (rtn);
}

/* ==================================================================== */

/*
 * -------------------------------------------------------------
 *  NAME   :  RuleFindRelation () 
 *
 *  PURPOSE:  This function is called when looking for the
 *            relation name in a rule. Once the relation is found, 
 *            it calls functions which do the right thing with
 *            the rest of the pattern.
 *
 *  INPUTS :  Three arguments, 
 *             A pointer to the current rule (RULE_PTR), 
 *             A flag telling if the pattern is bound to a
 *               variable for retraction (YES or NO) (int), and
 *             A flag telling if function was called from inside
 *               a not (YES or NO) (int).
 *
 *  RETURNS:  An integer, OK if processed OK, RESTART if
 *            it got confused.
 *
 *  NOTES  :  Should consider if RESTART is necessary anywhere.
 * -------------------------------------------------------------
 */

static int RuleFindRelation (current_rule, in_retract, in_not,in_or) 
int      in_retract, in_not, in_or;
RULE_PTR current_rule;
{
   int           token;
   int           rtn;
   MULT_REL_PTR  list = NULL;
   HASH         *temp_hash;
   

   list = NULL;
   token = GetToken (CurrentFile);
   
   /*=======================*/
   /*  Process a test case  */
   /*=======================*/

   IF ((token EQ WORD) AND (strcmp (TKNWORD, "test") EQ 0)) THEN
      if(current_rule->num_patterns == 0)
       {
         ErrorMessage(ERROR,"First CE in a rule may not be a test CE\n");
         return(RESTART);
       }
      token = GetToken (CurrentFile);
      IF (token NEQ LPAREN) THEN
         ErrorMessage (ERROR, "Check appropriate syntax for function call\n");
         return(RESTART);
      ELSE
         SaveToken (token, TKNWORD, FLOATNUMBER,INTNUMBER);
         if(FindBoundWords (RHS, NO, NO, NO,NO) == RESTART)
           return(RESTART);
         CurrentRule->num_patterns++;
      END_IF

   /*======================*/
   /*  Process a not case  */
   /*======================*/

   ELSE_IF ((token EQ WORD) AND (strcmp (TKNWORD, "not") EQ 0)) 

      /*============================*/
      /*  A not can't be retracted! */
      /*============================*/

      IF (in_retract IS_YES) THEN
         ErrorMessage (ERROR, "Can't retract a negated fact!");
         if(FindRhtParen () == RESTART)
           return(RESTART);
      ELSE_IF (in_not IS_YES) 
         ErrorMessage (ERROR, "Can't nest negated facts.");
         if(FindRhtParen () == RESTART)
           return(RESTART);
      ELSE

         /*==================================*/
         /*  Past not, now process relation  */
         /*==================================*/

         token = GetToken (CurrentFile);
         IF (token NEQ LPAREN) THEN
            ErrorMessage (ERROR, "Expect a pattern after not\n");
            return(RESTART);
         ELSE
            current_rule->num_nots++;
            if(RuleFindRelation (current_rule, NO, current_rule->num_nots,in_or) == RESTART)
              return(RESTART);
            token = GetToken(CurrentFile);
            if(token != RPAREN)
              {
                sprintf(MsgBuf,"Expected a right parenthesis but found %s\n",TKNWORD);
                ErrorMessage(ERROR,MsgBuf);
                return(RESTART);
              }
         END_IF
      END_IF

   /*======================*/
   /*  Process wildcards   */
   /*======================*/

   ELSE_IF ((token EQ SINGLE) OR (token EQ MULTIPLE)) 
      if(LHSPattern)
       CurrentTokenInPattern->num = 1;
      ErrorMessage (WARNING, 
         "Wildcard used in first field.");
      current_rule->num_patterns++;
      if(CheckMultipleRelation (&list, current_rule, in_not,in_or) != OK)
        return(RESTART);
      if (list == NULL) {
         if(FindBoundWords (LHS, in_not,in_or, YES,YES) != OK)
            return(RESTART);}
      else
         if(process_rule_relation (current_rule, list, in_retract, in_not,in_or) != OK)
           return(RESTART);

   /*======================*/
   /*  Process variables   */
   /*======================*/

   ELSE_IF ((token EQ BWORD) OR (token EQ BWORDS)) 
      if(LHSPattern)
       CurrentTokenInPattern->num = 1;
      sprintf (MsgBuf, "Variable <%.40s> was used in first field.", TKNWORD);
      ErrorMessage (WARNING, MsgBuf);
      current_rule->num_patterns++;
      if(ProcessLHSVariable (CurrentRule,NULL, NULL, token, 0, NO, in_not,in_or, 0, NO) != OK)
        return(RESTART);
      if(CheckMultipleRelation (&list, current_rule, in_not,in_or) != OK)
        return(RESTART);
      if (list == NULL) {
        if(FindBoundWords (LHS, in_not,in_or, YES,YES) != OK)
          return(RESTART);}
      else
        if(process_rule_relation (current_rule, list, in_retract, in_not,in_or) != OK)
          return(RESTART);

   /*=====================*/
   /*  Process 'or' case  */
   /*=====================*/

   ELSE_IF (strcmp (TKNWORD, "or") EQ 0) 
      token = GetToken (CurrentFile);
      if(token == RPAREN)
       {
         ErrorMessage(ERROR,"No patterns within or conditional element\n");
         return(RESTART);
       }
      while (token NEQ RPAREN) DO
         in_or++;
         IF (token EQ BWORD) THEN
            rtn = ProcessLHSRetract (current_rule, YES);
            IF (rtn EQ ERROR) THEN
               return (RESTART);
            END_IF
            if(RuleFindRelation (current_rule, YES, NO, in_or) != OK)
              return(RESTART);
         ELSE_IF (token NEQ LPAREN) 
            ErrorMessage (ERROR, "Check appropriate syntax for defrule\n");
            SendMessage("No patterns within or conditional element\n");
            return(RESTART);
         ELSE
            InitVarListInOrPattern(InOrVariableList,OFF);
            if(RuleFindRelation (current_rule, NO, NO,in_or) != OK)
              return(RESTART);
         END_IF
         token = GetToken (CurrentFile);
      END_WHILE
      InitVarListInOrPattern(InOrVariableList,TRUE);

   /*======================*/
   /*  Process 'and' case  */
   /*======================*/

   ELSE_IF (strcmp (TKNWORD, "and") EQ 0)
      if(in_not > 0)
        {
         ErrorMessage(ERROR,"Only a pattern may be used within a not conditional element\n");
         return(RESTART);
       }
      token = GetToken (CurrentFile);
      if(token == RPAREN)
       {
         ErrorMessage(ERROR,"No patterns within and conditional element\n");
         return(RESTART);
       }
      while (token NEQ RPAREN) DO
         IF (token EQ BWORD) THEN
            rtn = ProcessLHSRetract (current_rule, NO);
            IF (rtn EQ ERROR) THEN
               return (RESTART);
            END_IF
            if(RuleFindRelation (current_rule, YES, NO, in_or) != OK)
              return(RESTART);
         ELSE_IF (token NEQ LPAREN) 
            ErrorMessage (ERROR, "Check appropriate syntax for defrule\n");
            SendMessage("No patterns within and conditional element\n");
            return(RESTART);
         ELSE
            if(RuleFindRelation (current_rule, NO, NO, in_or) != OK)
              return(RESTART);
         END_IF
         token = GetToken (CurrentFile);
      END_WHILE

   /*====================================*/
   /*  Process a notted relation ~<rel>  */
   /*====================================*/

   ELSE_IF (token EQ LNOT) 
      token = GetToken (CurrentFile);
      if(LHSPattern)
       CurrentTokenInPattern->num = 1;
      IF ((token EQ WORD) OR (token EQ STRING) OR (token EQ INTEGER) 
          OR (token EQ FLOAT)) THEN
         list = AllocMultipleRelation ();
         (void) strcpy (list->rel_name, TKNWORD);
         if(process_rule_relation (current_rule, list, in_retract, in_not,in_or) == RESTART)
           return(RESTART);
      ELSE_IF ((token EQ BWORD) OR (token EQ BWORDS)) 
         ErrorMessage (WARNING, 
            "Variable used in first field");
         current_rule->num_patterns++;
         if(ProcessLHSVariable (CurrentRule,NULL, NULL, token, 0, NO, in_not,in_or, 0, YES) != OK)
           return(RESTART);
         if(CheckMultipleRelation (&list, current_rule, in_not,in_or) != OK)
           return(RESTART);
         if (list == NULL) {
          if(FindBoundWords (LHS, in_not,in_or,YES,YES) == RESTART)
            return(RESTART);}
         else
           if(process_rule_relation (current_rule, list, in_retract, in_not, in_or) == RESTART)
             return(RESTART);
      ELSE
         ErrorMessage (ERROR, "Check appropriate syntax for defrule");
         return(RESTART);
      END_IF

   /*===============================*/
   /*  Process a regular relation!  */
   /*===============================*/

   ELSE_IF ((token EQ WORD) OR (token EQ STRING) OR (token EQ INTEGER)
            OR (token EQ FLOAT) OR (token EQ INSTANCE))
     if(LHSPattern)
       CurrentTokenInPattern->num = 1;
     list = AllocMultipleRelation ();
     temp_hash = AddSymbol (TKNWORD);
     list->rel_name = temp_hash->contents;
     if(CheckMultipleRelation (&list, current_rule, in_not, in_or) != OK)
       return(RESTART);
     if(process_rule_relation (current_rule, list, in_retract, in_not, in_or) == RESTART)
             return(RESTART);
   /*==================================================*/
   /*  Don't know what this is, (shouldn't get here!)  */
   /*==================================================*/

   ELSE_IF(token EQ RPAREN)
    ErrorMessage(ERROR," A pattern must have one or more fields\n");
    return(RESTART);
   ELSE
      ErrorMessage (ERROR, "Unexpected item found, expecting a pattern.");
      return(RESTART);
   END_IF
   FreeMultipleRelation(list);
   return (OK);
}

/* ==================================================================== */

/*
 * -------------------------------------------------------------
 *  NAME   :  ProcessFBRelation () 
 *
 *  PURPOSE:  This function is called when a relation has been
 *            found in a deffacts block. It stores the appropriate
 *            information in the relations structure.
 *
 *  INPUTS :  A pointer to the current fact block (FACT_BLOCK *).
 *
 *  RETURNS:  Nothing
 *
 *  NOTES  :  Should be careful with memory out in alloc call!.
 * -------------------------------------------------------------
 */

static int ProcessFBRelation (cur_fb) 
FACT_BLOCK *cur_fb;
{
   char     *CurrentRelation_name;
   FBR_PTR   temp_fbr;
   short     is_template = NO;

   CurrentRelation_name  = TKNWORD;

   /*===============================*/
   /* Put relation in relation list */
   /*===============================*/
   
   IF (FindDeftemplate (DeftemplateHead, CurrentRelation_name)) THEN
      if(TemplateFormatToRelationFormat (CurrentRelation_name, YES,NULL) != OK)
        return(RESTART);
      is_template = YES;
   END_IF
   RelationHead = FindCreateRelation (RelationHead, CurrentRelation_name);

   /*============================*/
   /* Fill in relation structure */
   /*============================*/

   temp_fbr             = AllocFactBlockRelation ();
   
   if(find_fields (&(temp_fbr->num_fields),CurrentRelation,FB, NO,NO,NULL, NO) != OK)
    {
      FreeFactBlockRelation(temp_fbr);
      return(RESTART);
    }
   CurrentRelation->is_template = is_template;
   temp_fbr->fact_block = cur_fb;
   temp_fbr->next_fbr   = CurrentRelation->fb_list;
   IF (CHECK_DEFRELS IS_ON) THEN
      CheckMinNumOfFields (CurrentRelation->name, temp_fbr->num_fields, NO);
   END_IF

   CurrentRelation->fb_list     = temp_fbr;
   return(OK);
}

/* ==================================================================== */

/*
 * -------------------------------------------------------------
 *  NAME   :  FindCreateRelation () 
 *
 *  PURPOSE:  This function searches through a list of
 *            relations to find a specific name. If it doesn't
 *            find the name, it creates a new relation structure
 *            and adds it to the list.
 *
 *  INPUTS :  A pointer to the list of relations (RELATION *) 
 *            and a pointer to the name to search for (char *) 
 *
 *  RETURNS:  A pointer to the relation structure for the
 *            relation name
 *
 *  NOTES  :
 * ------------------------------------------------------------------
 */

static RELATION *FindCreateRelation (node, name) 
REL_PTR  node;
char    *name;
{
   int rtn;

   IF (node EQ NULL) THEN        /* A new relation! */
      node = AllocRelation ();
      node->name = name;
      CurrentRelation = node;
   ELSE
      rtn = strcmp (name, node->name);
      IF (rtn < 0) THEN
         node->lft_rel = FindCreateRelation (node->lft_rel, name);
      ELSE_IF (rtn > 0) 
         node->rht_rel = FindCreateRelation (node->rht_rel, name);
      ELSE
         CurrentRelation = node;
      END_IF
   END_IF
   return (node);
}

/* ==================================================================== */

/* ------------------------------------------------------------------
 *  NAME   : FindRelation () 
 *
 *  PURPOSE: This function searches through a list of
 *           relations to find a specific name.
 *
 *  INPUTS : A pointer to the list of relations (RELATION *) 
 *           and a pointer to the name to search for (char *) 
 *
 *  RETURNS: If the name is found, it returns a pointer to
 *           that structure. If it isn't found it returns NULL.
 *
 *  NOTES  : Primarily for calling by the CRSVDEFS functions.
 * ------------------------------------------------------------------
 */

RELATION *FindRelation (node, name) 
REL_PTR  node;
char    *name;
{
   int rtn;

   IF (node EQ NULL) THEN        /* A new relation! */
      return (NULL);
   ELSE
      rtn = strcmp (name, node->name);
      IF (rtn < 0) THEN
         return (FindRelation (node->lft_rel, name));
      ELSE_IF (rtn > 0) 
         return (FindRelation (node->rht_rel, name));
      ELSE
         return (node);
      END_IF
   END_IF
}


/* ==================================================================== */


/* ------------------------------------------------------------------
 *  NAME   : FindExternalFunction () 
 *
 *  PURPOSE: This function searches through a list of
 *           relations to find a specific name.
 *
 *  INPUTS : A pointer to the list of relations (RELATION *) 
 *           and a pointer to the name to search for (char *) 
 *
 *  RETURNS: If the name is found, it returns a pointer to
 *           that structure. If it isn't found it returns NULL.
 *
 *  NOTES  : Primarily for calling by the CRSVDEFS functions.
 * ------------------------------------------------------------------
 */

EX_FUNC *FindExternalFunction (node, name) 
EXF_PTR  node;
char    *name;
{
   int rtn;

   IF (node EQ NULL) THEN        /* A new external function! */
      return (NULL);
   ELSE
      rtn = strcmp (name, node->name);
      IF (rtn < 0) THEN
         return (FindCreateExternalFunction (node->lft_ex_func, name));
      ELSE_IF (rtn > 0) 
         return (FindCreateExternalFunction (node->rht_ex_func, name));
      ELSE
         return (node);
      END_IF
   END_IF
}

/* ==================================================================== */


/*
 * -------------------------------------------------------------
 *  NAME   :  process_rule_relation () 
 *
 *  PURPOSE:  This function is called when a relation has been
 *            found inside a rule. It stores the appropriate
 *            information in the relations structure.
 *
 *  INPUTS :  Three arguments, 
 *             A pointer to the current rule (RULE_PTR), 
 *             A flag telling if the pattern is bound to a
 *               variable for retraction (YES or NO) (int), and
 *             A flag telling if function was called from inside
 *               a not (YES or NO) (int).
 *
 *  RETURNS:  An integer, but currently doesn't return anything.
 *
 *  NOTES  :  Should be carefule with memory out in alloc call!.
 * -------------------------------------------------------------
 *                     Psuedo Code
 *
 *   Set current relation name
 *   Find relation structure pointer
 *   Allocate new Rule/Relation pointer
 *   Put Rule/Rel pointer into linked list
 *   process each field until closing paren is found
 * ------------------------------------------------------------
 */

static int process_rule_relation (current_rule, rel_list, in_retract, in_not,in_or) 
int      in_retract, in_not, in_or;
RULE_PTR current_rule;
MULT_REL_PTR rel_list;

{
   char          *CurrentRelation_name;
   RR_PTR        temp_rr;
   MULT_REL_PTR  temp;
   HASH *temp_hash;
   FIELD_PTR     var_list;
   int token;
   int num_template = 0, num_rel = 0;
   int is_deftmp = NO;
   short is_template = NO;
   register int count = 1;

   FOR (temp = rel_list;temp != NULL; temp = temp->next_rel) DO
       IF (FindDeftemplate (DeftemplateHead, temp->rel_name)) THEN
          num_template++;
       ELSE
          num_rel++;
       END_IF
   DONE

   IF (num_template NEQ 0) THEN
      IF (num_rel NEQ 0 OR num_template NEQ 1) THEN
         ErrorMessage (ERROR, 
            "Template names may not be used in a logical expression.");
         return(RESTART);
      ELSE
         var_list = NULL;
         is_deftmp = YES;
         if(TemplateFormatToRelationFormat (rel_list->rel_name, NO, &var_list) != OK)
           return(RESTART);
         is_template = YES;
      END_IF
   END_IF

   /* =================================================== */
   /* Store the fields of the relation (s) for latter      */
   /* processing. This is done because of the possibility */
   /* of multiple relations.                              */
   /* =================================================== */

   StoreTokenInRelation();
   
   /* Process each relation in the mutiple relation list */
   
   temp = rel_list;
   WHILE (temp != NULL) DO
      CurrentRelation_name = temp->rel_name;
      RelationHead = FindCreateRelation (RelationHead, CurrentRelation_name);
      current_rule->num_patterns++;
      temp_rr              = AllocRuleRelation ();
      if(find_fields (&(temp_rr->num_fields ),CurrentRelation, LHS, in_not,in_or, 
						var_list,is_deftmp) != OK)
		{
	      FreeRuleRelation(temp_rr);
	      FreeTokenInRelation();
	      return(RESTART);
	    }
	  temp_rr->rule        = current_rule;
	  temp_rr->next_rr     = CurrentRelation->rule_list;
      CurrentRelation->rule_list   = temp_rr;
      CurrentRelation->is_template = is_template;
      
      IF (CHECK_DEFRELS IS_ON) THEN
         CheckMinNumOfFields (CurrentRelation->name, temp_rr->num_fields, NO);
      END_IF

      IF (in_retract IS_YES) THEN
         RetractHead->relation = CurrentRelation;
      END_IF
      temp = temp->next_rel;
   DONE
   FreeTokenInRelation();
   return (OK);
}

/* ==================================================================== */


 /* -------------------------------------------------------------
 *  NAME   :  CheckMultipleRelation () 
 *
 *  PURPOSE:  This function is called after a relation or other
 *            first field info has been found. It checks to see
 *            if the relation is followed by an OR or an AND
 *            (& or |).
 *  INPUTS :  None.
 *
 *  RETURNS:  Nothing.
 *
 *  NOTES  : 
 * ------------------------------------------------------------
 */

static int CheckMultipleRelation (list, rule, in_not, in_or) 
MULT_REL_PTR *list;
RULE_PTR rule;
int in_not;
{
   int token;
   int exit_flag,func_rtn;
   int expect_lp;
   MULT_REL_PTR temp;
   HASH *temp_hash;

   /*======================*/
   /* Initialize variables */
   /*======================*/

   token       = GetToken (CurrentFile);
   expect_lp   = NO;
   exit_flag   = NO;

   IF ((token EQ LAND) OR (token EQ LOR)) THEN
      while (exit_flag IS_NO) DO
         token = GetToken (CurrentFile);
         switch (token) DO
            case BWORD:
            case BWORDS:
                 if(LHSPattern)
  		   			CurrentTokenInPattern->num = 1;
                 expect_lp = NO;
                 rule->num_patterns++;
                 (void)ProcessLHSVariable (CurrentRule,NULL, NULL, token,
                           0, NO, in_not,in_or,0, NO);
                 sprintf (MsgBuf, 
                    	"Variable <%.40s> was used in first field.", TKNWORD);
        		 ErrorMessage (WARNING, MsgBuf);
                 token     = GetToken (CurrentFile);
                 break;
            case STRING:
            case INSTANCE:
            case INTEGER:
            case FLOAT:
                 temp = AllocMultipleRelation ();
                 temp_hash = AddSymbol (TKNWORD);
                 temp->rel_name = temp_hash->contents;
                 temp->next_rel = *list;
                 *list = temp;
                 expect_lp = NO;
                 token     = GetToken (CurrentFile);
	             break;
            case WORD:
                 IF ((strcmp (TKNWORD, "=") EQ 0) OR
                    (strcmp (TKNWORD, ":") EQ 0)) THEN
                    expect_lp = YES;
                 ELSE
                    temp = AllocMultipleRelation ();
                    temp_hash = AddSymbol (TKNWORD);
                    temp->rel_name = temp_hash->contents;
                    temp->next_rel = *list;
                    *list = temp;
                    expect_lp = NO;
                    token     = GetToken (CurrentFile);
                 END_IF
                 break;

            case LPAREN:
                 IF (expect_lp NEQ YES) THEN
                    ErrorMessage (ERROR, 
                                  "Unexpected '(' in relation field.");
                    return(RESTART);
                 END_IF
                 token = GetToken(CurrentFile);
                 if(token != WORD){
                   ErrorMessage(ERROR,"A function name must be a SYMBOL\n");
                   return(RESTART);
                   }
                 IF (CheckExternalFuncs (TKNWORD,&func_rtn) IS_NO)THEN
                     if(ProcessExternalFunction (CurrentRule, TKNWORD, RHS,NO,NO) != OK)
                       return(RESTART);
                     CurrentRule->num_ex_funcs++;
                  ELSE
                     
                    if(AInstanceQueryFunction(TKNWORD) == YES)
                      if(!FindRhtParen())
                        return(RESTART);
                     if(FindBoundWords(RHS,NO,NO,NO,NO) != OK)
                         return(RESTART);
                  END_IF
                 token     = GetToken (CurrentFile);
                 break;

            case SINGLE:
            case MULTIPLE:
                 ErrorMessage (ERROR, "Invalid wildcard after '&' or '|'.");
                 return(RESTART);
            case LNOT:
                 token = GetToken(CurrentFile);
                 break;
            case LAND:
            case LOR:
                 ErrorMessage(ERROR,"Check appropriate syntax for defrule construct\n");
                 return(RESTART);
                 
         DONE

         IF (expect_lp EQ YES) THEN
            exit_flag = NO;
         ELSE_IF ((token EQ LAND) OR (token EQ LOR)) 
            exit_flag = NO;
         ELSE
            exit_flag = YES;
         END_IF

      END_WHILE
   END_IF

   SaveToken (token, TKNWORD, FLOATNUMBER,INTNUMBER);
   return (OK);
}

/* ===================================================================
 * =========       Field and Argument Processing Functions  ==========
 * ===================================================================
 */

/* ------------------------------------------------------------------
 * NAME   :     find_fields () 
 *
 * PURPOSE:     This function is called after a relation has been
 *              found and breaks out the remaining fields in the
 *              pattern. It counts the number of fields and stores
 *              literal values.
 *
 * INPUTS:      A pointer to the current relation structure, a
 *              flag to tell which side of the rule called it,
 *              a flag to tell if currently in a not, a list of variable 
 *              referenced if currently in a template,a flag to tell 
 *				if currently in an OR,and a flag to tell if currently 
 *				in a template
 *
 * RETURNS:     An integer, the number of fields in the pattern.
 *              If a $?var was found, the number of fields will
 *              be negative, so use the absolute value. If an
 *              error is found, it returns zero.
 *
 * ------------------------------------------------------------------
 *                       Pseudo Code
 *
 *   get token
 *   set field counter to 1 (for relation) 
 *   set new field flag to YES (again, for relation) 
 *   while the token is not a RPAREN and not STOP (EOF), do
 *      if the token is a variable or wildcard, then
 *         process the variable, increment field counter
 *      else if the token is an '&', or a '|', then
 *         ignore token, decrement field counter
 *      else if the token is an '=' (OPERATOR) then
 *         set expect LPAREN
 *      else if the token is a ':' (COAMP), then
 *         set expect LPAREN
 *      else if token is a LPAREN, then
 *         if expect LPAREN is on, then
 *            FindRhtParen
 *            increment field counter
 *         else
 *            PUNT, to next rule, error in code!
 *         end if
 *      else if the token is a '~', then
 *         turn on not_flag
 *         this is for generating an appropriate ErrorMessage later
 *      else if the token is a WORD, STRING or NUMBER, then
 *         increment field counter
 *         process field
 *		else if EOF 
 *         stop the process.
 *      else
 *         Error, don't know what this is
 *      end if
 *      get next token
 *   end while
 * ------------------------------------------------------------------
 */

static int find_fields (NumFields,current_rel, side_of_rule, in_not,in_or, 
				var_list, is_deftmp)
int *NumFields; 
REL_PTR current_rel;
FIELD_PTR var_list;
int     side_of_rule, in_not,in_or, is_deftmp;
{
   int   token,last_token;
   int   num_fields;
   int   func_rtn;
   short expect_lp,found_multi;
   short not_flag = NO,after_and = NO;      /* ON if variable is appended to a NOT (~) */
   DG_PTR global_ptr;

   /*======================*/
   /* Initialize variables */
   /*======================*/

   token   = GetToken (CurrentFile);
   num_fields  = 1;
   expect_lp   = NO;
   found_multi = NO;
   not_flag    = NO;

   while ((token NEQ RPAREN) && (token NEQ STOP)) DO
      switch (token) DO
         case SINGLE:
            num_fields++;
            if(ProcessSINGLEField(&after_and,side_of_rule,&expect_lp,num_fields) != OK)
              return(RESTART);
            break;

         case BWORD:
            num_fields++;
            if(ProcessBWORDField(&after_and,is_deftmp,&not_flag,in_not,
                              in_or,side_of_rule,num_fields,var_list,&expect_lp,
                              current_rel) != OK)
               return(RESTART);
            break;
         case MULTIPLE:
            num_fields++;
            if(ProcessMULTIPLEField(&after_and,&found_multi,&expect_lp,
                      side_of_rule,num_fields) != OK)
              return(RESTART);
            break;

         case BWORDS:
            num_fields++;
            if(ProcessBWORDSField(&after_and,&found_multi,&expect_lp,side_of_rule,
                           &not_flag,in_not,in_or,is_deftmp,num_fields,var_list,current_rel) != OK)
              return(RESTART);
            break;

         case LAND:
           /* */
             if(ProcessLANDField(in_not,in_or,&after_and,&expect_lp,&num_fields,
                         last_token,&token,var_list) != OK)
               return(RESTART);
	         break;
         case LOR:
            IF(last_token == LAND)THEN
              ErrorMessage(ERROR,"& is unexpected after |, syntax error! \n");
              return(RESTART);
            ELSE_IF (last_token == LOR)
              ErrorMessage(ERROR,"| is unexpected after another |, syntax error! \n");
              return(RESTART);
            ELSE
               num_fields--;
            END_IF
            expect_lp = NO;
            break;
         case LPAREN:
            if(ProcessLPARENField(side_of_rule,&expect_lp,&after_and,
                                 in_or,in_not,&func_rtn,&num_fields,
                                 current_rel,&token) != OK)
                 return(RESTART); 
            
            break;

         case LNOT:
            expect_lp = NO;
            not_flag  = YES;
            break;

         case WORD:
            IF ((strcmp (TKNWORD, "=") EQ 0) OR (strcmp (TKNWORD, ":") EQ 0)) THEN
               expect_lp = YES;
            ELSE
               num_fields++;
               if((LHSPattern IS_ON) && (!after_and)&&(CurrentTokenInPattern != NULL))
                  CurrentTokenInPattern->num = num_fields;
               else
                  after_and = NO;
               (void)process_field (token, TKNWORD, num_fields, current_rel);
               not_flag = NO;
            END_IF
            break;

          case GLOBAL:
             if(side_of_rule == LHS)
               {
                 ErrorMessage(ERROR,
                         "Global variables may not be used as a field in a pattern\n");
                 return(RESTART);
               }
             num_fields++;
             
         case STRING:
         case INTEGER:
         case FLOAT:
         case INSTANCE:
            num_fields++;
            if((LHSPattern IS_ON) && (!after_and)&&(CurrentTokenInPattern != NULL))
               CurrentTokenInPattern->num = num_fields;
            else
               after_and = NO;
            (void)process_field (token, TKNWORD, num_fields, current_rel);
            not_flag = NO;
            expect_lp = NO;
            break;

         default:
            ErrorMessage (ERROR, "Unknown symbol found!");
            return(ERROR);
            
      DONE
      last_token = token;
      token = GetToken (CurrentFile);
      if ( token == STOP){
        ErrorMessage(ERROR,"Unexpected end of file!");
        return(ERROR);
        }
   END_WHILE

   IF (found_multi IS_YES) THEN
      *NumFields = -num_fields;
   ELSE
      *NumFields = num_fields;
   END_IF
   return(OK);
}

/* ====================================================================
 *  Process ? in a field of a relation
 * ====================================================================
 */
 ProcessSINGLEField(after_and,side_of_rule,expect_lp,num_fields)
 short *after_and,*expect_lp;
 int side_of_rule;
 int num_fields;
 {
   if((LHSPattern IS_ON) && (!(*after_and)) && (CurrentTokenInPattern != NULL))
     CurrentTokenInPattern->num = num_fields;
   else
     *after_and = NO;
   *expect_lp = NO;
   IF (side_of_rule EQ RHS) THEN
     ErrorMessage (ERROR, "Wildcard used in an inappropriate place.");
     return(ERROR);
   ELSE_IF (side_of_rule EQ FB)
     ErrorMessage(ERROR,"Variables cannot be accessed by deffacts construct\n");
     return(ERROR);
   END_IF
   return(OK);
 }


/* ====================================================================
 *  Process ?<var> in a field of a relation
 * ====================================================================
 */
ProcessBWORDField(after_and,is_deftmp,not_flag,in_not,
                              in_or,side_of_rule,num_fields,var_list,expect_lp,current_rel)
short *after_and,*not_flag,*expect_lp;
int   in_not,in_or,side_of_rule,is_deftmp;
int num_fields;
FIELD_PTR var_list;
REL_PTR current_rel;
{
   if((LHSPattern IS_ON) && (!after_and)&&(CurrentTokenInPattern != NULL))
       CurrentTokenInPattern->num = num_fields;
   else
       *after_and = NO;
   *expect_lp = NO;
   IF (side_of_rule EQ LHS) THEN
     if ((is_deftmp) && (*not_flag))
        *not_flag = FindVariableInList(var_list,TKNWORD);
     if(ProcessLHSVariable (CurrentRule,current_rel, NULL, BWORD, num_fields, 
          NO, in_not,in_or,REL, *not_flag) != OK)
        return(RESTART);
   ELSE_IF (side_of_rule EQ RHS) 
     if(ProcessRHSVariable (CurrentRelation,CurrentExtFunc,BWORD, num_fields, 
                in_not,in_or,
               	REL,var_list) != OK)
       return(RESTART);
   ELSE_IF (side_of_rule EQ FB)
       ErrorMessage(ERROR,"Variables cannot be accessed by a deffacts construct \n");
   END_IF
   *not_flag = NO;
   return(OK);

}

/* ====================================================================
 *  Process $? in a field of a relation
 * ====================================================================
 */
ProcessMULTIPLEField(after_and,found_multi,expect_lp,side_of_rule,num_fields)
short *after_and,*found_multi,*expect_lp;
int side_of_rule;
int num_fields;
{
  if((LHSPattern IS_ON) && (!(*after_and))&&(CurrentTokenInPattern != NULL))
    CurrentTokenInPattern->num = num_fields;
  else
    *after_and = NO;
 /* IF ((*found_multi IS_YES) AND (side_of_rule EQ LHS)) THEN
     ErrorMessage (WARNING, 
                  "Multiple $? variables used in a single pattern.");
  END_IF*/
  *found_multi = YES;
  *expect_lp = NO;
  IF (side_of_rule EQ RHS) THEN
     ErrorMessage (ERROR, "Wildcard used in an inappropriate place.");
     return(RESTART);
  ELSE_IF (side_of_rule EQ FB)
     ErrorMessage(ERROR,"Variables cannot be accessed by a deffacts construct \n");
     return(RESTART);
  END_IF
  return(OK);
}
/* ====================================================================
 *  Process $?<var> in a field of a relation
 * ====================================================================
 */

ProcessBWORDSField(after_and,found_multi,expect_lp,side_of_rule,
                           not_flag,in_not,in_or,is_deftmp,num_fields,
                           var_list,current_rel)
short *after_and,*found_multi,*expect_lp,*not_flag;
int side_of_rule,in_not,in_or,is_deftmp;
int num_fields;
FIELD_PTR var_list;
REL_PTR current_rel;
{
   if((LHSPattern IS_ON) && (!(*after_and))&&(CurrentTokenInPattern != NULL))
      CurrentTokenInPattern->num = num_fields;
   else
      *after_and = NO;
 /*  IF ((*found_multi IS_YES) AND (side_of_rule EQ LHS)) THEN
      ErrorMessage (WARNING, 
                   "Multiple $? variables used in a single pattern.");
   END_IF*/
   *found_multi = YES;
   *expect_lp = NO;
   IF (side_of_rule EQ LHS) THEN
     if ((is_deftmp) && (*not_flag))
        *not_flag = FindVariableInList(var_list,TKNWORD);
     if(ProcessLHSVariable (CurrentRule,current_rel, NULL, BWORDS, 0, NO, 
         in_not,in_or, REL, *not_flag) != OK)
         return(RESTART);
   ELSE_IF (side_of_rule EQ RHS) 
     if(ProcessRHSVariable (CurrentRelation,CurrentExtFunc,BWORDS, 0, in_not,in_or,
         REL,var_list) != OK)
         return(RESTART);
   ELSE_IF(side_of_rule EQ FB)
     ErrorMessage(ERROR,"Variables cannot be accessed by a deffacts construct \n");
        return(RESTART);
   END_IF
  *not_flag = NO;  
  return(OK);
}
/* ====================================================================
 * Process & in the a field of a relation
 * ====================================================================
 */
ProcessLANDField(in_not,in_or,after_and,expect_lp,num_fields,
                         last_token,token,var_list)
short *after_and,*expect_lp;
int in_or,in_not,*num_fields,*token,last_token;
FIELD_PTR var_list;     
{
  IF(last_token == LAND)THEN
    ErrorMessage(ERROR,"& is unexpected after another &, syntax error! \n");
    return(ERROR);
  ELSE_IF (last_token == LOR)
    ErrorMessage(ERROR,"| is unexpected after &, syntax error! \n");
    return(ERROR);
  ELSE_IF ((last_token == WORD) || (last_token == STRING) || 
           (last_token == INSTANCE) || (last_token == INTEGER) || 
           (last_token == FLOAT))
    *token = GetToken(CurrentFile);
    if ((*token == STRING) || 
      (*token == INSTANCE)||(*token == INTEGER)|| 
      (*token == FLOAT))
      ErrorMessage(WARNING,"\"&\" may not be appropriate\n");
    else if(*token == WORD)
     {
      if(strcmp(":",TKNWORD) == 0)
        {
          *expect_lp = TRUE;
           return(OK);
        }
      else
         ErrorMessage(WARNING,"\"&\" may not be appropriate\n");
     }            
    else if (*token == BWORDS)
       if(ProcessRHSVariable (CurrentRelation,CurrentExtFunc,BWORDS, 0, in_not,in_or,
                            REL,var_list) != OK)
       return(RESTART);
    else if (*token == BWORD)
       if(ProcessRHSVariable (CurrentRelation,CurrentExtFunc,BWORD, 0, in_not,in_or,
               		       REL,var_list) != OK)
         return(RESTART);
  ELSE
    *num_fields--;
    *after_and = YES;
  END_IF
  *expect_lp = NO;                       
 }
 /* ============================================================
  *
  * ============================================================
  */
 
 ProcessLPARENField(side_of_rule,expect_lp,after_and,
                    in_or,in_not,func_rtn,num_fields,current_rel,token)
 short *expect_lp,*after_and;
 int side_of_rule,in_or,in_not,*func_rtn;
 int *num_fields;
 REL_PTR current_rel;
 int *token;
 {
   IF (*expect_lp IS_YES) THEN
      *token   = GetToken (CurrentFile);
      (*num_fields)++;
      if((LHSPattern IS_ON) && (!(*after_and))&&(CurrentTokenInPattern != NULL))
         CurrentTokenInPattern->num = *num_fields;
      else
         *after_and = NO;
      IF (*token EQ WORD)THEN
        IF (CheckExternalFuncs (TKNWORD,func_rtn) IS_NO)THEN
          IF (CHECK_DEFRELS IS_ON) THEN
            checkExtFncRtnTypeWDefrel (current_rel->name, TKNWORD, *num_fields);
          END_IF
          IF(side_of_rule != FB)
            CurrentRule->num_ex_funcs++;
          if(ProcessExternalFunction (CurrentRule, TKNWORD, side_of_rule,in_not,in_or) != OK)
              return(RESTART);
        ELSE
          
          if(AInstanceQueryFunction(TKNWORD) == YES)
            if(!FindRhtParen())
              return(RESTART);
          IF (CHECK_DEFRELS IS_ON) THEN
                     checkIntFncRtnTypeWDefrel(current_rel->name, 
                                             TKNWORD,*func_rtn, *num_fields);
          END_IF
          IF(side_of_rule != FB)THEN
            if(FindBoundWords (RHS, in_not,in_or, NO,NO) != OK)
               return(RESTART);
          ELSE
            if(FindBoundWords(FB,in_not,in_or,NO,NO) != OK)
               return(RESTART);
          END_IF
        END_IF
      ELSE
        ErrorMessage(ERROR," A function name must be a SYMBOL\n");
        return(RESTART);
      END_IF
        *expect_lp = NO;
   ELSE
      switch(side_of_rule) 
      {
         case RHS:
            ErrorMessage (ERROR, 
                          "Bad argument for RHS pattern\n");
            break;
      case LHS:
            ErrorMessage (ERROR, 
                     "Bad argument for LHS pattern\n");
            break;
      case FB:
            ErrorMessage (ERROR, 
                    "Bad argument for FB pattern\n");
            break;
      }
               
      return (RESTART);
   END_IF
  return(OK);          
            
}
/* ====================================================================
 * FindVariableInList
 *   This funtion searches for the variable in the variable list
 * Arguments :
 *   list: List of variables
 * name: Variable
 * Return:
 *   YES if found
 *   NO  if not found
 * ==================================================================== 
 */
 
int FindVariableInList(list,name)
FIELD_PTR list;
char *name;
{
  FIELD_PTR temp;

    temp = list;
    while(temp != NULL)
      {
         if(strcmp (temp->word,name) == 0)
           break;
         temp = temp->next;
      }
    if((temp != NULL) && ( temp->num > 1))
       return(YES);
    else
       return(NO);
}

/* ---------------------------------------------------------------
 * NAME  :  process_field () 
 *
 * PUROSE:  This function is called after a literal value
 *          has been found in a field. It searches the
 *          list of words already used for that field in
 *          that relationship and store it appropriately.
 *          It may also call the appropriate functions for
 *          comparing to any defrelation values!
 *
 * INPUTS:  Four arguments:
 *
 *  int   type      -  The type of the literal value
 *  char *word      -  A pointer to the literal value
 *  int   num_field -  The number of the field word was found in
 *  REL_PTR current_rel -  A pointer to the current relation structure.
 *
 * RETURNS:     An integer, basically useless (always OK) 
 * ------------------------------------------------------------------
 *                          Pseudo Code
 *
 *   Find field pointer
 *   while word list pointer is not NULL, do
 *      compare word with word list element
 *      if they are the same word, then
 *         return
 *      end if
 *      set word list pointer to next element
 *   end while
 *   allocate new word list element
 *   put word in element
 *   put element at top of list
 *   hook list back up to field pointer in current relation
 * ---------------------------------------------------------------
 */

static int process_field (type, word, num_field, current_rel) 
REL_PTR  current_rel;
int      type, num_field;
char    *word;
{
   FLD_PTR   temp_fld;

   temp_fld = GetFieldPtr(num_field, current_rel);

   temp_fld->lit_values = AddToWordList (temp_fld->lit_values, word, type, 
      NO);

   /*========================*/
   /* Check Defrelation info */
   /*========================*/

   IF (CHECK_DEFRELS IS_ON) THEN
      CheckFieldInfo (current_rel->name, type, num_field, word);
   END_IF

   return (OK);
}

/* ==================================================================== */

/* -------------------------------------------------------
 *  NAME   :  GetFieldPtr() 
 *
 *  PURPOSE:  This function finds the field pointer
 *            associated with a field number. (e.g.
 *            the structure associated with the second
 *            field). If no structure was previously
 *            associated, one is created.
 *
 *  INPUTS:   Two arguments:
 *
 *    int     num     - Number of the field we want
 *    REL_PTR current_rel - Pointer to current relation structure
 *
 *  RETURNS:  A pointer to the proper field (FLD_PTR).
 * -------------------------------------------------------
 */

static FLD_PTR GetFieldPtr(num, current_rel) 
int num;
REL_PTR current_rel;
{
   FLD_PTR temp_fld;

   temp_fld = current_rel->field_list;
   while (temp_fld NEQ NULL) DO
      IF (num EQ temp_fld->field_num) THEN
         return (temp_fld);
      END_IF
      temp_fld = temp_fld->next_field;
   END_WHILE

   temp_fld             = AllocField ();
   temp_fld->field_num  = num;
   temp_fld->next_field = current_rel->field_list;
   current_rel->field_list  = temp_fld;

   return (temp_fld);
}


/* ------------------------------------------------------
 * process_args
 *   This function process the parameters that are passing 
 *   in the external function.
 * ------------------------------------------------------
 */

static int process_args (type, word, num_arg, node) 
int type;
char *word;
int num_arg;
EXF_PTR node;

{
   FLD_PTR   temp_arg;

   temp_arg = GetArgumentPtr (num_arg, node);

   temp_arg->lit_values = AddToWordList (temp_arg->lit_values, word, type, 
      NO);

   /*========================*/
   /* Check Defexternal info */
   /*========================*/

   IF (CHECK_DEFRELS IS_ON) THEN
      CheckArgumentInfo (node->name, type, num_arg, word);
   END_IF

   return (OK);
}

/* -------------------------------------------------------
 *  NAME   :  GetArgumentPtr () 
 *
 *  PURPOSE:  This function finds the argument pointer
 *            associated with an argument number. (e.g.
 *            the structure associated with the second
 *            argument). If no structure was previously
 *            associated, one is created.
 *
 *  INPUTS:   Two arguments:
 *
 *    int      num       - Number of the argument we want
 *    EX_FUNC *cur_ex    - Pointer to current external
 *                         function structure
 *
 *  RETURNS:  A pointer to the proper field (FLD_PTR).
 * -------------------------------------------------------
 */

static FLD_PTR GetArgumentPtr (num, cur_ex) 
int num;
EX_FUNC *cur_ex;
{
   FLD_PTR temp_arg;

   temp_arg = cur_ex->argument_list;
   while (temp_arg NEQ NULL) DO
      IF (num EQ temp_arg->field_num) THEN
         return (temp_arg);
      END_IF
      temp_arg = temp_arg->next_field;
   END_WHILE

   temp_arg               = AllocField ();
   temp_arg->field_num    = num;
   temp_arg->next_field   = cur_ex->argument_list;
   cur_ex->argument_list  = temp_arg;

   return (temp_arg);
}

/* =======================================================
 * checkExtFncRtnTypeWDefrel () 
 *    This funtion checks to see if the return type of an
 *    external function is compatible with the definition of
 *    a relation.  This is called when the return value of an
 *    external function is a field in a relation
 *
 * arguments:
 *    rel_name  : name of the relation which called the external function
 *    func_name : name of the external function
 *    position  : position of the external function in the relation
 * =======================================================
 */

static int checkExtFncRtnTypeWDefrel (rel_name, func_name, position) 
char *rel_name, *func_name;
int position;

{
   DR_PTR    def_rel;
   DE_PTR    def_ex;
   DEF_FLD  *field;

   def_rel = FindDefrelation (DefrelationHead, rel_name);
   if (def_rel != NULL) 
   {
      def_ex = FindDefexternal (DefexternalHead, func_name);
      if (def_ex != NULL) 
      {
         field = FindDeffield (position, def_rel->fields);
         if (field != NULL) 
         {
            if (( (def_ex->return_word IS_YES) &&   (field->allow_word IS_NO)) ||
               ((def_ex->return_string IS_YES) &&(field->allow_string IS_NO)) ||
               ((def_ex->return_integer IS_YES) && (field->allow_integer IS_NO)) ||
               ((def_ex->return_float IS_YES) && (field->allow_float IS_NO))) 
            {
               ErrorMessage (ERROR, 
                  "Incompatible type definition. Return type of external function.\n");
               sprintf (MsgBuf, 
                  "        <%.40s> is not allowed in position %d of relation <%s>.", 
                  func_name, position, rel_name);
               SendMessage(MsgBuf,NO);
            }
         } 				
      }
   }
}

/* ----------------------------------------------------------------
 *  checkIntFncRtnTypeWDefrel
 *  This funtion checks to see if the return type of an
 *    internal function is compatible with the definition of
 *    a relation.  This is called when the return value of an
 *    internal function is a field in a relation
 *
 * arguments:
 *    rel_name  : name of the relation which called the external function
 *    func_name : name of the external function
 *    rtn       : type of the return value
 *    position  : position of the external function in the relation
 * ----------------------------------------------------------------
 */
static int checkIntFncRtnTypeWDefrel (rel_name,func_name,rtn, position) 
char *rel_name,*func_name;
int rtn,position;

{
   DR_PTR    def_rel;
   DE_PTR    def_ex;
   DEF_FLD  *field;

   def_rel = FindDefrelation (DefrelationHead, rel_name);
   IF(def_rel != NULL) THEN
         field = FindDeffield (position, def_rel->fields);
         IF(field != NULL) THEN
            IF(((rtn == WORD) && (field->allow_word != TRUE))||
               ((rtn == STRING) && (field->allow_string != TRUE))||
               ((rtn == INTEGER) && (field->allow_integer != TRUE))||
               ((rtn == FLOAT) && (field->allow_float != TRUE))||
               ((rtn == INSTANCE) && (field->allow_instance != TRUE))||
               ((rtn == EXTERNAL_ADDRESS) && (field->allow_address != TRUE))||
               (rtn == VOID))THEN
                    ErrorMessage (ERROR, 
                      "Incompatible type definition. Return type of external function.\n");
                    sprintf (MsgBuf, 
                      "        <%.40s> is not allowed in position %d of relation <%s>.", 
                       func_name, position, rel_name);
                    SendMessage(MsgBuf,NO);
            END_IF
         END_IF 				
   END_IF
}
