   /*******************************************************/
   /*      "C" Language Integrated Production System      */
   /*                                                     */
   /*                  A Product Of The                   */
   /*             Software Technology Branch              */
   /*             NASA - Johnson Space Center             */
   /*                                                     */
   /*             CLIPS Version 5.10  07/17/91            */
   /*                                                     */
   /*                ANALYSIS HEADER FILE                 */
   /*******************************************************/

/*************************************************************/
/* Purpose:                                                  */
/*                                                           */
/* Principal Programmer(s):                                  */
/*      Gary D. Riley                                        */
/*                                                           */
/* Contributing Programmer(s):                               */
/*                                                           */
/* Revision History:                                         */
/*                                                           */
/*************************************************************/

#ifndef _H_analysis

#define _H_analysis

#include "expressn.h"
#include "reorder.h"

#ifdef LOCALE
#undef LOCALE
#endif
#ifdef _ANALYSIS_SOURCE_
#define LOCALE
#else
#define LOCALE extern
#endif

#if ANSI_COMPILER
   LOCALE BOOLEAN                        RuleAnalysis(struct node *);
   LOCALE VOID                           VariableAnalysis(struct node *);
   LOCALE BOOLEAN                        CheckVariables(struct node *);
   LOCALE struct expr                   *CheckExpression(struct expr *,int,int,int,int);
   LOCALE int                            LogicalAnalysis(struct node *);
#else
   LOCALE BOOLEAN                        RuleAnalysis();
   LOCALE VOID                           VariableAnalysis();
   LOCALE BOOLEAN                        CheckVariables();
   LOCALE struct expr                   *CheckExpression();
   LOCALE int                            LogicalAnalysis();
#endif

#endif






