   /*******************************************************/
   /*      "C" Language Integrated Production System      */
   /*                                                     */
   /*                  A Product Of The                   */
   /*             Software Technology Branch              */
   /*             NASA - Johnson Space Center             */
   /*                                                     */
   /*             CLIPS Version 5.10  07/17/91            */
   /*                                                     */
   /*                 BLOAD HEADER FILE                   */
   /*******************************************************/

/*************************************************************/
/* Purpose:                                                  */
/*                                                           */
/* Principal Programmer(s):                                  */
/*      Gary D. Riley                                        */
/*                                                           */
/* Contributing Programmer(s):                               */
/*                                                           */
/* Revision History:                                         */
/*                                                           */
/*************************************************************/

#ifndef _H_bload
#define _H_bload

struct BinaryFunction;

#include "expressn.h"
#include "symbol.h"

#ifdef LOCALE
#undef LOCALE
#endif
#ifdef _BLOAD_SOURCE_
#define LOCALE
#else
#define LOCALE extern
#endif

struct BinaryFunction
  {
   char *name;
   VOID (*func)(VOID_ARG);
   int priority;
   struct BinaryFunction *next;
  };

#define IncrementCount(ptr) (((struct symbolHashNode *) ptr)->count++)
#define DecrementCount(ptr) (((struct symbolHashNode *) ptr)->count--)

#define SymbolPointer(i) ((SYMBOL_HN *) (SymbolArray[(unsigned long) (i)]))
#define FloatPointer(i) ((FLOAT_HN *) (FloatArray[(unsigned long) (i)]))
#define IntegerPointer(i) ((INTEGER_HN *) (IntegerArray[(unsigned long) (i)]))
#define ExpressionPointer(i) ((struct expr *) (((long) (i) == -1L) ? NULL : \
                                   &ExpressionArray[(unsigned long) (i)]))
#define FunctionPointer(i) ((struct FunctionDefinition *) (((long) (i) == -1L) ? NULL : \
                                    FunctionArray[(long) (i)]))
                                   
#if ANSI_COMPILER  
   LOCALE VOID                    BloadCommand(void);
   LOCALE BOOLEAN                 Bload(char *);
   LOCALE BOOLEAN                 Bloaded(void);
   LOCALE VOID                    GenRead(VOID *,unsigned long);
   LOCALE VOID                    AddBeforeBloadFunction(char *,VOID (*)(void),int);
   LOCALE VOID                    AddAfterBloadFunction(char *,VOID (*)(void),int);
   LOCALE VOID                    AddBloadReadyFunction(char *,int (*)(void),int);
   LOCALE VOID                    AddClearBloadReadyFunction(char *,int (*)(void),int);
   LOCALE VOID                    AddAbortBloadFunction(char *,VOID (*)(void),int);
#else
   LOCALE VOID                    BloadCommand();
   LOCALE BOOLEAN                 Bload();
   LOCALE BOOLEAN                 Bloaded();
   LOCALE VOID                    GenRead();
   LOCALE VOID                    AddBeforeBloadFunction();
   LOCALE VOID                    AddAfterBloadFunction();
   LOCALE VOID                    AddBloadReadyFunction();
   LOCALE VOID                    AddClearBloadReadyFunction();
   LOCALE VOID                    AddAbortBloadFunction();
#endif

#ifndef _BLOAD_SOURCE_
   extern char                                  *BinaryPrefixID;
   extern char                                  *BinaryVersionID;
   extern struct expr HUGE_ADDR                 *ExpressionArray;
   extern struct symbolHashNode * HUGE_ADDR     *SymbolArray;
   extern struct floatHashNode * HUGE_ADDR      *FloatArray;
   extern struct integerHashNode * HUGE_ADDR    *IntegerArray;
   extern struct FunctionDefinition * HUGE_ADDR *FunctionArray;
#endif
   
#endif







