   /*******************************************************/
   /*      "C" Language Integrated Production System      */
   /*                                                     */
   /*                  A Product Of The                   */
   /*             Software Technology Branch              */
   /*             NASA - Johnson Space Center             */
   /*                                                     */
   /*             CLIPS Version 5.10  07/17/91            */
   /*                                                     */
   /*                 BSAVE HEADER FILE                   */
   /*******************************************************/

/*************************************************************/
/* Purpose:                                                  */
/*                                                           */
/* Principal Programmer(s):                                  */
/*      Gary D. Riley                                        */
/*                                                           */
/* Contributing Programmer(s):                               */
/*                                                           */
/* Revision History:                                         */
/*                                                           */
/*************************************************************/

#ifndef _H_bsave
#define _H_bsave

struct BinaryItem;

#ifndef _CLIPS_STDIO_
#define _CLIPS_STDIO_
#include <stdio.h>
#endif

#include "expressn.h"

#ifdef LOCALE
#undef LOCALE
#endif

#ifdef _BSAVE_SOURCE_
#define LOCALE
#else
#define LOCALE extern
#endif

struct BinaryItem
  {
   char *name; 
   VOID (*findFunction)(VOID_ARG);
   VOID (*bloadFunction)(VOID_ARG);
   VOID (*refreshFunction)(VOID_ARG);
   VOID (*clearFunction)(VOID_ARG);
#if ANSI_COMPILER
   VOID (*expressionFunction)(FILE *);
   VOID (*bsaveFunction)(FILE *);
#else
   VOID (*expressionFunction)();
   VOID (*bsaveFunction)();
#endif
   int priority;
   struct BinaryItem *next;
  };
  
  
#define CONSTRUCT_HEADER_SIZE 20
                                   
#if ANSI_COMPILER 
   LOCALE VOID                    BsaveCommand(void);
#if BLOAD_AND_BSAVE
   LOCALE BOOLEAN                 Bsave(char *);
   LOCALE VOID                    MarkNeededItems(struct expr *);
   LOCALE VOID                    BsaveExpression(struct expr *,FILE *);
   LOCALE VOID                    GenWrite(VOID *,unsigned long,FILE *);
#endif
   LOCALE BOOLEAN                 AddBinaryItem(char *,int,VOID (*)(void),
                                                VOID (*)(FILE *),VOID (*)(FILE *),
                                                VOID (*)(void),VOID (*)(void),
                                                VOID (*)(void));
#else
   LOCALE VOID                    BsaveCommand();
#if BLOAD_AND_BSAVE
   LOCALE BOOLEAN                 Bsave();
   LOCALE VOID                    MarkNeededItems();
   LOCALE VOID                    BsaveExpression();
   LOCALE VOID                    GenWrite();
#endif
   LOCALE BOOLEAN                 AddBinaryItem();
#endif

#ifndef _BSAVE_SOURCE_
   extern unsigned long int       ExpressionCount;
   extern struct BinaryItem      *ListOfBinaryItems;
#endif

#endif







