   /*******************************************************/
   /*      "C" Language Integrated Production System      */
   /*                                                     */
   /*                  A Product Of The                   */
   /*             Software Technology Branch              */
   /*             NASA - Johnson Space Center             */
   /*                                                     */
   /*             CLIPS Version 5.10  07/17/91            */
   /*                                                     */
   /*           CONSTRUCT COMPILER HEADER FILE            */
   /*******************************************************/

/*************************************************************/
/* Purpose:                                                  */
/*                                                           */
/* Principal Programmer(s):                                  */
/*      Gary D. Riley                                        */
/*                                                           */
/* Contributing Programmer(s):                               */
/*                                                           */
/* Revision History:                                         */
/*                                                           */
/*************************************************************/

#ifndef _H_conscomp
#define _H_conscomp

#if DEFFUNCTION_CONSTRUCT
#include "deffnctn.h"
#endif

#if DEFGENERIC_CONSTRUCT
#include "genrcfun.h"
#endif

#ifdef LOCALE
#undef LOCALE
#endif

#ifndef _CLIPS_STDIO_
#define _CLIPS_STDIO_
#include <stdio.h>
#endif

struct CodeGeneratorItem
  {
   char *name; 
   VOID (*beforeFunction)(VOID_ARG);
#if ANSI_COMPILER
   VOID (*initFunction)(FILE *,int,int);
   int (*generateFunction)(char *,int,FILE *,int,int);
#else
   VOID (*initFunction)();
   int (*generateFunction)();
#endif
   int priority;
   struct CodeGeneratorItem *next;
  };
  
#ifdef _CONSCOMP_SOURCE_
#define LOCALE
#else
#define LOCALE extern
#endif

#if ANSI_COMPILER  
   LOCALE FILE                    *NewCFile(char *,int,int);
   LOCALE int                      ExpressionToCode(FILE *,struct expr *);
   LOCALE VOID                     PrintSymbolReference(FILE *,SYMBOL_HN *);
   LOCALE VOID                     PrintFloatReference(FILE *,FLOAT_HN *);
   LOCALE VOID                     PrintIntegerReference(FILE *,INTEGER_HN *);
   LOCALE VOID                     PrintFunctionReference(FILE *,struct FunctionDefinition *);
#if DEFFUNCTION_CONSTRUCT
   LOCALE VOID                     PrintDeffunctionReference(FILE *,struct dfunc *);
#endif
#if DEFGENERIC_CONSTRUCT
   LOCALE VOID                     PrintGenericFunctionReference(FILE *,GENERIC_FUNC *);
#endif
   LOCALE BOOLEAN                  AddCodeGeneratorItem(char *,int,VOID (*)(void),
                                                        VOID (*)(FILE *,int,int),
                                                        int (*)(char *,int,FILE *,int,int));
#else
   LOCALE FILE                    *NewCFile();
   LOCALE int                      ExpressionToCode();
   LOCALE VOID                     PrintSymbolReference();
   LOCALE VOID                     PrintFloatReference();
   LOCALE VOID                     PrintIntegerReference();
   LOCALE VOID                     PrintFunctionReference();
#if DEFFUNCTION_CONSTRUCT
   LOCALE VOID                     PrintDeffunctionReference();
#endif
#if DEFGENERIC_CONSTRUCT
   LOCALE VOID                     PrintGenericFunctionReference();
#endif
   LOCALE BOOLEAN                  AddCodeGeneratorItem();
#endif 

#endif




