   /*******************************************************/
   /*      "C" Language Integrated Production System      */
   /*                                                     */
   /*                  A Product Of The                   */
   /*             Software Technology Branch              */
   /*             NASA - Johnson Space Center             */
   /*                                                     */
   /*             CLIPS Version 4.40  07/17/91            */
   /*                                                     */
   /*              DEFFUNCTION HEADER FILE                */
   /*******************************************************/

/*************************************************************/
/* Purpose:                                                  */
/*                                                           */
/* Principal Programmer(s):                                  */
/*      Brian L. Donnell                                     */
/*      Gary D. Riley                                        */
/*                                                           */
/* Contributing Programmer(s):                               */
/*                                                           */
/* Revision History:                                         */
/*                                                           */
/*************************************************************/

#ifndef _H_deffnctn
#define _H_deffnctn

struct dfunc;

#include "evaluatn.h"
#include "expressn.h"
#include "symbol.h"

#ifdef LOCALE
#undef LOCALE
#endif
#ifdef _DEFFNCTN_SOURCE_
#define LOCALE
#else
#define LOCALE extern
#endif


/***********************************************************************/
/* DFUNC STRUCTURE:  Stores information about a deffunction construct. */
/***********************************************************************/
struct dfunc
  {
   unsigned busy,executing;
   SYMBOL_HN *name;
   char *ppForm;
   EXPRESSION *code;
   int minNumberOfParameters,maxNumberOfParameters;
   long bsaveIndex;
   struct dfunc *prev,*next; 
  };

#if ANSI_COMPILER
LOCALE VOID                           InitializeDeffunctions(void);
LOCALE VOID                          *FindDeffunction(char *);
LOCALE VOID                          *FindDeffunctionBySymbol(SYMBOL_HN *);
LOCALE VOID                           CallDeffunction(struct dfunc *,
                                                      EXPRESSION *,DATA_OBJECT *);
LOCALE int                            DeleteDeffunction(VOID *);
LOCALE char                          *GetDeffunctionName(VOID *);
LOCALE VOID                          *GetNextDeffunction(VOID *);
LOCALE int                            IsDeffunctionDeletable(VOID *);
LOCALE VOID                           CmdUndeffunction(void);
LOCALE VOID                           DeffunctionGetBind(DATA_OBJECT *);
LOCALE VOID                           DFRtnUnknown(DATA_OBJECT *);
LOCALE VOID                           DFWildargs(DATA_OBJECT *);

#if DEBUGGING_FUNCTIONS
LOCALE VOID                           CmdListDeffunctions(void);
LOCALE VOID                           CmdPPDeffunction(void);
LOCALE char                          *GetDeffunctionPPForm(VOID *);
LOCALE VOID                           ListDeffunctions(void);
#endif

#if RUN_TIME
LOCALE VOID                           SetListOfDeffunctions(void *);
#endif

#else
LOCALE VOID                           InitializeDeffunctions();
LOCALE VOID                          *FindDeffunction();
LOCALE VOID                          *FindDeffunctionBySymbol();
LOCALE VOID                           CallDeffunction();
LOCALE int                            DeleteDeffunction();
LOCALE char                          *GetDeffunctionName();
LOCALE VOID                          *GetNextDeffunction();
LOCALE int                            IsDeffunctionDeletable();
LOCALE VOID                           CmdUndeffunction();
LOCALE VOID                           DeffunctionGetBind();
LOCALE VOID                           DFRtnUnknown();
LOCALE VOID                           DFWildargs();

#if DEBUGGING_FUNCTIONS
LOCALE VOID                           CmdListDeffunctions();
LOCALE VOID                           CmdPPDeffunction();
LOCALE char                          *GetDeffunctionPPForm();
LOCALE VOID                           ListDeffunctions();
#endif

#if RUN_TIME
LOCALE VOID                           SetListOfDeffunctions();
#endif
#endif

#if (BLOAD || BLOAD_ONLY || BLOAD_AND_BSAVE) && (! RUN_TIME)

#define DFPointer(i) ((((long) (i)) == -1L) ? NULL : \
                       (struct dfunc *) &deffunctionArray[(long) (i)])

#ifndef _DEFFNCTN_SOURCE_
extern struct dfunc HUGE_ADDR *deffunctionArray;
#endif


#endif

#endif






