   /*******************************************************/
   /*      "C" Language Integrated Production System      */
   /*                                                     */
   /*                  A Product Of The                   */
   /*             Software Technology Branch              */
   /*             NASA - Johnson Space Center             */
   /*                                                     */
   /*             CLIPS Version 5.10  07/17/91            */
   /*                                                     */
   /*                GENERATE HEADER FILE                 */
   /*******************************************************/

/*************************************************************/
/* Purpose:                                                  */
/*                                                           */
/* Principal Programmer(s):                                  */
/*      Gary D. Riley                                        */
/*                                                           */
/* Contributing Programmer(s):                               */
/*                                                           */
/* Revision History:                                         */
/*                                                           */
/*************************************************************/

#ifndef _H_generate

#define _H_generate

#include "expressn.h"

#ifdef LOCALE
#undef LOCALE
#endif

#ifdef _GENERATE_SOURCE_
#define LOCALE
#else
#define LOCALE extern
#endif

#if ANSI_COMPILER  
   LOCALE VOID                           InitGenModule(void);
   LOCALE struct expr                   *GenGetvar(int,int);
   LOCALE struct expr                   *GenGetfield(int);
   LOCALE struct expr                   *GenFourIntegers(int,int,int,int);
   LOCALE struct expr                   *GenTwoIntegers(int,int);
   LOCALE struct expr                   *GenAnd(void);
   LOCALE struct expr                   *GenOr(void);
   LOCALE struct expr                   *GenPNConstant(int,int,VOID *);
   LOCALE struct expr                   *GenJNConstant(int,int,VOID *,int,int);
   LOCALE struct expr                   *GenJNColon(int,struct expr *,int,int,int);
   LOCALE struct expr                   *GenPNColon(int,struct expr *,int,int);
   LOCALE struct expr                   *GenJNEq(int,struct expr *,int,int,int);
   LOCALE struct expr                   *GenPNEq(int,struct expr *,int,int);
   LOCALE VOID                           GetvarReplace(struct expr *,int,int,int);
   LOCALE VOID                           GetfieldReplace(struct expr *,int,int);
   LOCALE struct expr                   *GenConstant(int,VOID *);
   LOCALE struct expr                   *GenJNVariableComparison(int,VOID *,int,int,int);
   LOCALE struct expr                   *GenPNVariableComparison(int,VOID *,int,int);
   LOCALE struct expr                   *CombineExpressions(struct expr *,struct expr *);
   LOCALE VOID                          *GenGetvarValue(int,int);
#else
   LOCALE VOID                           InitGenModule();
   LOCALE struct expr                   *GenGetvar();
   LOCALE struct expr                   *GenGetfield();
   LOCALE struct expr                   *GenFourIntegers();
   LOCALE struct expr                   *GenTwoIntegers();
   LOCALE struct expr                   *GenAnd();
   LOCALE struct expr                   *GenOr();
   LOCALE struct expr                   *GenPNConstant();
   LOCALE struct expr                   *GenJNConstant();
   LOCALE struct expr                   *GenJNColon();
   LOCALE struct expr                   *GenPNColon();
   LOCALE struct expr                   *GenJNEq();
   LOCALE struct expr                   *GenPNEq();
   LOCALE VOID                           GetvarReplace();
   LOCALE VOID                           GetfieldReplace();
   LOCALE struct expr                   *GenConstant();
   LOCALE struct expr                   *GenJNVariableComparison();
   LOCALE struct expr                   *GenPNVariableComparison();
   LOCALE struct expr                   *CombineExpressions();
   LOCALE VOID                          *GenGetvarValue();
#endif 
   
#ifndef _GENERATE_SOURCE_
   extern VOID                          *PTR_NOP;
   extern VOID                          *PTR_CONSTANT;
   extern VOID                          *PTR_NOTCONSTANT;
   extern VOID                          *PTR_GET_FIELD;
   extern VOID                          *PTR_AND; 
   extern VOID                          *PTR_OR; 
   extern VOID                          *PTR_EQ;
   extern VOID                          *PTR_NEQ; 
   extern VOID                          *PTR_NOT;
   extern VOID                          *PTR_EQ_FIELD;
   extern VOID                          *PTR_NEQ_FIELD;
#endif

#endif






