   /*******************************************************/
   /*      "C" Language Integrated Production System      */
   /*                                                     */
   /*                  A Product Of The                   */
   /*             Software Technology Branch              */
   /*             NASA - Johnson Space Center             */
   /*                                                     */
   /*               CLIPS Version 5.10  07/17/91          */
   /*                                                     */
   /*                                                     */
   /*******************************************************/

/*************************************************************/
/* Purpose:                                                  */
/*                                                           */
/* Principal Programmer(s):                                  */
/*      Brian L. Donnell                                     */
/*                                                           */
/* Contributing Programmer(s):                               */
/*                                                           */
/* Revision History:                                         */
/*                                                           */
/*************************************************************/

#ifndef _H_genrccom
#define _H_genrccom

#include "evaluatn.h"

#ifdef LOCALE
#undef LOCALE
#endif

#ifdef _GENRCCOM_SOURCE_
#define LOCALE
#else
#define LOCALE extern
#endif

#if ANSI_COMPILER

LOCALE VOID SetupGenericFunctions(void);
LOCALE char *GetDefgenericName(VOID *);
LOCALE VOID *FindDefgeneric(char *);
LOCALE VOID *GetNextDefgeneric(VOID *);
LOCALE unsigned GetNextDefmethod(VOID *,unsigned);
LOCALE int IsDefgenericDeletable(VOID *);
LOCALE int IsDefmethodDeletable(VOID *,unsigned);
LOCALE VOID GetDefmethodDescription(char *,int,VOID *,unsigned);
LOCALE VOID CmdUndefgeneric(void);
LOCALE VOID CmdUndefmethod(void);
LOCALE VOID RtnGenericUnknown(DATA_OBJECT *); 
LOCALE VOID GetGenericWildargs(DATA_OBJECT *); 
LOCALE VOID GetGenericBind(DATA_OBJECT *);

LOCALE int DeleteDefgeneric(VOID *);
LOCALE int DeleteDefmethod(VOID *,unsigned);

#if ! OBJECT_SYSTEM
LOCALE VOID TypeOf(DATA_OBJECT *);
#endif

#if DEBUGGING_FUNCTIONS
LOCALE VOID PPDefgeneric(void);
LOCALE VOID CmdListDefgenerics(void);
LOCALE VOID PPDefmethod(void);
LOCALE VOID CmdListDefmethods(void);
LOCALE char *GetDefgenericPPForm(VOID *);
LOCALE char *GetDefmethodPPForm(VOID *,unsigned);
LOCALE VOID ListDefgenerics(void);
LOCALE VOID ListDefmethods(VOID *);
#endif

#else

LOCALE VOID SetupGenericFunctions();
LOCALE char *GetDefgenericName();
LOCALE VOID *FindDefgeneric();
LOCALE VOID *GetNextDefgeneric();
LOCALE unsigned GetNextDefmethod();
LOCALE int IsDefgenericDeletable();
LOCALE int IsDefmethodDeletable();
LOCALE VOID GetDefmethodDescription();
LOCALE VOID CmdUndefgeneric();
LOCALE VOID CmdUndefmethod();
LOCALE VOID RtnGenericUnknown(); 
LOCALE VOID GetGenericWildargs(); 
LOCALE VOID GetGenericBind();

LOCALE int DeleteDefgeneric();
LOCALE int DeleteDefmethod();

#if ! OBJECT_SYSTEM
LOCALE VOID TypeOf();
#endif

#if DEBUGGING_FUNCTIONS
LOCALE VOID PPDefgeneric();
LOCALE VOID CmdListDefgenerics();
LOCALE VOID PPDefmethod();
LOCALE VOID CmdListDefmethods();
LOCALE char *GetDefgenericPPForm();
LOCALE char *GetDefmethodPPForm();
LOCALE VOID ListDefgenerics();
LOCALE VOID ListDefmethods();
#endif

#endif

#endif





