   /*******************************************************/
   /*      "C" Language Integrated Production System      */
   /*                                                     */
   /*                  A Product Of The                   */
   /*             Software Technology Branch              */
   /*             NASA - Johnson Space Center             */
   /*                                                     */
   /*               CLIPS Version 5.10  07/17/91          */
   /*                                                     */
   /*                                                     */
   /*******************************************************/

/*************************************************************/
/* Purpose:                                                  */
/*                                                           */
/* Principal Programmer(s):                                  */
/*      Brian L. Donnell                                     */
/*                                                           */
/* Contributing Programmer(s):                               */
/*                                                           */
/* Revision History:                                         */
/*                                                           */
/*************************************************************/

#ifndef _H_msgcom
#define _H_msgcom

#include "object.h"

#ifdef LOCALE
#undef LOCALE
#endif

#ifdef _MSGCOM_SOURCE_
#define LOCALE
#else
#define LOCALE extern
#endif
   
#define INIT_STRING     "init"
#define DELETE_STRING   "delete"

#if ANSI_COMPILER
LOCALE VOID SetupMessageHandlers(void);
LOCALE char *GetDefmessageHandlerName(VOID *,unsigned);
LOCALE char *GetDefmessageHandlerType(VOID *,unsigned);
LOCALE unsigned GetNextDefmessageHandler(VOID *,unsigned);
LOCALE unsigned FindDefmessageHandler(VOID *,char *,char *);
LOCALE int IsDefmessageHandlerDeletable(VOID *,unsigned);
LOCALE VOID CmdUndefmessageHandler(void);
LOCALE VOID HandlerRtnUnknown(DATA_OBJECT *);
LOCALE VOID HandlerWildargs(DATA_OBJECT *);
LOCALE VOID HandlerGetBind(DATA_OBJECT *);
LOCALE VOID HandlerGetSlot(DATA_OBJECT *);
LOCALE int HandlerPutSlot(void);
LOCALE int HandlerReplaceSlot(void);
LOCALE int HandlerInsertSlot(void);
LOCALE int HandlerDeleteSlot(void);

#if (! BLOAD_ONLY) && (! RUN_TIME)
LOCALE VOID AddSystemHandlers(void);
LOCALE int CheckHandlerAgainstSlots(CLASS_TYPE *,SYMBOL_HN *,int);
#endif

LOCALE VOID GroupHandlerWildargs(DATA_OBJECT *,int);
LOCALE int DeleteDefmessageHandler(VOID *,unsigned);
LOCALE int WildDeleteHandler(VOID *,char *,char *);

#if DEBUGGING_FUNCTIONS
LOCALE VOID PPDefmessageHandler(void);
LOCALE VOID CmdListDefmessageHandlers(void);
LOCALE VOID PreviewMessageCmd(void);
LOCALE char *GetDefmessageHandlerPPForm(VOID *,unsigned);
LOCALE VOID ListDefmessageHandlers(VOID *,char *,char *);
LOCALE VOID PreviewMessage(VOID *,char *);
#endif

#else

LOCALE VOID SetupMessageHandlers();
LOCALE char *GetDefmessageHandlerName();
LOCALE char *GetDefmessageHandlerType();
LOCALE unsigned GetNextDefmessageHandler();
LOCALE unsigned FindDefmessageHandler();
LOCALE int IsDefmessageHandlerDeletable();
LOCALE VOID CmdUndefmessageHandler();
LOCALE VOID HandlerRtnUnknown();
LOCALE VOID HandlerWildargs();
LOCALE VOID HandlerGetBind();
LOCALE VOID HandlerGetSlot();
LOCALE int HandlerPutSlot();
LOCALE int HandlerReplaceSlot();
LOCALE int HandlerInsertSlot();
LOCALE int HandlerDeleteSlot();

#if (! BLOAD_ONLY) && (! RUN_TIME)
LOCALE VOID AddSystemHandlers();
LOCALE int CheckHandlerAgainstSlots();
#endif

LOCALE VOID GroupHandlerWildargs();
LOCALE int DeleteDefmessageHandler();
LOCALE int WildDeleteHandler();

#if DEBUGGING_FUNCTIONS
LOCALE VOID PPDefmessageHandler();
LOCALE VOID CmdListDefmessageHandlers();
LOCALE VOID PreviewMessageCmd();
LOCALE char *GetDefmessageHandlerPPForm();
LOCALE VOID ListDefmessageHandlers();
LOCALE VOID PreviewMessage();
#endif
#endif

#ifndef _MSGCOM_SOURCE_
extern SYMBOL_HN *INIT_SYMBOL,*DELETE_SYMBOL;
#endif

#endif





