   /*******************************************************/
   /*      "C" Language Integrated Production System      */
   /*                                                     */
   /*                  A Product Of The                   */
   /*             Software Technology Branch              */
   /*             NASA - Johnson Space Center             */
   /*                                                     */
   /*             CLIPS Version 5.10  07/17/91            */
   /*                                                     */
   /*               PARSER UTILITIES MODULE               */
   /*******************************************************/

/*************************************************************/
/* Purpose:                                                  */
/*                                                           */
/* Principal Programmer(s):                                  */
/*      Gary D. Riley                                        */
/*                                                           */
/* Contributing Programmer(s):                               */
/*                                                           */
/* Revision History:                                         */
/*                                                           */
/*************************************************************/

#ifndef _H_parsutil
#define _H_parsutil

#include "expressn.h"
#include "scanner.h"
#include "symbol.h"

#ifdef LOCALE
#undef LOCALE
#endif

#ifdef _PARSUTIL_SOURCE_
#define LOCALE
#else
#define LOCALE extern
#endif

#if ANSI_COMPILER
LOCALE BOOLEAN                        ReadUntilClosingParen(char *,struct token *);
LOCALE struct expr                   *GroupActions(char *,struct token *,int,char *);
LOCALE struct expr                   *CompactActions(struct expr *);
LOCALE struct expr                   *BuildRHSAssert(struct expr *,char *,int,int *);
LOCALE struct expr                   *GetAssertArgument(char *,struct token *,int *,int *,int,int,int *);
LOCALE struct expr                   *GetRHSPattern(char *,struct token *,int *,int *,int,int,int);
LOCALE struct symbolHashNode         *GetConstructNameAndComment(char *,
                                         struct token *,char *,void *(*)(char *),
                                         int (*)(void *),char *,int);
#else
LOCALE BOOLEAN                        ReadUntilClosingParen();
LOCALE struct expr                   *GroupActions();
LOCALE struct expr                   *CompactActions();
LOCALE struct expr                   *BuildRHSAssert();
LOCALE struct expr                   *GetAssertArgument();
LOCALE struct expr                   *GetRHSPattern();
LOCALE struct symbolHashNode         *GetConstructNameAndComment();
#endif

#endif



