   /*******************************************************/
   /*      "C" Language Integrated Production System      */
   /*                                                     */
   /*                  A Product Of The                   */
   /*             Software Technology Branch              */
   /*             NASA - Johnson Space Center             */
   /*                                                     */
   /*             CLIPS Version 5.10  07/17/91            */
   /*                                                     */
   /*                 REORDER HEADER FILE                 */
   /*******************************************************/

/*************************************************************/
/* Purpose:                                                  */
/*                                                           */
/* Principal Programmer(s):                                  */
/*      Gary D. Riley                                        */
/*                                                           */
/* Contributing Programmer(s):                               */
/*                                                           */
/* Revision History:                                         */
/*                                                           */
/*************************************************************/

#ifndef _H_reorder
#define _H_reorder

struct node;

#include "expressn.h"

#ifdef LOCALE
#undef LOCALE
#endif

#ifdef _REORDER_SOURCE_
#define LOCALE
#else
#define LOCALE extern
#endif

/****************************************************************/
/* NODE STRUCTURE:  Stores information about the intermediate   */  
/*   parsed representation of the lhs of a rule.                */
/****************************************************************/
struct node
  {
   int type;  
   VOID *value;                   
   unsigned int negated : 1;       
   unsigned int logical : 1;  
   struct expr *expression;      
   struct node *right;
   struct node *bottom;
  };
  
#if ANSI_COMPILER
LOCALE struct node                   *ReorderPatterns(struct node *);
LOCALE struct node                   *CopyNodes(struct node *);
LOCALE struct node                   *GetNode(void);
LOCALE VOID                           ReturnNodes(struct node *);
#else
LOCALE struct node                   *ReorderPatterns();
LOCALE struct node                   *CopyNodes();
LOCALE struct node                   *GetNode();
LOCALE VOID                           ReturnNodes();
#endif

#endif



 
  




