   /*******************************************************/
   /*      "C" Language Integrated Production System      */
   /*                                                     */
   /*                  A Product Of The                   */
   /*             Software Technology Branch              */
   /*             NASA - Johnson Space Center             */
   /*                                                     */
   /*             CLIPS Version 5.10  07/17/91            */
   /*                                                     */
   /*              SPECIAL FORM HEADER FILE               */
   /*******************************************************/

/*************************************************************/
/* Purpose:                                                  */
/*                                                           */
/* Principal Programmer(s):                                  */
/*      Gary D. Riley                                        */
/*                                                           */
/* Contributing Programmer(s):                               */
/*                                                           */
/* Revision History:                                         */
/*                                                           */
/*************************************************************/

#ifndef _H_spclform
#define _H_spclform

struct BindInfo;

#include "symbol.h"

#ifdef LOCALE
#undef LOCALE
#endif

#ifdef _SPCLFORM_SOURCE_
#define LOCALE
#else
#define LOCALE extern
#endif

struct BindInfo
  {
   struct symbolHashNode *name;
   struct BindInfo *next;
  };

#if ANSI_COMPILER
LOCALE VOID                           InitializeSpecialForms(void);
LOCALE BOOLEAN                        SearchParsedBindNames(struct symbolHashNode *);
LOCALE struct BindInfo               *GetParsedBindNames(void);
LOCALE VOID                           SetParsedBindNames(struct BindInfo *);
LOCALE VOID                           ClearParsedBindNames(void);
LOCALE BOOLEAN                        ParsedBindNamesEmpty(void);
#else
LOCALE VOID                           InitializeSpecialForms();
LOCALE BOOLEAN                        SearchParsedBindNames();
LOCALE struct BindInfo               *GetParsedBindNames();
LOCALE VOID                           SetParsedBindNames();
LOCALE VOID                           ClearParsedBindNames();
LOCALE BOOLEAN                        ParsedBindNamesEmpty();
#endif

#endif




