   /*******************************************************/
   /*      "C" Language Integrated Production System      */
   /*                                                     */
   /*                  A Product Of The                   */
   /*             Software Technology Branch              */
   /*             NASA - Johnson Space Center             */
   /*                                                     */
   /*             CLIPS Version 5.10  07/17/91            */
   /*                                                     */
   /*                 UTILITY HEADER FILE                 */
   /*******************************************************/

/*************************************************************/
/* Purpose:                                                  */
/*                                                           */
/* Principal Programmer(s):                                  */
/*      Gary D. Riley                                        */
/*                                                           */
/* Contributing Programmer(s):                               */
/*                                                           */
/* Revision History:                                         */
/*                                                           */
/*************************************************************/

#ifndef _H_utility
#define _H_utility

#ifdef LOCALE
#undef LOCALE
#endif

#ifdef _UTILITY_SOURCE_
#define LOCALE
#else
#define LOCALE extern
#endif

#if ANSI_COMPILER  
LOCALE VOID                           PrintFloat(char *,double);
LOCALE VOID                           PrintLongInteger(char *,long);
LOCALE char                          *FloatToString(double);
LOCALE char                          *LongIntegerToString(long);
LOCALE char                          *AppendToString(char *,char *,int *,int *);
LOCALE char                          *AppendNToString(char *,char *,int,int *,int *);
LOCALE char                          *ExpandStringWithChar(int,char *,int *,int *,int);
LOCALE char                          *GetLogicalName(int,char *);
LOCALE char                          *GetFileName(char *,int);
LOCALE char                          *GetConstructName(int,int,char *,char *);
LOCALE VOID                           ExpectedTypeError(char *,int,char *);
LOCALE VOID                           SyntaxErrorMessage(char *);
LOCALE VOID                           ExpectedCountError(char *,int,int);
LOCALE VOID                           OpenErrorMessage(char *,char *);
LOCALE VOID                           CLIPSSystemError(char *,int);
LOCALE VOID                           PeriodicCleanup(BOOLEAN,BOOLEAN);
LOCALE VOID                           PrintAtom(char *,int,VOID *);
LOCALE VOID                           PrintTally(char *,long,char *,char *);
LOCALE BOOLEAN                        AddCleanupFunction(char *,VOID (*)(),int);
LOCALE BOOLEAN                        AddPeriodicFunction(char *,VOID (*)(),int);
LOCALE BOOLEAN                        RemoveCleanupFunction(char *);
LOCALE BOOLEAN                        RemovePeriodicFunction(char *);
LOCALE BOOLEAN                        SetWatchItem(char *,int);
LOCALE int                            GetWatchItem(char *);
LOCALE BOOLEAN                        AddWatchItem(char *,int *,int);
LOCALE BOOLEAN                        SetAllWatchItems(int);
LOCALE VOID                           RestoreAllWatchItems(void);
LOCALE VOID                           SetWatchDisplayFunction(int (*)());
LOCALE char                          *GetNthWatchName(int);
LOCALE int                            GetNthWatchValue(int);
LOCALE VOID                           AtomInstall(int,VOID *);
LOCALE VOID                           AtomDeinstall(int,VOID *);
LOCALE VOID                           PrintInChunks(char *,char *);
#else
LOCALE VOID                           PrintFloat();
LOCALE VOID                           PrintLongInteger();
LOCALE char                          *FloatToString();
LOCALE char                          *LongIntegerToString();
LOCALE char                          *AppendToString();
LOCALE char                          *AppendNToString();
LOCALE char                          *ExpandStringWithChar();
LOCALE char                          *GetLogicalName();
LOCALE char                          *GetFileName();
LOCALE char                          *GetConstructName();
LOCALE VOID                           ExpectedTypeError();
LOCALE VOID                           SyntaxErrorMessage();
LOCALE VOID                           ExpectedCountError();
LOCALE VOID                           OpenErrorMessage();
LOCALE VOID                           CLIPSSystemError();
LOCALE VOID                           PeriodicCleanup();
LOCALE VOID                           PrintAtom();
LOCALE VOID                           PrintTally();
LOCALE BOOLEAN                        AddCleanupFunction();
LOCALE BOOLEAN                        AddPeriodicFunction();
LOCALE BOOLEAN                        RemoveCleanupFunction();
LOCALE BOOLEAN                        RemovePeriodicFunction();
LOCALE BOOLEAN                        SetWatchItem();
LOCALE int                            GetWatchItem();
LOCALE BOOLEAN                        AddWatchItem();
LOCALE BOOLEAN                        SetAllWatchItems();
LOCALE VOID                           RestoreAllWatchItems();
LOCALE VOID                           SetWatchDisplayFunction();
LOCALE char                          *GetNthWatchName();
LOCALE int                            GetNthWatchValue();
LOCALE VOID                           AtomInstall();
LOCALE VOID                           AtomDeinstall();
LOCALE VOID                           PrintInChunks();
#endif 

#ifndef _UTILITY_SOURCE_
   extern BOOLEAN                 PreserveEscapedCharacters;
   extern BOOLEAN                 AddressesToStrings;
   extern unsigned long           EphemeralItemCount;
   extern unsigned long           EphemeralItemSize;
#endif

#endif




