   /*******************************************************/
   /*      "C" Language Integrated Production System      */
   /*                                                     */
   /*                  A Product Of The                   */
   /*             Software Technology Branch              */
   /*             NASA - Johnson Space Center             */
   /*                                                     */
   /*             CLIPS Version 5.10  07/17/91            */
   /*                                                     */
   /*                VARIABLE HEADER FILE                 */
   /*******************************************************/

/*************************************************************/
/* Purpose:                                                  */
/*                                                           */
/* Principal Programmer(s):                                  */
/*      Gary D. Riley                                        */
/*                                                           */
/* Contributing Programmer(s):                               */
/*                                                           */
/* Revision History:                                         */
/*                                                           */
/*************************************************************/

#ifndef _H_variable
#define _H_variable

struct pn_test;
struct field_tests;
struct expr_info;
struct pat_info;
struct var_info;

#include "expressn.h"
#include "symbol.h"

#ifdef LOCALE
#undef LOCALE
#endif

#ifdef _VARIABLE_SOURCE_
#define LOCALE
#else
#define LOCALE extern
#endif

struct pn_test
  {
   int element;
   int type;              /* Type of pattern: Single or Multiple */
   struct expr *pnt;      /* Test associated with pattern.       */
   struct pn_test *next;
  };
  
struct field_tests
  {
   struct expr *pnt;
   struct expr *jnt;
  };
  
struct expr_info
  {
   int pattern;
   int logic;
   struct expr *jnt;
   struct pn_test *pntl;
   struct expr *otest;
   struct expr_info *next;
  };

struct pat_info
  {
   int position;
   int logic;
   struct symbolHashNode *fact_address;
   struct symbolHashNode *relation;
   struct var_info *variables;
   struct pat_info *next;
  };
  
struct var_info
  {
   struct symbolHashNode *name;
   int pattern;
   int element;
   struct var_info *next;
  };
   

#if ANSI_COMPILER
LOCALE struct var_info               *FindVariable(struct symbolHashNode *,int,int,int,int);
LOCALE VOID                           FlushVariableAnalysis(void);
LOCALE int                            GetFactAddressPosition(struct symbolHashNode *);
LOCALE struct symbolHashNode         *GetRelationForPattern(int);
LOCALE BOOLEAN                        PatternHasTemplate(int);
LOCALE int                            CountJoins(void);
LOCALE char                           GetJoinLogic(int);
LOCALE struct expr                   *GetPrimaryJoinExpression(int);
LOCALE struct expr                   *GetNotJoinExpression(int);
LOCALE int                            GetNodeType(int,int);
LOCALE int                            CountPatternFields(int);
LOCALE struct expr                   *GetPatternExpression(int,int);
LOCALE VOID                           FlushAnalysisExpressions(void);
LOCALE int                            RuleComplexity(void);
LOCALE int                            ExpressionComplexity(struct expr *);
LOCALE VOID                           SetRuleInformation(struct expr_info *);
LOCALE VOID                           SetVariableInformation(struct pat_info *);
LOCALE struct pat_info               *GetVariableInformation(void);
#else
LOCALE struct var_info               *FindVariable();
LOCALE VOID                           FlushVariableAnalysis();
LOCALE int                            GetFactAddressPosition();
LOCALE struct symbolHashNode         *GetRelationForPattern();
LOCALE BOOLEAN                        PatternHasTemplate();
LOCALE int                            CountJoins();
LOCALE char                           GetJoinLogic();
LOCALE struct expr                   *GetPrimaryJoinExpression();
LOCALE struct expr                   *GetNotJoinExpression();
LOCALE int                            GetNodeType();
LOCALE int                            CountPatternFields();
LOCALE struct expr                   *GetPatternExpression();
LOCALE VOID                           FlushAnalysisExpressions();
LOCALE int                            RuleComplexity();
LOCALE int                            ExpressionComplexity();
LOCALE VOID                           SetRuleInformation();
LOCALE VOID                           SetVariableInformation();
LOCALE struct pat_info               *GetVariableInformation();
#endif

#endif




